unit UntAnnulla;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, DBCGrids, Menus, ExtCtrls, ToolWin, ComCtrls, StdCtrls, Mask,
  DBCtrls, dmServizi, db, jpeg, ShlIntf, ActiveX, ComObj, StrTools, dblookup, variants;

type
  TFrmAnnulla = class(TForm)
    btnSi: TButton;
    btnNo: TButton;
    Label1: TLabel;
    Label39: TLabel;
    Label12: TLabel;
    ERRORE: TDBLookupComboBox;
    CENTRALINO: TDBLookupComboBox;
    Label35: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    nserviz: TLabel;
    grpNote: TGroupBox;
    Note: TDBRichEdit;
    constructor CreateWithDM(AOwner: TComponent; d: TdmdServizi);
    procedure btnSiClick(Sender: TObject);
    procedure btnNoClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);

  private
    real_tipo: string;
    FdmServizi: TdmdServizi;

  public

  end;

var
  FrmAnnulla: TFrmAnnulla;

implementation

{$R *.dfm}

uses UntServizi;


constructor TFrmAnnulla.CreateWithDM(AOwner: TComponent; d: TdmdServizi);
begin
  inherited Create(AOwner);
  FdmServizi := d;
  RedirectFixupReferences(Self, 'dmdServizi', FdmServizi.Name);
end;

procedure TFrmAnnulla.btnNoClick(Sender: TObject);
begin
   if FdmServizi.TblServizi.state in [dsInsert,dsEdit] then
      FdmServizi.TblServizi.FieldByName('TIPO').AsString := real_tipo;
      
    ModalResult := mrNo;
end;

procedure TFrmAnnulla.btnSiClick(Sender: TObject);
begin

  if FdmServizi.TblServizi.state in [dsInsert,dsEdit] then
  begin
   if (FdmServizi.TblServizi['TIPO'] = NULL) then
   begin
      MessageDlg('Specificare il motivo.', mtError,[mbCancel], 0);
    Abort;
   end
   else
   begin

   FdmServizi.TblServizi.FieldByName('DELETED').AsInteger := 1;

  if FdmServizi.TblServizi['MEZZO'] = NULL then
    FdmServizi.TblServizi['MEZZO'] := 'n/a';
  if FdmServizi.TblServizi['CLIENTE'] = NULL then
    FdmServizi.TblServizi['CLIENTE'] := 'n/a';
  if FdmServizi.TblServizi['MOTIVO'] = NULL then
    FdmServizi.TblServizi['MOTIVO'] := 'n/a';
  if FdmServizi.TblServizi['LUOGO'] = NULL then
    FdmServizi.TblServizi['LUOGO'] := 'n/a';
  if FdmServizi.TblServizi['LUOGO_CITTA'] = NULL then
    FdmServizi.TblServizi['LUOGO_CITTA'] := 'n/a';
  if FdmServizi.TblServizi['AUTISTA'] = NULL then
    FdmServizi.TblServizi['AUTISTA'] := 'n/a';
  if FdmServizi.TblServizi['STATO'] = NULL then
    FdmServizi.TblServizi['STATO'] := 'n/a';
  if FdmServizi.TblServizi['KM'] = NULL then
    FdmServizi.TblServizi['KM'] := '0';
  if FdmServizi.TblServizi['BOLLA'] = NULL then
    FdmServizi.TblServizi['BOLLA'] := '0';
  if FdmServizi.TblServizi['ORA_FINE'] = NULL then
    FdmServizi.TblServizi['ORA_FINE'] := FdmServizi.TblServizi['ORA_SERV'];
   end;

    ModalResult := mrYes;
   end;

end;

procedure TFrmAnnulla.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then btnNoClick(self);
end;

procedure TFrmAnnulla.FormShow(Sender: TObject);
begin;
  nserviz.Caption := FdmServizi.Tblservizi.FieldByName('NUM').AsString;
  real_tipo := FdmServizi.TblServizi.FieldByName('TIPO').AsString;
  FdmServizi.TblServizi['TIPO'] := NULL;
  centralino.setfocus;
end;

end.
