unit UntElServ;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  dmMod, untException,
  StdCtrls, ExtCtrls, DBCtrls, Grids, DBGrids, Buttons, db;

type
  TFrmElServ = class(TForm)
    btnExit: TSpeedButton;
    btnCancel: TSpeedButton;
    btnApply: TSpeedButton;
    Panel1: TPanel;
    Label3: TLabel;
    grdServizi: TDBGrid;
    Label4: TLabel;
    grdTrasportati: TDBGrid;
    Label5: TLabel;
    DBMemo1: TDBMemo;
    Label1: TLabel;
    Label6: TLabel;
    procedure btnExitClick(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmElServ: TFrmElServ;

implementation

{$R *.DFM}

procedure TFrmElServ.btnExitClick(Sender: TObject);
begin
  frmElserv.Close;
end;

procedure TFrmElServ.btnApplyClick(Sender: TObject);
begin
  //SALVATAGGIO NEL DATABASE
  //Esegui in una transazione
  ModServ.Database.StartTransaction;
  try

  if ModServ.TblServizi.State in [dsInsert, dsEdit] then
    ModServ.TblServizi.Post;

  if ModServ.TblTrasport.State in [dsInsert, dsEdit] then
    ModServ.TblTrasport.Post;

    // Applicazione delle modifiche
    Modserv.Tblservizi.ApplyUpdates;
    Modserv.TblTrasport.ApplyUpdates;

    // Svuotamento dellla cache
    Modserv.Tblservizi.CommitUpdates;
    Modserv.TblTrasport.CommitUpdates;

    //Commit della transazione
    ModServ.Database.Commit;
  except
    on E: Exception do
    begin
      //se c' qualche problema allora avvia la procedura di rollback
      if ModServ.Database.InTransaction then
        ModServ.Database.Rollback;

      FrmException := TFrmException.Create(self);
      FrmException.TextLabel.Text := 'Registrazioni non avvenute per problemi nei database.'#13 +
        'Rivolgersi all'' assistenza tecnica.';
      FrmException.DetailsMemo.Text :=  E.Message;
      FrmException.ShowModal;
      FrmException.Free;
      Abort;
    end;
  end;
end;

procedure TFrmElServ.btnCancelClick(Sender: TObject);
begin
  //annullamento dell'inserimento
  Modserv.TblServizi.Cancel;
  //cancellazione cache
  ModServ.TblTrasport.CancelUpdates;
  ModServ.Tblservizi.CancelUpdates;
end;

end.
