unit UntFind;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, dmMod, Grids, DBGrids, ImgList, ComCtrls, ToolWin,
  Buttons;

type
  TFrmFind = class(TForm)
    lblFind: TLabel;
    btnExit: TSpeedButton;
    lblExtracted: TLabel;
    tot: TLabel;
    pnlCenter: TPanel;
    SQL: TMemo;
    grdResult: TDBGrid;
    Splitter: TSplitter;
    Pulisci: TSpeedButton;
    SpeedButton1: TSpeedButton;
    procedure btnClearClick(Sender: TObject);
    procedure btnExecuteClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmFind: TFrmFind;

implementation

{$R *.DFM}

procedure TFrmFind.btnClearClick(Sender: TObject);
begin
  //pulizia della MEMO SQL
  SQL.Clear;
  ModServ.QryFind.Close;
end;

procedure TFrmFind.btnExecuteClick(Sender: TObject);
begin
  try
    //passaggio della stringa memo alla query ed apertura della stessa
    ModServ.QryFind.Close;
    ModServ.QryFind.SQL.Assign(Sql.Lines);
    ModServ.QryFind.Open;
    ModServ.QryFind.Last;
    Tot.Caption := IntToStr(ModServ.QryFind.RecordCount);
  except
    on E: Exception do
      MessageDlg('Codice SQL non corretto: ' + E.Message, mtError, [mbOk], 0);
  end;
end;

procedure TFrmFind.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmFind.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then close;
end;

end.
