unit UntGestionePersonale;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  dmMod,untException, untcommon, ImgList, ActnList, DB, Grids, DBGrids,
  StdCtrls, DBCtrls, Mask, ComCtrls, Buttons, ExtCtrls;

type
  TFrmInsertVol = class(TForm)
    Label6: TLabel;
    Label1: TLabel;
    sbNew: TSpeedButton;
    sbDel: TSpeedButton;
    sbundo: TSpeedButton;
    sbsave: TSpeedButton;
    sbEdit: TSpeedButton;
    sbExit: TSpeedButton;
    dtsVolunteer: TDataSource;
    Label19: TLabel;
    tot: TLabel;
    PAGESOCI: TPageControl;
    TabSoci: TTabSheet;
    tablista: TTabSheet;
    Label17: TLabel;
    PageVol: TPageControl;
    TabGen: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label18: TLabel;
    COGNOME: TDBEdit;
    RESIDENZA: TDBEdit;
    ABITAZIONE: TDBEdit;
    NATOA: TDBEdit;
    NATOIL: TDBEdit;
    PROFESSIONE: TDBEdit;
    CI: TDBEdit;
    CF: TDBEdit;
    M: TRadioButton;
    F: TRadioButton;
    patente: TDBCheckBox;
    cbxInstructionLevel: TDBLookupComboBox;
    TabSocio: TTabSheet;
    Label4: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label5: TLabel;
    tessera: TDBEdit;
    DBEdit1: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBCheckBox1: TDBCheckBox;
    DBCheckBox2: TDBCheckBox;
    DBCheckBox3: TDBCheckBox;
    cxbGrado: TDBLookupComboBox;
    TabTurni: TTabSheet;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    DBCheckBox4: TDBCheckBox;
    DBCheckBox5: TDBCheckBox;
    DBLookupComboBox2: TDBLookupComboBox;
    DBLookupComboBox3: TDBLookupComboBox;
    TabNote: TTabSheet;
    DBMemo1: TDBMemo;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    DBGrid1: TDBGrid;
    edSearch: TEdit;
    SpeedButton1: TSpeedButton;
    acnVolunteer: TActionList;
    acnSearch: TAction;
    ImageList1: TImageList;
    dae: TDBEdit;
    Label28: TLabel;
    Label29: TLabel;
    cxbPosizione: TDBLookupComboBox;
    procedure FormShow(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure edSearchKeyPress(Sender: TObject; var Key: Char);
    procedure acnSearchExecute(Sender: TObject);
    procedure sbNewClick(Sender: TObject);
    procedure sbEditClick(Sender: TObject);
    procedure sbundoClick(Sender: TObject);
    procedure sbsaveClick(Sender: TObject);
    procedure dtsVolunteerStateChange(Sender: TObject);
    procedure sbExitClick(Sender: TObject);
    procedure dtsVolunteerDataChange(Sender: TObject; Field: TField);
    procedure sbDelClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
  private
    procedure disabilita_tab;
    procedure abilita_tab;
    procedure SyncList;
  public
    { Public declarations }
  end;

var
  FrmInsertVol: TFrmInsertVol;

implementation

{$R *.DFM}

procedure TFrmInsertVol.sbNewClick(Sender: TObject);
begin
  abilita_tab;
  PageSOCI.ActivePage := tabSOCI;
  PageVol.ActivePage := tabgen;
  Modserv.TblGestVol.Insert;
  cognome.SetFocus;
  modServ.TblGestVol.FieldByName('SERVIZIO').ASINTEGER := 1;
  modServ.TblGestVol.FieldByName('ASPETT').ASINTEGER := 0;
  modServ.TblGestVol.FieldByName('DIMISS').ASINTEGER := 0;
  modServ.TblGestVol.FieldByName('SERV_INT').ASINTEGER := 1;
  modServ.TblGestVol.FieldByName('INDISPOSTO').ASINTEGER := 0;
  modServ.TblGestVol.FieldByName('PATENTE').ASINTEGER := 0;
end;

procedure TFrmInsertVol.sbEditClick(Sender: TObject);
begin
  abilita_tab;
  PageSOCI.ActivePage := tabSOCI;
  PageVol.ActivePage := tabgen;
  modserv.TblGestVol.edit;
  cognome.SetFocus;
end;

procedure TFrmInsertVol.sbundoClick(Sender: TObject);
begin
  if confirm('Annullare le modifiche ?') then
  begin
    disabilita_tab;
    //annullamento dell'inserimento
    Modserv.TblGestVol.Cancel;
    //cancellazione cache
    ModServ.Tblgestvol.CancelUpdates;
  end;
end;

procedure TFrmInsertVol.sbsaveClick(Sender: TObject);
begin
  disabilita_tab;
  //salvataggio del sesso
  if m.Checked then
    ModServ.TblGestVol.FieldByName('SESSO').asstring := 'M'
  else
    ModServ.TblGestVol.FieldByName('SESSO').asstring := 'F';
  //SALVATAGGIO NEL DATABASE
  //INIZIA LA TRANSAZIONE
  ModServ.Tblgestvol.Post;
  ModServ.Database.StartTransaction;
  try
    //salvo la tabella padre
    ModServ.Tblgestvol.ApplyUpdates;
    ModServ.Tblgestvol.CommitUpdates;
    //salvo la transazione
    ModServ.Database.Commit;
    ModServ.qryVolunteerList.Close;
    ModServ.qryVolunteerList.Open;
  except
    on E: Exception do
    begin
      //se c' qualche problema allora avvia la procedura di rollback
      if ModServ.Database.InTransaction then
        ModServ.Database.Rollback;

      FrmException := TFrmException.Create(self);
      FrmException.TextLabel.Text := 'Registrazioni non avvenute per problemi nei database.'#13 +
        'Rivolgersi all'' assistenza tecnica.';
      FrmException.DetailsMemo.Text :=  E.Message;
      FrmException.ShowModal;
      FrmException.Free;
      
      Abort;
    end;

  end;
end;

procedure TFrmInsertVol.abilita_tab;
begin
  TabGen.Enabled := true;
  TabSocio.Enabled := true;
  TabTurni.Enabled := true;
  Tabnote.Enabled := true;
end;

procedure TFrmInsertVol.disabilita_tab;
begin
  TabGen.Enabled := false;
  TabSocio.Enabled := false;
  TabTurni.Enabled := false;
  Tabnote.Enabled := false;
end;

procedure TFrmInsertVol.dtsVolunteerStateChange(Sender: TObject);
begin
  if modserv.TblGestVol.State in [dsedit, dsinsert] then
  begin
    sbnew.enabled := false;
    sbedit.enabled := false;
    sbdel.enabled := false;
    sbundo.enabled := true;
    sbsave.enabled := true;
    sbexit.enabled := false;
  end
  else
  begin
    sbnew.enabled := true;
    if modserv.tblgestvol.recordcount > 0 then
    begin
      sbedit.enabled := true;
      sbdel.enabled := true;
    end
    else
    begin
      sbedit.enabled := false;
      sbdel.enabled := false;
    end;
    sbundo.enabled := false;
    sbsave.enabled := false;
    sbexit.enabled := true;
  end;
  tot.Caption := inttostr(modserv.tblgestvol.recordcount);
end;

procedure TFrmInsertVol.sbExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmInsertVol.dtsVolunteerDataChange(Sender: TObject;
  Field: TField);
begin
  if modserv.TblGestVol.State = dsbrowse then
  begin
    if modServ.TblGestVol.FieldByName('SESSO').asstring = 'M' then
      m.Checked := true
    else
      f.Checked := true;
  end;
end;

procedure TFrmInsertVol.sbDelClick(Sender: TObject);
begin
  if confirm('Eliminare il record ?') then
  begin
    ModServ.Tblgestvol.Delete;
    MODSERV.Database.StartTransaction;
    try
      //salvo la tabella padre
      Modserv.Tblgestvol.ApplyUpdates;
      Modserv.Tblgestvol.CommitUpdates;
      //salvo la transazione
      ModServ.Database.Commit;
    except
      on E: Exception do
      begin
        //se c' qualche problema allora avvia la procedura di rollback
        if ModServ.Database.InTransaction then
          ModServ.Database.Rollback;
      FrmException := TFrmException.Create(self);
      FrmException.TextLabel.Text := 'Registrazioni non avvenute per problemi nei database.'#13 +
        'Rivolgersi all'' assistenza tecnica.';
      FrmException.DetailsMemo.Text :=  E.Message;
      FrmException.ShowModal;
      FrmException.Free;
        Abort;
      end;
    end;
  ModServ.qryVolunteerList.Close;
  ModServ.qryVolunteerList.Open;
  end;
end;

procedure TFrmInsertVol.DBGrid1DblClick(Sender: TObject);
begin
  SyncList;
  pagesoci.ActivePage := tabsoci;
end;

procedure TFrmInsertVol.acnSearchExecute(Sender: TObject);
begin
  ModServ.TblGestVol.Locate('COGNOME', edSearch.Text, [loCaseInsensitive, loPartialKey]);
end;

procedure TFrmInsertVol.edSearchKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    acnSearch.Execute;
    Key := #0;
  end;
end;

procedure TFrmInsertVol.SyncList;
begin
   ModServ.TblGestVol.Locate('id', ModServ.qryVolunteerListid.Value, []);
end;

procedure TFrmInsertVol.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    SyncList;
    pagesoci.ActivePage := tabsoci;
  end;
end;

procedure TFrmInsertVol.FormShow(Sender: TObject);
begin
  DISABILITA_TAB;
  ModServ.qryVolunteerList.Open;
  SyncList;
end;

end.
