unit UntReport;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, JvExStdCtrls, JvHtControls, JvDBHTLabel, Mask, DBCtrls,
  ExtCtrls, dmMod;

type
  TFrmReport = class(TForm)
    GroupBox1: TGroupBox;
    JvDBHTLabel1: TJvDBHTLabel;
    Label1: TLabel;
    JvDBHTLabel2: TJvDBHTLabel;
    GroupBox2: TGroupBox;
    JvDBHTLabel3: TJvDBHTLabel;
    JvDBHTLabel4: TJvDBHTLabel;
    GroupBox3: TGroupBox;
    JvDBHTLabel5: TJvDBHTLabel;
    JvDBHTLabel6: TJvDBHTLabel;
    GroupBox4: TGroupBox;
    JvDBHTLabel7: TJvDBHTLabel;
    GroupBox5: TGroupBox;
    JvDBHTLabel8: TJvDBHTLabel;
    JvDBHTLabel9: TJvDBHTLabel;
    GroupBox6: TGroupBox;
    JvDBHTLabel10: TJvDBHTLabel;
    JvDBHTLabel11: TJvDBHTLabel;
    Button1: TButton;
    GroupBox7: TGroupBox;
    chkMSA: TDBCheckBox;
    chkMSB: TDBCheckBox;
    chkEli: TDBCheckBox;
    chkVVF: TDBCheckBox;
    chkForzordine: TDBCheckBox;
    chkAltro: TDBCheckBox;
    GroupBox8: TGroupBox;
    DBMemo: TDBMemo;
    Label2: TLabel;
    DBCheckBox1: TDBCheckBox;
    DBNavigator1: TDBNavigator;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmReport: TFrmReport;

implementation

{$R *.dfm}

uses untmain, untException;

resourcestring
  BlobError = 'Impossibile visualizzare questa scheda a causa di un errore sconosciuto.'
  + #13+#10+#13+#10+ 'Sar visualizzata la scheda precedente a quella selezionata';

procedure TFrmReport.Button1Click(Sender: TObject);
begin
  close
end;

procedure TFrmReport.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then close; 
end;

procedure TFrmReport.FormShow(Sender: TObject);
begin
  try

   ModServ.TblServizi.Locate('num', FrmMain.last10serv.Fields[0].Value , []);
   ModServ.TblTrasport.Locate('num', FrmMain.last10serv.Fields[0].Value , []);

   if ModServ.TblServizi['deleted'] = 1 then
    label2.Visible := True
   else
    label2.Visible := False
  except
      on E: Exception do
      begin
        FrmException := TFrmException.Create(self);
        FrmException.TextLabel.Text := BlobError;
        FrmException.DetailsMemo.Text :=  E.Message;
        FrmException.ShowModal;
        FrmException.Free;
      end;
  end;

end;

end.
