unit UntServizi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, DBCGrids, Menus, ExtCtrls, ToolWin, ComCtrls, StdCtrls, Mask,
  DBCtrls, db, jpeg,  StrTools, Grids, DBGrids,
  dmServizi, dmMod, JvExMask, JvToolEdit, JvMaskEdit, JvCheckedMaskEdit,
  JvDatePickerEdit, JvDBDatePickerEdit, JvExComCtrls, JvDateTimePicker,
  JvDBDateTimePicker; //ShlIntf, ActiveX, ComObj,;

type
  TfrmServizi = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Registra1: TMenuItem;
    Registra2: TMenuItem;
    Chiusura1181: TMenuItem;
    N1: TMenuItem;
    Panel1: TPanel;
    grpNserviz: TGroupBox;
    CONTENITORE: TPanel;
    BtnCanc: TSpeedButton;
    BtnSave: TSpeedButton;
    Label11: TLabel;
    TIPO: TDBLookupComboBox;
    Label14: TLabel;
    Orari1: TMenuItem;
    FineMissione1: TMenuItem;
    OraLibero1: TMenuItem;
    OraDestinazione1: TMenuItem;
    OraCaricato1: TMenuItem;
    OrasulpostoSospeso1: TMenuItem;
    Partenzadallasede1: TMenuItem;
    data_serv: TJvDBDateTimePicker;
    Img118: TImage;
    function getNumeroScheda(): Integer;
    function Save(): boolean;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TIPOClick(Sender: TObject);
    procedure sbNewRicClick(Sender: TObject);
    procedure BtnCancClick(Sender: TObject);
    procedure sbfineClick(Sender: TObject);
    procedure sbpostoClick(Sender: TObject);
    procedure sbcaricatoClick(Sender: TObject);
    procedure sbdestinazioneClick(Sender: TObject);
    procedure sbliberoClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sbpartenzaClick(Sender: TObject);
    procedure Partenzadallasede1Click(Sender: TObject);
    procedure OrasulpostoSospeso1Click(Sender: TObject);
    procedure OraCaricato1Click(Sender: TObject);
    procedure OraDestinazione1Click(Sender: TObject);
    procedure OraLibero1Click(Sender: TObject);
    procedure FineMissione1Click(Sender: TObject);
    procedure Btn118Click(Sender: TObject);
    procedure Registra2Click(Sender: TObject);
    //procedure Completamento(CampoForm: TDBedit; ColonnaDB : string; ExtFile : boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CleanComboBox(Sender: TObject; var Key: Char);
  private
    //FAutoComplete: IAutoComplete2;
    //FStrings: IUnknown;
    //qryresult: TStringList;
    FDmServizi: TdmdServizi;
    FCurrentPage: Tframe;
  public
    { Public declarations }
  end;

var
  frmServizi: TfrmServizi;

implementation

{$R *.DFM}

uses Variants, untAuto, UntCliente, UntTrasportato, UntAnnulla,UntOspedale,untException,
    svrFrame118, svrFrameAutoMed, svrFrameStaziona, svrFrameTrasporto, untChiusura118,
    svrFrameTrasportoAmbu, svrFrameTraspoDisab, svrFrameGuardiaMed, untMain;

resourcestring
  NoResource = 'Impossibile aprire una nuova scheda, risorse non sufficienti.';
  NoScheda = 'Impossibile ottenere il numero di scheda.'+ #13+#10+#13+#10 +
  'provare a riavviare il programma per vedere se il problema si risolve';
  No118 = 'Attenzione, questa non  una missione 118 o di automedica';
  NoCodice = 'Attenzione!'+ #13+#10 +'Non  stato inserito il Codice ';

function TfrmServizi.getNumeroScheda(): Integer;
begin
    Result := FdmServizi.Tblservizi.FieldByName('NUM').AsInteger;
end;

{*************************************************************************
 TODO -oMemini -cFixup : Per qualche strano motivo l'autocomplete non fuziona
 pi sui form aperti con la CreateWithDM(),forse perch bisogna creare la lista
 e attivare l'activex prima di creare la form.
 Ora non  essenziale per bisogna risolverlo quanto prima...
 }

{
procedure TfrmServizi.Completamento(CampoForm: TDBedit; ColonnaDB : string; ExtFile : boolean);
var
  qrystring: string;

begin
  qryresult := TStringList.Create;

  if ExtFile then
  begin
      qryresult := TStringList.Create;
      qryresult.LoadFromFile(ColonnaDB);
  end
  else
  begin
    qrystring := Format('select %s from servizi group by %s;', [ColonnaDB,ColonnaDB]);

    FdmServizi.QryFind.Close;
    FdmServizi.QryFind.SQL.Clear;
    FdmServizi.QryFind.SQL.Add(qrystring);
    FdmServizi.QryFind.Open;

    while not FdmServizi.QryFind.EOF do begin
      qryresult.Add(FdmServizi.QryFind.FieldByName(ColonnaDB).AsString);
      FdmServizi.QryFind.Next;
    end;

    FdmServizi.QryFind.Close;
  end;

  // AUTOCOMPLETE

  FAutoComplete := CreateComObject(CLSID_AutoComplete) as IAutoComplete2;
  FStrings := TEnumString.Create(qryresult) as IUnknown;
  OleCheck(FAutoComplete.SetOptions(ACO_AUTOAPPEND or ACO_AUTOSUGGEST or ACO_UPDOWNKEYDROPSLIST));
  OleCheck(FAutoComplete.Init(CampoForm.handle, FStrings, nil, nil));

end;
}

function TfrmServizi.Save(): boolean;
begin
  //INIZIA LA TRANSAZIONE
  { TODO 0 -oMemini -cRefactoring : Transazioni
  Attuamlmente utilizzo mysql con l'autocommit, quindi lo starttransaction qui sotto
   inutile. Quando prima dovr provare a riutilizzare la transazioni e vedere che succede
  }
  ModServ.Database.StartTransaction;
  try
    //Salvo il nuovo numero di servizio nei trasportati
    if not FdmServizi.TblTrasport.IsEmpty then
    try
      FdmServizi.TblTrasport.DisableControls;
      FdmServizi.TblTrasport.First;
      while not (FdmServizi.TblTrasport.Eof) do
      begin
        FdmServizi.TblTrasport.Edit;
        FdmServizi.TblTrasport.FieldByName('NUM').AsInteger :=
        FdmServizi.Tblservizi.FieldByName('NUM').AsInteger;
        FdmServizi.TblTrasport.Post;
        FdmServizi.TblTrasport.Next;
      end;
      FdmServizi.TblTrasport.First;
    finally
      FdmServizi.TblTrasport.EnableControls;
    end;

    //Salvo i dati del servizio nel database
    FdmServizi.TblServizi.post;

    if FdmServizi.qryMezziActive.State in [dsEdit, dsInsert] then
    begin
      FdmServizi.qryMezziActive.Post;
      FdmServizi.qryMezziActive.ApplyUpdates;
      FdmServizi.qryMezziActive.CommitUpdates;
    end;

    //SALVATAGGIO NEL DATABASE

    //salvo la tabella padre
    FdmServizi.Tblservizi.ApplyUpdates;
    //salvo la tabella figlia
    FdmServizi.TblTrasport.ApplyUpdates;

    //commit
    FdmServizi.Tblservizi.CommitUpdates;
    FdmServizi.TblTrasport.CommitUpdates;

    //salvo la transazione
    ModServ.Database.Commit;

    Result := True;
  except
      on E: Exception do
    begin
    if ModServ.Database.InTransaction then
      ModServ.Database.Rollback;
      MessageDlg('Attenzione, completare tutti i campi.' + #13+#10+#13+#10 + E.Message, mtWarning,[mbOK], 0);
      Result := False;
      Abort;
    end;
  end;

end;

procedure TfrmServizi.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FdmServizi.TblServizi.State in [dsedit, dsinsert] then
  begin
    MessageDlg('Attenzione , Modifiche in corso', mtWarning, [mbCancel], 0);
    Abort;
  end
  else
//    if modserv.AUTOCOMPLETE then
//      qryresult.free;

  // Chiudo il tab
  frmAuto.TabControl1.tabs.Delete(frmAuto.tabcontrol1.TabIndex);
  frmAuto.TabControl1.TabIndex := 0;
  frmAuto.TabControl1Change(self);

  // non mi ricordo a cosa servisse...
  Action := caFree;
end;

procedure TfrmServizi.FormCreate(Sender: TObject);
var   formattedDateTime : string;
begin
  DateTimeToString(formattedDateTime, 't', Time);
  try
    // Smart code to have our unique datamodule reference
    FdmServizi := TdmdServizi.Create(Self);

    // Apro le interfaccie per le query
    FdmServizi.OpenDatasets;

    // Inserimento nuova riga nella tabella servizi
    FdmServizi.TblServizi.Insert;

    // Richiedo al database un nuovo numero di servizio
    {
    TODO 1 -oMemini -cProvare con altri driver ODBC perch quello attuale non
    permette l'utilizzo TStoreProc
    }
     try
      FdmServizi.qrySequence.SQL.Add('call generate_sequence_number(@num)');
      FdmServizi.qrySequence.ExecSQL;
      FdmServizi.qrySequence.SQL.Clear;
      FdmServizi.qrySequence.SQL.add('select @num');
      FdmServizi.qrySequence.Open;
      FdmServizi.Tblservizi.FieldByName('NUM').AsInteger :=
        strtoint(FdmServizi.qrySequence.FieldByName('@num').AsString);
      FdmServizi.qrySequence.Close;
      FdmServizi.qrySequence.SQL.Clear;
    except
      // Se fallisce a creare il numero di scheda la scheda NON si deve aprire
      on E: Exception do
      begin
        FrmException := TFrmException.Create(self);
        FrmException.TextLabel.Text := noscheda;
        FrmException.DetailsMemo.Text :=  E.Message;
        FrmException.ShowModal;
        FrmException.Free;
        //MessageDlg(''
        //+ #13+#10+#13+#10+ 'Motivo: ' + E.Message, mtError,[mbOK], 0);
        Destroy;
        Abort;
      end;
    end;

  // Inizializzazione dei dati base del nuovo servizio
  {
  TODO 1 -oMemini -cValutare se non conviene spostare questa parte
  nell'evento NewRecord della tblservizi
  }

  FdmServizi.TblServizi.FieldByName('DATA_SERV').AsDateTime := Date;
  FdmServizi.TblServizi.FieldByName('ORA_SERV').AsString := formattedDateTime;
  FdmServizi.TblServizi.FieldByName('PAGATO').AsInteger := 0;
  FdmServizi.TblServizi.FieldByName('MSB').AsString := 'False';
  FdmServizi.TblServizi.FieldByName('MSA').AsString := 'False';
  FdmServizi.TblServizi.FieldByName('MSAonB').AsString := 'False';
  FdmServizi.TblServizi.FieldByName('VVF').AsString := 'False';
  FdmServizi.TblServizi.FieldByName('POLIZ').AsString := 'False';
  FdmServizi.TblServizi.FieldByName('ELI').AsString := 'False';
  FdmServizi.TblServizi.FieldByName('VNOTE').AsString := 'False';
  FdmServizi.TblServizi.FieldByName('DAE').AsString := 'False';

  {
  Non funziona come mi aspettavo.. deve tenere questa parte in FrmAuto

  frmauto.TabControl1.tabs.AddObject('Scheda n: ' + IntToStr(self.getNumeroScheda()), FrmServizi);
  frmauto.TabControl1.TabIndex := frmauto.tabcontrol1.Tabs.Count - 1;
  //visualizzazione form dati nel tab
  frmauto.jvmergemanager1.Merge(Self, true);
  }
  except
    on E: Exception do
    begin
      FrmException := TFrmException.Create(self);
      FrmException.TextLabel.Text := NoResource;
      FrmException.DetailsMemo.Text :=  E.Message;
      FrmException.ShowModal;
      FrmException.Free;

      // Distruggo la form corrente - Non  bello usare la Destroy per se uso la
      // close mi ritrovo a chiudere il tab della scheda attiva (l'associazione della
      // form al tabset avviene al termine della FormCreate mentre la distruzione del
      // tab avviene nella in FrmServizi.FormClose)
      Destroy;
    end;
  end;

end;

procedure TfrmServizi.FormDestroy(Sender: TObject);
begin
  // Chiudo i dataset e liBBero la memoria del datamodule
  FdmServizi.CloseDatasets;
  FdmServizi.Free;
end;

procedure TfrmServizi.TIPOClick(Sender: TObject);
var
  codserv: integer;
begin
  codserv := FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger;

  if FCurrentPage <> nil then
  begin
    FreeAndNil(FCurrentPage);

    // Pulizia dei campi
    FdmServizi.TblServizi['CS'] := NULL;
    FdmServizi.TblServizi['MILITE'] := NULL;
    FdmServizi.TblServizi['MILITE2'] := NULL;
    FdmServizi.TblServizi['CLIENTE'] := NULL;
    FdmServizi.TblServizi['ORA_CARIC'] := NULL;
    FdmServizi.TblServizi['DESTINAZ'] := NULL;
    FdmServizi.TblServizi['DESTINAZ_CITTA'] := NULL;
    FdmServizi.TblServizi['ORA_DEST'] := NULL;
    FdmServizi.TblServizi['TRASP_R'] := NULL;
    FdmServizi.TblServizi['COSTO'] := NULL;
    FdmServizi.TblServizi['STATO'] := NULL;
    FdmServizi.TblServizi['PAGATO'] := 0;
    FDmServizi.TblTrasport.CancelUpdates;

  end;

  case codserv of
    1:
    begin
      img118.Visible := True;
      // Scheda 118
      FCurrentPage := TFrame118.createWithDM(self, FdmServizi);
      // Dispone la pagina all'interno del pannello contenitore
      FCurrentPage.Parent := CONTENITORE;
      // Forza la pagina ad occupare tutto lo spazio disponibile
      FCurrentPage.Align := alClient;
      // Imposto il cliente (o convenzione) predefinito ossia il primo della tabella
      FdmServizi.TblCliente.First;
      FdmServizi.TblServizi.FieldByName('Cliente').AsString :=
      FdmServizi.TblCliente.FieldByName('RAGSOC').AsString;
    end;
    2:
    begin
      img118.Visible := False;
      // Scheda stazionamento
      FCurrentPage := TFrameStaziona.createWithDM(self, FdmServizi);
      // Dispone la pagina all'interno del pannello contenitore
      FCurrentPage.Parent := CONTENITORE;
      // Forza la pagina ad occupare tutto lo spazio disponibile
      FCurrentPage.Align := alClient;
      FdmServizi.TblServizi.FieldByName('STATO').AsString := 'REGOLARE';
    end;
    3:
    begin
      img118.Visible := False;
      // Scheda trasporto macchina
      FCurrentPage := TFrameTrasporto.createWithDM(self, FdmServizi);
      // Dispone la pagina all'interno del pannello contenitore
      FCurrentPage.Parent := CONTENITORE;
      // Forza la pagina ad occupare tutto lo spazio disponibile
      FCurrentPage.Align := alClient;
      FdmServizi.TblServizi.FieldByName('STATO').AsString := 'REGOLARE';
    end;
    4:
    begin
      img118.Visible := True;
      // Scheda automedica
      FCurrentPage := TFrameAutoMed.createWithDM(self, FdmServizi);
      // Dispone la pagina all'interno del pannello contenitore
      FCurrentPage.Parent := CONTENITORE;
      // Forza la pagina ad occupare tutto lo spazio disponibile
      FCurrentPage.Align := alClient;
      // Forzo un cliente fittizzio (il 118)
      FdmServizi.TblCliente.First;
      FdmServizi.TblServizi.FieldByName('Cliente').AsString := '118';
    end;
    5:
    begin
      img118.Visible := False;
      // Scheda trasporto ambulanza
      FCurrentPage := TFrameTrasportoAmbu.createWithDM(self, FdmServizi);
      // Dispone la pagina all'interno del pannello contenitore
      FCurrentPage.Parent := CONTENITORE;
      // Forza la pagina ad occupare tutto lo spazio disponibile
      FCurrentPage.Align := alClient;
      FdmServizi.TblServizi.FieldByName('STATO').AsString := 'REGOLARE';
    end;
    6:
    begin
      img118.Visible := False;
      // Scheda trasporto disabili
      FCurrentPage := TFrameTrasportoDisabili.createWithDM(self, FdmServizi);
      // Dispone la pagina all'interno del pannello contenitore
      FCurrentPage.Parent := CONTENITORE;
      // Forza la pagina ad occupare tutto lo spazio disponibile
      FCurrentPage.Align := alClient;
      FdmServizi.TblServizi.FieldByName('STATO').AsString := 'REGOLARE';
    end;
    7:
    begin
      img118.Visible := False;
      // Scheda CMR
      FCurrentPage := TFrameTrasportoAmbu.createWithDM(self, FdmServizi);
      // Dispone la pagina all'interno del pannello contenitore
      FCurrentPage.Parent := CONTENITORE;
      // Forza la pagina ad occupare tutto lo spazio disponibile
      FCurrentPage.Align := alClient;
      FdmServizi.TblServizi.FieldByName('STATO').AsString := 'REGOLARE';
    end;
    8:
    begin
      img118.Visible := False;
      // Scheda Guardia Medica
      FCurrentPage := TFrameGuardiaMedica.createWithDM(self, FdmServizi);
      // Dispone la pagina all'interno del pannello contenitore
      FCurrentPage.Parent := CONTENITORE;
      // Forza la pagina ad occupare tutto lo spazio disponibile
      FCurrentPage.Align := alClient;
      FdmServizi.TblServizi.FieldByName('STATO').AsString := 'REGOLARE';
    end;
  end;
end;

procedure TfrmServizi.sbNewRicClick(Sender: TObject);
begin
  frmCliente := TFrmCliente.createWithDM(self, FdmServizi);
  FdmServizi.tblCliente.Append;
  frmCliente.ShowModal;
  frmCliente.free;
end;

procedure TfrmServizi.BtnCancClick(Sender: TObject);
begin

  FrmAnnulla := TFrmAnnulla.createWithDM(self, FdmServizi);

  if (FrmAnnulla.ShowModal = mrYes) then
    begin
      data_serv.SetFocus;
      //inizio della procedura di salvataggio

      // Faccio pulizia nella tabella trasportati, non ha senso salvare
      // il trasportato in un servizio annullato
      FDmServizi.TblTrasport.Cancel;
      FDmServizi.TblTrasport.CancelUpdates;

      // Evito che chiuda la disponibilt del mezzo se si annulla
      // la missione (ad es. un addestramento)
      FdmServizi.qryMezziActive.Cancel;
      FdmServizi.qryMezziActive.CancelUpdates;

      if Save() then
      begin
        FrmMain.RefreshQuery;
        Close; //chiusura del form
      end;

    end
  else
    begin
      data_serv.SetFocus;
    end;
  FrmAnnulla.free;
end;

procedure TfrmServizi.sbfineClick(Sender: TObject);
var   formattedDateTime : string;
begin
  DateTimeToString(formattedDateTime, 't', Time);
  FdmServizi.TblServizi['ORA_FINE'] := formattedDateTime;
  // FdmServizi.TblServizi['ORA_FINE'] := TimeToStr(Time);
end;

procedure TfrmServizi.sbpostoClick(Sender: TObject);
var   formattedDateTime : string;
begin
  if (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 1) or
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 4) or
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 8) then
      DateTimeToString(formattedDateTime, 't', Time);
      FdmServizi.TblServizi['ORA_POSTO'] := formattedDateTime;
      //FdmServizi.TblServizi['ORA_POSTO'] := TimeToStr(Time);
end;

procedure TfrmServizi.sbcaricatoClick(Sender: TObject);
var   formattedDateTime : string;
begin
  if (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 1) or
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 4) then
      if FdmServizi.TblServizi.FieldByName('STATO').AsString = 'REGOLARE' then
        DateTimeToString(formattedDateTime, 't', Time);
        FdmServizi.TblServizi['ORA_CARIC'] := formattedDateTime;
        //FdmServizi.TblServizi['ORA_CARIC'] := TimeToStr(Time);
end;

procedure TfrmServizi.sbdestinazioneClick(Sender: TObject);
var   formattedDateTime : string;
begin
  if (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 1) or
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 4) then
      if FdmServizi.TblServizi.FieldByName('STATO').AsString = 'REGOLARE' then
        DateTimeToString(formattedDateTime, 't', Time);
        FdmServizi.TblServizi['ORA_DEST'] := formattedDateTime;
        //FdmServizi.TblServizi['ORA_DEST'] := TimeToStr(Time);
end;

procedure TfrmServizi.sbliberoClick(Sender: TObject);
var   formattedDateTime : string;
begin
  if (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 1) or
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 4) or
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 8) then
     DateTimeToString(formattedDateTime, 't', Time);
     FdmServizi.TblServizi['ORA_LIB'] := formattedDateTime;
     //FdmServizi.TblServizi['ORA_LIB'] := TimeToStr(Time);
end;

procedure TfrmServizi.FormShow(Sender: TObject);
begin

  grpNserviz.Caption := 'Servizio Interno: ' +
   FdmServizi.Tblservizi.FieldByName('NUM').AsString;

  //IMPOSTO IL SETFOCUS SUL TIPO (genere)
  TIPO.SetFocus;

{*************************************************************************
  if modserv.AUTOCOMPLETE then
  begin
    if Modserv.FMotivi <> '' then
      begin
        Completamento(MOTIVO, Modserv.FMotivi, TRUE);
      end
    else
      begin
        Completamento(MOTIVO, MOTIVO.DataField, FALSE);
      end;

    Completamento(LUOGO, LUOGO.DataField, FALSE);
    Completamento(luogo_citta, luogo_citta.DataField, FALSE);
    Completamento(DESTINAZ, DESTINAZ.DataField, FALSE);
    Completamento(destinaz_citta, destinaz_citta.DataField, FALSE);
  end;
   **************************************************************************}
end;

procedure TfrmServizi.Partenzadallasede1Click(Sender: TObject);
begin
  sbpartenzaClick(Sender);
end;

procedure TfrmServizi.OrasulpostoSospeso1Click(Sender: TObject);
begin
  sbpostoClick(Sender);
end;

procedure TfrmServizi.OraCaricato1Click(Sender: TObject);
begin
  sbcaricatoClick(Sender);
end;

procedure TfrmServizi.OraDestinazione1Click(Sender: TObject);
begin
  sbdestinazioneClick(Sender);
end;

procedure TfrmServizi.OraLibero1Click(Sender: TObject);
begin
  sbliberoClick(Sender);
end;

procedure TfrmServizi.FineMissione1Click(Sender: TObject);
begin
  sbfineClick(Sender);
end;

procedure TfrmServizi.sbpartenzaClick(Sender: TObject);
var   formattedDateTime : string;
begin
  DateTimeToString(formattedDateTime, 't', Time);
  FdmServizi.TblServizi['ORA_PART'] := formattedDateTime;
  //FdmServizi.TblServizi['ORA_PART'] := TimeToStr(Time);
end;

procedure TfrmServizi.Registra2Click(Sender: TObject);
begin
  // ORRIBILE QUESTO CONTROLLO... per funziona!
  //controllo se sono stati inseriti almeno il paziente trasportato
  //e non si tratta di stazionamento / guardia medica / automedica
  if (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger <> 2) and
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger <> 4) and
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger <> 8) then
    begin
     if (FdmServizi.TblServizi.FieldByName('STATO').AsString = 'REGOLARE') and
     (FdmServizi.tblTrasport.RecordCount = 0) then
      begin
      MessageDlg('Inserire i dati della persona trasportata.', mtError,
        [mbCancel], 0);
      Abort;
      end;
  end;

  if (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 1) then
   begin
   // Qui verifico che sia stato inserito il codice di invio
   if (FdmServizi.TblServizi.FieldByName('trasp_a').asString = '') then
     begin
      MessageDlg(NoCodice + 'Invio.', mtError, [mbOk], 0);
      Abort;
     end;

   // Qui verifico che sia stato inserito il codice di trasporto
   if (FdmServizi.TblServizi.FieldByName('STATO').AsString = 'REGOLARE') and
    (FdmServizi.TblServizi.FieldByName('trasp_r').asString = '') then
     begin
      MessageDlg(NoCodice + 'Trasporto.', mtError, [mbOk], 0);
      Abort;
     end;
  end;

  try
  data_serv.SetFocus;
  //inizio della procedura di salvataggio
  if Save() then
    FrmMain.RefreshQuery;

  finally
    if not(FdmServizi.TblServizi.State in [dsedit, dsinsert]) then
      close; //chiusura del form
  end;
end;

procedure TfrmServizi.Btn118Click(Sender: TObject);
begin

  if not((FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 1) or
    (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 4)) then
  begin
    MessageDlg(No118, mtWarning, [mbOk], 0);
    exit;
  end;

  frm118 := TFrm118.Create(self);

  frm118.label10.Caption := '';
  frm118.label11.Caption := '';
  frm118.label12.Caption := '';
  frm118.label13.Caption := '';
  frm118.label14.Caption := '';
  frm118.label15.Caption := '';
  frm118.codcol.Caption := '';
  frm118.label20.Caption := '';
  frm118.label22.Caption := '';

  if FdmServizi.TblServizi['NUM118'] <> Null then
    frm118.label12.Caption := FdmServizi.TblServizi['NUM118'];
  if FdmServizi.TblServizi['ORA_POSTO'] <> Null then
    frm118.label10.Caption := FdmServizi.TblServizi['ORA_POSTO'];
  if FdmServizi.TblServizi['ORA_CARIC'] <> Null then
    frm118.label11.Caption := FdmServizi.TblServizi['ORA_CARIC'];
  if FdmServizi.TblServizi['ORA_DEST'] <> Null then
    frm118.label13.Caption := FdmServizi.TblServizi['ORA_DEST'];
  if FdmServizi.TblServizi['ORA_LIB'] <> Null then
    frm118.label14.Caption := FdmServizi.TblServizi['ORA_LIB'];
  if FdmServizi.TblServizi['DESTINAZ'] <> Null then
    frm118.label15.Caption := FdmServizi.TblServizi['DESTINAZ'];
  if FdmServizi.TblServizi['DESTINAZ_CITTA'] <> Null then
    frm118.label15.Caption := FdmServizi.TblServizi['DESTINAZ_CITTA'];
  if FdmServizi.TblServizi['TRASP_R'] <> Null then
    frm118.codcol.Caption := FdmServizi.TblServizi['TRASP_R'];

  if FdmServizi.TblServizi['ORA_PART'] <> Null then
    frm118.label20.Caption := FdmServizi.TblServizi['ORA_PART'];
  if FdmServizi.TblServizi['STATO'] <> Null then
    frm118.label22.Caption := FdmServizi.TblServizi['STATO'];
  frm118.showmodal;

  frm118.free;
end;

procedure TFrmServizi.CleanComboBox(Sender: TObject; var Key: Char);
begin
  if (Key = Chr(vk_Back)) then
     FdmServizi.TblServizi[(Sender as TDBLookupComboBox).DataField] := NULL;
end;

end.
