unit UntSoci;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ActnList, DB, Grids, DBGrids, StdCtrls, DBCtrls, Mask,
  ComCtrls, Buttons, ExtCtrls, dmMod,untException, DBTables, dateutils,
  JvExDBGrids, JvDBGrid, JvComponentBase, JvDBGridExport, JvExMask, JvToolEdit,
  JvExStdCtrls, JvEdit;

type
  TFrmSoci = class(TForm)
    Label6: TLabel;
    Label1: TLabel;
    sbNew: TSpeedButton;
    sbDel: TSpeedButton;
    sbundo: TSpeedButton;
    sbsave: TSpeedButton;
    sbEdit: TSpeedButton;
    sbExit: TSpeedButton;
    Label19: TLabel;
    tot: TLabel;
    PAGESOCI: TPageControl;
    TabSoci: TTabSheet;
    spSearch: TSpeedButton;
    PageDettagli: TPageControl;
    TabGen: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label25: TLabel;
    Label18: TLabel;
    INDIRIZZO: TDBEdit;
    CITTA: TDBEdit;
    NATOA: TDBEdit;
    NATOIL: TDBEdit;
    PROFESSIONE: TDBEdit;
    CF: TDBEdit;
    Privacy_626: TDBCheckBox;
    TabFamiliari: TTabSheet;
    TabRinnovi: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    edSearch: TEdit;
    tablista: TTabSheet;
    DBGrid1: TDBGrid;
    dtsSociList: TDataSource;
    NOMINATIVO: TDBEdit;
    Label29: TLabel;
    CAP: TDBEdit;
    Label30: TLabel;
    PROVINCIA: TDBEdit;
    Label31: TLabel;
    TELEFONO: TDBEdit;
    Label32: TLabel;
    TESSERA: TDBEdit;
    Label24: TLabel;
    DATA_TESSERAMENTO: TDBEdit;
    Label33: TLabel;
    Label34: TLabel;
    Bevel2: TBevel;
    FamList: TDBGrid;
    RinnList: TDBGrid;
    btnAddRinnovo: TSpeedButton;
    btnDelRinnovo: TSpeedButton;
    dtsFamiliari: TDataSource;
    dtsRinnovi: TDataSource;
    imlSoci: TImageList;
    aclSoci: TActionList;
    acnNew: TAction;
    acnDelete: TAction;
    acnUndo: TAction;
    acnSave: TAction;
    acnModify: TAction;
    acnClose: TAction;
    acnSearch: TAction;
    qrySoci: TQuery;
    dtsQuerySoci: TDataSource;
    btnAddFamiliare: TSpeedButton;
    btnDelFamiliare: TSpeedButton;
    qrySociid_socio: TIntegerField;
    qrySocitessera: TIntegerField;
    qrySocinominativo: TStringField;
    qrySocidata_di_nascita: TDateField;
    qryGenerica: TQuery;
    VALIDITA: TEdit;
    dtsGenerica: TDataSource;
    qryFamiliari: TQuery;
    upFamiliari: TUpdateSQL;
    qryRinnovi: TQuery;
    upRinnovi: TUpdateSQL;
    qryRinnoviID_SOCIO: TIntegerField;
    qryRinnoviID_RINNOVO: TIntegerField;
    qryRinnoviANNO: TIntegerField;
    qryRinnoviQUOTA: TFloatField;
    qryRinnoviDATA_RINNOVO: TDateField;
    TabSheet1: TTabSheet;
    ProgressBar1: TProgressBar;
    JvDBGridCSVExport1: TJvDBGridCSVExport;
    btnExport: TButton;
    GroupBox1: TGroupBox;
    chktessera: TCheckBox;
    chknominativo: TCheckBox;
    chkindirizzo: TCheckBox;
    chkcomune: TCheckBox;
    chkcap: TCheckBox;
    chkluogodinascita: TCheckBox;
    chkdatadinascita: TCheckBox;
    chkcf: TCheckBox;
    chkprovincia: TCheckBox;
    chktesseramento: TCheckBox;
    chktelefono: TCheckBox;
    chkprofessione: TCheckBox;
    chkprivacy: TCheckBox;
    qryExportSoci: TQuery;
    dstExportSoci: TDataSource;
    JvFilenameEdit1: TJvFilenameEdit;
    GroupBox2: TGroupBox;
    elCompleto: TRadioButton;
    elinregola: TRadioButton;
    elanno: TRadioButton;
    anno: TEdit;
    rdiTessera: TRadioButton;
    rdiNome: TRadioButton;
    Label14: TLabel;
    password: TJvEdit;
    Label4: TLabel;
    Bevel3: TBevel;
    Label5: TLabel;
    ZONA: TDBEdit;
    Label7: TLabel;
    Label8: TLabel;
    chkZona: TCheckBox;
    exportGrid: TJvDBGrid;
    procedure acnCloseExecute(Sender: TObject);
    procedure acnNewExecute(Sender: TObject);
    procedure acnModifyExecute(Sender: TObject);
    procedure acnUndoExecute(Sender: TObject);
    procedure acnSaveExecute(Sender: TObject);
    procedure acnDeleteExecute(Sender: TObject);
    procedure dtsSociListStateChange(Sender: TObject);
    procedure acnSearchExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnAddFamiliareClick(Sender: TObject);
    procedure btnDelFamiliareClick(Sender: TObject);
    procedure edSearchKeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure btnAddRinnovoClick(Sender: TObject);
    procedure btnDelRinnovoClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PAGESOCIChanging(Sender: TObject; var AllowChange: Boolean);
    procedure JvDBGridExcelExport1Progress(Sender: TObject; Min, Max,
      Position: Cardinal; const AText: string; var AContinue: Boolean);
    procedure btnExportClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure elCompletoClick(Sender: TObject);
    procedure elinregolaClick(Sender: TObject);
    procedure elannoClick(Sender: TObject);
    procedure rdiNomeClick(Sender: TObject);
    procedure rdiTesseraClick(Sender: TObject);
    procedure passwordKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    procedure disabilita_tab;
    procedure abilita_tab;
    procedure SyncList;
    procedure GetSocioData(idsocio: integer);
    procedure RefreshQuery;
    procedure CloseQry;
    procedure OpenQry;
    procedure GenerateSQL;
  public
    { Public declarations }
  end;

var
  FrmSoci: TFrmSoci;

implementation

{$R *.dfm}
uses untcommon, ShlObj ;

procedure TFrmSoci.acnCloseExecute(Sender: TObject);
begin
    close;
end;


procedure TFrmSoci.acnDeleteExecute(Sender: TObject);
begin
  if confirm('Eliminare il record ?') then
  begin
    ModServ.TblSoci.Delete;
    ModServ.Database.StartTransaction;
    try
      //salvo la tabella padre
      Modserv.TblSoci.ApplyUpdates;
      Modserv.TblSoci.CommitUpdates;
      //salvo la transazione
      ModServ.Database.Commit;
    except
      on E: Exception do
      begin
        //se c' qualche problema allora avvia la procedura di rollback
        if ModServ.Database.InTransaction then
          ModServ.Database.Rollback;
      FrmException := TFrmException.Create(self);
      FrmException.TextLabel.Text := 'Registrazioni non avvenute per problemi nei database.'#13 +
        'Rivolgersi all'' assistenza tecnica.';
      FrmException.DetailsMemo.Text :=  E.Message;
      FrmException.ShowModal;
      FrmException.Free;
        Abort;
      end;
    end;
  qrySoci.Close;
  qrySoci.Open;
  end;
end;

procedure TFrmSoci.acnModifyExecute(Sender: TObject);
begin
  abilita_tab;
  PageSOCI.ActivePage := tabSOCI;
  PageDettagli.ActivePage := tabgen;
  modserv.TblSoci.edit;
  nominativo.SetFocus;
end;

procedure TFrmSoci.acnNewExecute(Sender: TObject);
  var last_tessera : integer;
begin
  abilita_tab;
  PageSOCI.ActivePage := tabSOCI;
  PageDettagli.ActivePage := tabGen;

  // Mi posizione sul primo record della query ( ordinata in maniera decrescente)
  // e mi copio l'ultimo numero di tessera inserito
  if (qrysoci.RecordCount = 0) then
  begin
    last_tessera := 0;
  end
  else
  begin
    qrySoci.First;
    last_tessera := qrySoci.FieldByName('TESSERA').Value;
  end;

  Modserv.TblSoci.Insert;
  ModServ.TblSoci.FieldByName('trattamento_dati').AsInteger := 1;

  // Sommo 1 all'ultimo numero di tessera presente nel db e lo assegno al campo.
  // Il valore rimane modificabile dall'utente per il campo  UNIQUE quindi non
  // ci possono essere 2 numeri di tessera identici
  ModServ.TblSoci.FieldByName('TESSERA').AsInteger := last_tessera + 1;
  GetSocioData(-1);
  nominativo.SetFocus;
end;


procedure TFrmSoci.acnSaveExecute(Sender: TObject);
begin

  disabilita_tab;

  //SALVATAGGIO NEL DATABASE
  //INIZIA LA TRANSAZIONE
  ModServ.Database.StartTransaction;
  try
    //salvo la tabella padre
    if ModServ.TblSoci.State in [dsEdit, dsInsert] then
    begin
      ModServ.TblSoci.Post;
      ModServ.TblSoci.ApplyUpdates;
      ModServ.TblSoci.CommitUpdates;
    end;

    if qryFamiliari.State in [dsEdit, dsInsert] then
    begin
      qryFamiliari.Post;
      qryFamiliari.ApplyUpdates;
      qryFamiliari.CommitUpdates;
    end;

    if qryRinnovi.State in [dsEdit, dsInsert] then
    begin
      qryRinnovi.Post;
      qryRinnovi.ApplyUpdates;
      qryRinnovi.CommitUpdates;
    end;

     //salvo la transazione
    ModServ.Database.Commit;

  except
    on E: Exception do
    begin
      //se c' qualche problema allora avvia la procedura di rollback
      if ModServ.Database.InTransaction then
        ModServ.Database.Rollback;

      qryRinnovi.CancelUpdates;
      qryFamiliari.CancelUpdates;
      ModServ.TblSoci.CancelUpdates;

      FrmException := TFrmException.Create(self);
      FrmException.TextLabel.Text := 'Registrazioni non avvenute per problemi nei database.'#13 + #10 +
        'Rivolgersi all'' assistenza tecnica.';
      FrmException.DetailsMemo.Text :=  E.Message;
      FrmException.ShowModal;
      FrmException.Free;

      Abort;
    end;
  end;
  RefreshQuery;
  GetSocioData(ModServ.TblSoci.FieldByName('ID_SOCIO').Value);

end;

procedure TFrmSoci.acnSearchExecute(Sender: TObject);
begin
  if rdiNome.Checked then
    ModServ.TblSoci.Locate('NOMINATIVO', edSearch.Text, [loCaseInsensitive, loPartialKey]);

  if rdiTessera.Checked then
    ModServ.TblSoci.Locate('TESSERA', edSearch.Text, []);

  GetSocioData(ModServ.TblSoci.FieldByName('ID_SOCIO').Value);
end;

procedure TFrmSoci.acnUndoExecute(Sender: TObject);
begin
  if confirm('Annullare le modifiche ?') then
  begin
    disabilita_tab;

    //annullamento dell'inserimento
    Modserv.TblSoci.Cancel;
    qryFamiliari.Cancel;
    qryRinnovi.Cancel;

    //cancellazione cache
    ModServ.TblSoci.CancelUpdates;
    qryFamiliari.CancelUpdates;
    qryRinnovi.CancelUpdates;

    SyncList;
  end;
end;

procedure TFrmSoci.btnAddFamiliareClick(Sender: TObject);
  var antani : integer;
begin

    if ModServ.TblSoci.State in [dsInsert] then
    begin
      antani := StrToInt(TESSERA.text);
      ModServ.TblSoci.Post;
      ModServ.TblSoci.ApplyUpdates;
      ModServ.TblSoci.CommitUpdates;
      ModServ.TblSoci.Locate('TESSERA', antani, []);
      ModServ.TblSoci.Edit;
    end;

    qryFamiliari.Append;
    qryFamiliari.FieldByName('ID_SOCIO').AsInteger :=
      ModServ.TblSoci.FieldByName('ID_SOCIO').AsInteger;
    FamList.SetFocus;
end;

procedure TFrmSoci.btnAddRinnovoClick(Sender: TObject);
  var antani : integer;
begin

    if ModServ.TblSoci.State in [dsInsert] then
    begin
      antani := StrToInt(TESSERA.text);
      ModServ.TblSoci.Post;
      ModServ.TblSoci.ApplyUpdates;
      ModServ.TblSoci.CommitUpdates;
      ModServ.TblSoci.Locate('TESSERA', antani, []);
      ModServ.TblSoci.Edit;
    end;

    qryRinnovi.Append;
    qryRinnovi.FieldByName('ID_SOCIO').AsInteger :=
      ModServ.TblSoci.FieldByName('ID_SOCIO').AsInteger;
    RinnList.SetFocus;
end;

procedure TFrmSoci.btnDelFamiliareClick(Sender: TObject);
begin
    if confirm('Eliminare la riga selezionata?') then
    begin
      qryFamiliari.Delete;
      qryFamiliari.ApplyUpdates;
      qryFamiliari.CommitUpdates;
    end;
end;

procedure TFrmSoci.btnDelRinnovoClick(Sender: TObject);
begin
    if confirm('Eliminare la riga selezionata?') then
    begin
      qryRinnovi.Delete;
      qryRinnovi.ApplyUpdates;
      qryRinnovi.CommitUpdates;
    end;
end;

procedure TFrmSoci.btnExportClick(Sender: TObject);
begin
  GenerateSQL;

  JvDBGridCSVExport1.FileName := JvFilenameEdit1.FileName;
  if JvDBGridCSVExport1.ExportGrid then
    ShowMessage('Esportazione completata')
  else
    ShowMEssage(JvDBGridCSVExport1.LastExceptionMessage);

  ProgressBar1.Position := 0;
end;

procedure TFrmSoci.Button3Click(Sender: TObject);
begin
  GenerateSQL;
end;

procedure TFrmSoci.DBGrid1DblClick(Sender: TObject);
begin
  SyncList;
  pagesoci.ActivePage := tabsoci;
end;

procedure TFrmSoci.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    SyncList;
    pagesoci.ActivePage := tabsoci;
  end;
end;

procedure TFrmSoci.abilita_tab;
begin
  TabGen.Enabled := true;
  TabFamiliari.Enabled := true;
  TabRinnovi.Enabled := true;
end;

procedure TFrmSoci.disabilita_tab;
begin
  TabGen.Enabled := false;
  TabFamiliari.Enabled := false;
  TabRinnovi.Enabled := false;
end;

procedure TFrmSoci.dtsSociListStateChange(Sender: TObject);
begin
  if modserv.TblSoci.State in [dsedit, dsinsert] then
  begin
    sbnew.enabled := false;
    sbedit.enabled := false;
    sbdel.enabled := false;
    sbundo.enabled := true;
    sbsave.enabled := true;
    sbexit.enabled := false;
  end
  else
  begin
    sbnew.enabled := true;
    if modserv.tblsoci.recordcount > 0 then
    begin
      sbedit.enabled := true;
      sbdel.enabled := true;
    end
    else
    begin
      sbedit.enabled := false;
      sbdel.enabled := false;
    end;
    sbundo.enabled := false;
    sbsave.enabled := false;
    sbexit.enabled := true;
  end;
  tot.Caption := inttostr(modserv.tblsoci.recordcount);
end;

procedure TFrmSoci.edSearchKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    acnSearch.Execute;
    Key := #0;
  end;
end;

procedure TFrmSoci.elannoClick(Sender: TObject);
begin
  elinregola.Checked := False;
  elCompleto.Checked := False;
  anno.enabled := True;
  anno.SetFocus;
end;

procedure TFrmSoci.elCompletoClick(Sender: TObject);
begin
  elinregola.Checked := False;
  elanno.Checked := False;
  anno.Text := '';
  anno.enabled := False;
end;

procedure TFrmSoci.elinregolaClick(Sender: TObject);
begin
  elCompleto.Checked := False;
  elanno.Checked := False;
  anno.Text := '';
  anno.enabled := False;
end;

procedure TFrmSoci.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    CloseQry;
end;

procedure TFrmSoci.FormShow(Sender: TObject);
begin
  DISABILITA_TAB;
  qrySoci.Open;
  SyncList;
  JvFilenameEdit1.InitialDir := GetSpecialFolder(CSIDL_DESKTOPDIRECTORY);
  JvFilenameEdit1.FileName := JvFilenameEdit1.InitialDir + '\' +  JvFilenameEdit1.FileName;
end;

procedure TFrmSoci.SyncList;
begin
  ModServ.TblSoci.Locate('id_socio', qrySociId_socio.Value, []);
  GetSocioData(qrySociId_socio.Value);
end;

procedure TFrmSoci.GetSocioData(idsocio: integer);
begin
  qryFamiliari.Close;
  qryGenerica.Close;
  qryRinnovi.Close;
  
  // Cerco l'ultimo rinnovo nella tabella soci_rinnovi
  qrygenerica.ParamByName('ID_SOCIO').Value := idsocio;
  qryGenerica.Open;
  VALIDITA.Text := qryGenerica.FieldByName('anno').AsString;

  If qryGenerica.FieldByName('anno').AsString <> '' then
  begin
  // Se la data dell'ultimo rinnovo corrisponde all'anno corrente
  // allora coloro la cella di verde, altrimenti la faccio rossa
    if strtoint(qryGenerica.FieldByName('anno').AsString) >= YearOf(now) then
    begin
      VALIDITA.Color := clLime;
    end
    else
      VALIDITA.Color := clRed;

  end
  else
    VALIDITA.Color := clBlack;

  qryGenerica.Close;

  // Estraggo i familiari e tutti i rinnovi per l'ID_SOCIO selezionato
  qryFamiliari.ParamByName('ID_SOCIO').Value := idsocio;
  qryRinnovi.ParamByName('ID_SOCIO').Value := idsocio;
  qryFamiliari.Open;
  qryRinnovi.Open;
end;

procedure TFrmSoci.JvDBGridExcelExport1Progress(Sender: TObject; Min, Max,
  Position: Cardinal; const AText: string; var AContinue: Boolean);
begin
  if Position>0 then
  begin
    ProgressBar1.Max := Max;
    ProgressBar1.Position := Position
  end { Progress>0 }
  else
    ProgressBar1.Min := min
end;

procedure TFrmSoci.RefreshQuery;
begin
  CloseQry;
  OpenQry;
end;

procedure TFrmSoci.CloseQry;
begin
  qryFamiliari.Close;
  qryRinnovi.Close;
  qrySoci.Close;
  qryExportSoci.Close;
end;

procedure TFrmSoci.passwordKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if CheckPassword(password.Text,'ADMIN') then
    btnExport.Enabled := True
  else
    btnExport.Enabled := False;
end;

procedure TFrmSoci.OpenQry;
begin
  qryFamiliari.Open;
  qryRinnovi.Open;
  qrySoci.Open;
  qryExportSoci.Open;
end;

procedure TFrmSoci.GenerateSQL;
var
  campiscelti: string;
begin
  qryExportSoci.SQL.Clear;
  qryExportSoci.SQL.Add('SELECT ');
  if chknominativo.Checked then
    campiscelti := campiscelti + 'Nominativo,';
  if chktessera.Checked then
    campiscelti := campiscelti + 'Tessera,';
  if chkindirizzo.Checked then
    campiscelti := campiscelti + 'Indirizzo,';
  if chkcomune.Checked then
    campiscelti := campiscelti + 'Citta,';
  if chkcap.Checked then
    campiscelti := campiscelti + 'CAP,';
  if chkprovincia.Checked then
    campiscelti := campiscelti + 'Prov,';
  if chkluogodinascita.Checked then
    campiscelti := campiscelti + 'luogo_di_nascita,';
  if chkdatadinascita.Checked then
    campiscelti := campiscelti + 'data_di_nascita,';
  if chkcf.Checked then
    campiscelti := campiscelti + 'cf,';
  if chktesseramento.Checked then
    campiscelti := campiscelti + 'data_tesseramento,';
  if chktelefono.Checked then
    campiscelti := campiscelti + 'Telefono,';
  if chkprofessione.Checked then
    campiscelti := campiscelti + 'Professione,';
  if chkprivacy.Checked then
    campiscelti := campiscelti + 'Trattamento_dati,';
  if chkZona.Checked then
    campiscelti := campiscelti + 'Zona,';

  Delete(campiscelti, Length(campiscelti), 1);
  qryExportSoci.SQL.Add(campiscelti);
  qryExportSoci.SQL.Add(' FROM soci');
// SELECT * FROM soci AS o JOIN soci_rinnovi AS c on o.id_socio = c.id_socio
// WHERE c.anno="2000"
  if elanno.Checked then
  begin
    if anno.text <> '' then
    begin
      qryExportSoci.SQL.Add(' AS o JOIN soci_rinnovi AS c on o.id_socio = c.id_socio');
      qryExportSoci.SQL.Add(' WHERE c.anno="' + anno.text + '"');
    end
    else
    begin
      MessageDlg('Devi specificare l''anno di ricerca', mtWarning, [mbOk], 0);
      anno.SetFocus;
      abort;
    end;
  end;

  if elinregola.Checked then
  begin
    qryExportSoci.SQL.Add(' AS o JOIN soci_rinnovi AS c on o.id_socio = c.id_socio');
    qryExportSoci.SQL.Add(' WHERE c.anno="' + IntToStr(yearof(now)) + '"');
  end;

  qryExportSoci.Close;
  qryExportSoci.ExecSQL;
  qryExportSoci.Open;
end;

procedure TFrmSoci.PAGESOCIChanging(Sender: TObject; var AllowChange: Boolean);
begin

  if Modserv.TblSoci.state  in [dsedit, dsinsert] then
  begin
    disabilita_tab;

    //annullamento dell'inserimento
    Modserv.TblSoci.Cancel;
    qryFamiliari.Cancel;
    qryRinnovi.Cancel;

    //cancellazione cache
    ModServ.TblSoci.CancelUpdates;
    qryFamiliari.CancelUpdates;
    qryRinnovi.CancelUpdates;

    SyncList;
  end;

end;


procedure TFrmSoci.rdiNomeClick(Sender: TObject);
begin
  rdiTessera.Checked := False;
end;

procedure TFrmSoci.rdiTesseraClick(Sender: TObject);
begin
  rdiNome.Checked := False;
end;

end.
