object ModServ: TModServ
  OldCreateOrder = True
  OnCreate = ModServCreate
  Height = 519
  Width = 780
  object Database: TDatabase
    AliasName = 'viola_servizi'
    DatabaseName = 'SERV'
    LoginPrompt = False
    Params.Strings = (
      'DATABASE NAME=db_cvc_4'
      'USER NAME='
      'ODBC DSN=viola_servizi'
      'OPEN MODE=READ/WRITE'
      'SCHEMA CACHE SIZE=8'
      'SQLQRYMODE='
      'LANGDRIVER='
      'SQLPASSTHRU MODE=SHARED AUTOCOMMIT'
      'SCHEMA CACHE TIME=-1'
      'MAX ROWS=-1'
      'BATCH COUNT=200'
      'ENABLE SCHEMA CACHE=FALSE'
      'SCHEMA CACHE DIR='
      'ENABLE BCD=FALSE'
      'ROWSET SIZE=20'
      'BLOBS TO CACHE=64'
      'PASSWORD=')
    SessionName = 'Default'
    Left = 24
    Top = 448
  end
  object DsrGestVol: TDataSource
    DataSet = TblGestVol
    Left = 144
    Top = 72
  end
  object TblGestVol: TTable
    CachedUpdates = True
    BeforeClose = DatasetBeforeClose
    DatabaseName = 'SERV'
    DefaultIndex = False
    IndexFieldNames = 'id'
    TableName = 'gestvol'
    UpdateMode = upWhereKeyOnly
    Left = 144
    Top = 8
    object TblGestVolid: TIntegerField
      FieldName = 'id'
      ProviderFlags = [pfInUpdate, pfInWhere, pfInKey]
    end
    object TblGestVolid_posizione: TIntegerField
      FieldName = 'id_posizione'
    end
    object TblGestVoltessera: TIntegerField
      FieldName = 'tessera'
    end
    object TblGestVolcognome: TStringField
      FieldName = 'cognome'
      Required = True
      Size = 30
    end
    object TblGestVolgrado: TStringField
      FieldName = 'grado'
      Required = True
      FixedChar = True
      Size = 2
    end
    object TblGestVolservizio: TIntegerField
      FieldName = 'servizio'
      Required = True
    end
    object TblGestVolaspett: TIntegerField
      FieldName = 'aspett'
      Required = True
    end
    object TblGestVoldae: TStringField
      FieldName = 'dae'
    end
    object TblGestVoldimiss: TIntegerField
      FieldName = 'dimiss'
      Required = True
    end
    object TblGestVolserv_int: TIntegerField
      FieldName = 'serv_int'
    end
    object TblGestVolindisposto: TIntegerField
      FieldName = 'indisposto'
    end
    object TblGestVolnome: TStringField
      FieldName = 'nome'
    end
    object TblGestVolnato_a: TStringField
      FieldName = 'nato_a'
      Size = 50
    end
    object TblGestVolnato_il: TDateField
      FieldName = 'nato_il'
      EditMask = '!99/99/0000;1;_'
    end
    object TblGestVolresidenza: TStringField
      FieldName = 'residenza'
      Size = 50
    end
    object TblGestVolabitazione: TStringField
      FieldName = 'abitazione'
      Size = 50
    end
    object TblGestVolcf: TStringField
      FieldName = 'cf'
    end
    object TblGestVolci: TStringField
      FieldName = 'ci'
    end
    object TblGestVolpatente: TStringField
      FieldName = 'patente'
      Size = 25
    end
    object TblGestVolprofession: TStringField
      FieldName = 'profession'
    end
    object TblGestVoldata_pres: TDateField
      FieldName = 'data_pres'
      EditMask = '!99/99/0000;1;_'
    end
    object TblGestVoldata_acc: TDateField
      FieldName = 'data_acc'
      EditMask = '!99/99/0000;1;_'
    end
    object TblGestVoldata_dim: TDateField
      FieldName = 'data_dim'
      EditMask = '!99/99/0000;1;_'
    end
    object TblGestVolfoto: TBlobField
      FieldName = 'foto'
      Size = 1
    end
    object TblGestVolnote: TMemoField
      FieldName = 'note'
      BlobType = ftMemo
      Size = 1
    end
    object TblGestVolall_ac: TIntegerField
      FieldName = 'all_ac'
    end
    object TblGestVolall_pat: TIntegerField
      FieldName = 'all_pat'
    end
    object TblGestVolall_cf: TIntegerField
      FieldName = 'all_cf'
    end
    object TblGestVolall_ci: TIntegerField
      FieldName = 'all_ci'
    end
    object TblGestVolsesso: TStringField
      FieldName = 'sesso'
      Required = True
      FixedChar = True
      Size = 1
    end
    object TblGestVolstudio: TStringField
      FieldName = 'studio'
      Size = 40
    end
    object TblGestVolsq_fer: TStringField
      FieldName = 'sq_fer'
      FixedChar = True
      Size = 2
    end
    object TblGestVolsq_fes: TStringField
      FieldName = 'sq_fes'
      FixedChar = True
      Size = 2
    end
  end
  object QryAvailable: TQuery
    DatabaseName = 'SERV'
    Left = 336
    Top = 392
  end
  object DsrQryAvaible: TDataSource
    DataSet = QryAvailable
    Left = 336
    Top = 448
  end
  object DsrSq_feriale: TDataSource
    DataSet = TblSq_feriale
    Left = 208
    Top = 72
  end
  object TblSq_feriale: TTable
    DatabaseName = 'SERV'
    TableName = 'sq_feriale'
    Left = 208
    Top = 8
    object TblSq_ferialeid_feriale: TIntegerField
      FieldName = 'id_feriale'
    end
    object TblSq_ferialecod: TStringField
      FieldName = 'cod'
      Required = True
      FixedChar = True
      Size = 2
    end
    object TblSq_ferialesquadra: TStringField
      FieldName = 'squadra'
      Required = True
      FixedChar = True
      Size = 10
    end
  end
  object TblSq_festivi: TTable
    DatabaseName = 'SERV'
    TableName = 'sq_festivi'
    Left = 272
    Top = 8
    object TblSq_festiviid_festivo: TIntegerField
      FieldName = 'id_festivo'
    end
    object TblSq_festivicod: TStringField
      FieldName = 'cod'
      Required = True
      FixedChar = True
      Size = 2
    end
    object TblSq_festivisquadra: TStringField
      FieldName = 'squadra'
      Required = True
      FixedChar = True
      Size = 10
    end
  end
  object dsrSq_festivi: TDataSource
    DataSet = TblSq_festivi
    Left = 272
    Top = 72
  end
  object TblPosizione: TTable
    DatabaseName = 'SERV'
    IndexFieldNames = 'ID_POSIZIONE'
    TableName = 'posizione'
    Left = 344
    Top = 8
    object TblPosizioneID_POSIZIONE: TIntegerField
      FieldName = 'ID_POSIZIONE'
      Required = True
    end
    object TblPosizionecod: TStringField
      FieldName = 'cod'
      Required = True
      FixedChar = True
      Size = 2
    end
    object TblPosizioneposizione: TStringField
      FieldName = 'posizione'
      Required = True
      FixedChar = True
      Size = 15
    end
  end
  object DsrPosizione: TDataSource
    DataSet = TblPosizione
    Left = 344
    Top = 72
  end
  object TblStudio: TTable
    DatabaseName = 'SERV'
    IndexFieldNames = 'studio'
    TableName = 'studio'
    Left = 16
    Top = 8
    object TblStudiocod: TStringField
      FieldName = 'cod'
      Required = True
      FixedChar = True
      Size = 2
    end
    object TblStudiostudio: TStringField
      FieldName = 'studio'
      Required = True
      FixedChar = True
      Size = 40
    end
  end
  object DsrStudio: TDataSource
    DataSet = TblStudio
    Left = 16
    Top = 72
  end
  object TblPassword: TTable
    DatabaseName = 'SERV'
    TableName = 'password'
    Left = 80
    Top = 8
  end
  object dsrPassword: TDataSource
    DataSet = TblPassword
    Left = 80
    Top = 72
  end
  object qryVolunteerList: TQuery
    DatabaseName = 'SERV'
    SQL.Strings = (
      'SELECT id, tessera, cognome, grado'
      'FROM gestvol Gestvol'
      'ORDER BY cognome')
    Left = 424
    Top = 392
    object qryVolunteerListid: TIntegerField
      FieldName = 'id'
      Origin = 'SERV.gestvol.id'
    end
    object qryVolunteerListtessera: TIntegerField
      FieldName = 'tessera'
      Origin = 'SERV.gestvol.tessera'
    end
    object qryVolunteerListcognome: TStringField
      FieldName = 'cognome'
      Origin = 'SERV.gestvol.cognome'
      Size = 30
    end
    object qryVolunteerListgrado: TStringField
      FieldName = 'grado'
      Origin = 'SERV.gestvol.grado'
      FixedChar = True
      Size = 2
    end
  end
  object dtsVolunteerList: TDataSource
    DataSet = qryVolunteerList
    Left = 424
    Top = 448
  end
  object QryFind: TQuery
    DatabaseName = 'SERV'
    Left = 248
    Top = 391
  end
  object DsrQryFind: TDataSource
    DataSet = QryFind
    Left = 248
    Top = 448
  end
  object DsrServizi: TDataSource
    DataSet = TblServizi
    Left = 472
    Top = 72
  end
  object TblServizi: TTable
    CachedUpdates = True
    AutoRefresh = True
    DatabaseName = 'SERV'
    FieldDefs = <
      item
        Name = 'id'
        DataType = ftInteger
      end
      item
        Name = 'num'
        Attributes = [faRequired]
        DataType = ftInteger
      end
      item
        Name = 'tipo'
        Attributes = [faRequired]
        DataType = ftString
        Size = 30
      end
      item
        Name = 'cliente'
        DataType = ftString
        Size = 30
      end
      item
        Name = 'convenzione'
        DataType = ftString
        Size = 20
      end
      item
        Name = 'num118'
        DataType = ftString
        Size = 10
      end
      item
        Name = 'stato'
        DataType = ftString
        Size = 25
      end
      item
        Name = 'luogo'
        DataType = ftString
        Size = 50
      end
      item
        Name = 'luogo_citta'
        DataType = ftString
        Size = 50
      end
      item
        Name = 'motivo'
        DataType = ftString
        Size = 30
      end
      item
        Name = 'destinaz'
        DataType = ftString
        Size = 50
      end
      item
        Name = 'destinaz_citta'
        DataType = ftString
        Size = 50
      end
      item
        Name = 'cs'
        DataType = ftString
        Size = 30
      end
      item
        Name = 'autista'
        DataType = ftString
        Size = 30
      end
      item
        Name = 'milite'
        DataType = ftString
        Size = 30
      end
      item
        Name = 'milite2'
        DataType = ftString
        Size = 30
      end
      item
        Name = 'centralino'
        Attributes = [faRequired]
        DataType = ftString
        Size = 30
      end
      item
        Name = 'ora_posto'
        DataType = ftString
        Size = 8
      end
      item
        Name = 'ora_caric'
        DataType = ftString
        Size = 8
      end
      item
        Name = 'ora_dest'
        DataType = ftString
        Size = 8
      end
      item
        Name = 'ora_lib'
        DataType = ftString
        Size = 8
      end
      item
        Name = 'km'
        DataType = ftInteger
      end
      item
        Name = 'mezzo'
        DataType = ftString
        Size = 5
      end
      item
        Name = 'bolla'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'trasp_a'
        DataType = ftString
        Size = 10
      end
      item
        Name = 'trasp_r'
        DataType = ftString
        Size = 10
      end
      item
        Name = 'data_serv'
        DataType = ftDate
      end
      item
        Name = 'ora_serv'
        DataType = ftString
        Size = 8
      end
      item
        Name = 'ora_part'
        DataType = ftString
        Size = 8
      end
      item
        Name = 'cod_stato'
        DataType = ftInteger
      end
      item
        Name = 'cod_serv'
        DataType = ftInteger
      end
      item
        Name = 'ora_fine'
        DataType = ftString
        Size = 8
      end
      item
        Name = 'note'
        DataType = ftBlob
        Size = 1
      end
      item
        Name = 'deleted'
        DataType = ftInteger
      end
      item
        Name = 'costo'
        DataType = ftFloat
      end
      item
        Name = 'pagato'
        DataType = ftInteger
      end
      item
        Name = 'num_fatt'
        DataType = ftString
        Size = 5
      end
      item
        Name = 'fatturato'
        DataType = ftInteger
      end
      item
        Name = 'riferimenti'
        DataType = ftString
        Size = 50
      end
      item
        Name = 'DAE'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'MSA'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'MSAonB'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'ELI'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'VVF'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'POLIZ'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'VNOTE'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'MSB'
        Attributes = [faRequired]
        DataType = ftString
        Size = 5
      end
      item
        Name = 'bolla2'
        DataType = ftString
        Size = 5
      end>
    StoreDefs = True
    TableName = 'servizi'
    UpdateMode = upWhereChanged
    Left = 472
    Top = 8
    object TblServiziid: TIntegerField
      FieldName = 'id'
    end
    object cccc: TIntegerField
      FieldName = 'num'
      Required = True
    end
    object TblServizitipo: TStringField
      FieldName = 'tipo'
      Required = True
      Size = 30
    end
    object TblServizicliente: TStringField
      FieldName = 'cliente'
      Required = True
      Size = 30
    end
    object TblServizinum118: TStringField
      FieldName = 'num118'
      Size = 10
    end
    object TblServizistato: TStringField
      FieldName = 'stato'
      Required = True
      Size = 25
    end
    object TblServiziluogo: TStringField
      FieldName = 'luogo'
      Required = True
      Size = 50
    end
    object TblServiziluogo_citta: TStringField
      FieldName = 'luogo_citta'
      Required = True
      Size = 50
    end
    object TblServizimotivo: TStringField
      FieldName = 'motivo'
      Required = True
      Size = 30
    end
    object TblServizidestinaz: TStringField
      FieldName = 'destinaz'
      Size = 50
    end
    object TblServizidestinaz_citta: TStringField
      FieldName = 'destinaz_citta'
      Size = 50
    end
    object TblServizics: TStringField
      FieldName = 'cs'
      Size = 30
    end
    object TblServiziautista: TStringField
      FieldName = 'autista'
      Required = True
      Size = 30
    end
    object TblServizimilite: TStringField
      FieldName = 'milite'
      Size = 30
    end
    object TblServizimilite2: TStringField
      FieldName = 'milite2'
      Size = 30
    end
    object TblServizicentralino: TStringField
      FieldName = 'centralino'
      Required = True
      Size = 30
    end
    object TblServiziora_posto: TStringField
      FieldName = 'ora_posto'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblServiziora_caric: TStringField
      FieldName = 'ora_caric'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblServiziora_dest: TStringField
      FieldName = 'ora_dest'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblServiziora_lib: TStringField
      FieldName = 'ora_lib'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblServizikm: TIntegerField
      FieldName = 'km'
      Required = True
    end
    object TblServizimezzo: TStringField
      FieldName = 'mezzo'
      Required = True
      Size = 5
    end
    object TblServizibolla: TStringField
      FieldName = 'bolla'
      Required = True
      Size = 5
    end
    object TblServizitrasp_a: TStringField
      FieldName = 'trasp_a'
      Size = 10
    end
    object TblServizitrasp_r: TStringField
      FieldName = 'trasp_r'
      Size = 10
    end
    object TblServizidata_serv: TDateField
      FieldName = 'data_serv'
      Required = True
    end
    object TblServiziora_serv: TStringField
      FieldName = 'ora_serv'
      Required = True
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblServiziora_part: TStringField
      FieldName = 'ora_part'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblServizicod_stato: TIntegerField
      FieldName = 'cod_stato'
    end
    object c: TIntegerField
      FieldName = 'cod_serv'
    end
    object TblServiziora_fine: TStringField
      FieldName = 'ora_fine'
      Required = True
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblServizideleted: TIntegerField
      FieldName = 'deleted'
    end
    object TblServizipagato: TIntegerField
      FieldName = 'pagato'
    end
    object TblServizinum_fatt: TStringField
      FieldName = 'num_fatt'
      Size = 5
    end
    object TblServizifatturato: TIntegerField
      FieldName = 'fatturato'
    end
    object TblServiziriferimenti: TStringField
      FieldName = 'riferimenti'
      Size = 50
    end
    object TblServiziDAE: TStringField
      FieldName = 'DAE'
      Required = True
      Size = 5
    end
    object TblServiziMSA: TStringField
      FieldName = 'MSA'
      Required = True
      Size = 5
    end
    object TblServiziMSAonB: TStringField
      FieldName = 'MSAonB'
      Required = True
      Size = 5
    end
    object TblServiziELI: TStringField
      FieldName = 'ELI'
      Required = True
      Size = 5
    end
    object TblServiziVVF: TStringField
      FieldName = 'VVF'
      Required = True
      Size = 5
    end
    object TblServiziPOLIZ: TStringField
      FieldName = 'POLIZ'
      Required = True
      Size = 5
    end
    object TblServiziVNOTE: TStringField
      FieldName = 'VNOTE'
      Required = True
      Size = 5
    end
    object TblServiziMSB: TStringField
      FieldName = 'MSB'
      Required = True
      Size = 5
    end
    object TblServizicosto: TFloatField
      FieldName = 'costo'
    end
    object TblServizibolla2: TStringField
      FieldName = 'bolla2'
      Size = 5
    end
    object TblServizinote: TBlobField
      FieldName = 'note'
      Size = 1
    end
  end
  object DsrTrasport: TDataSource
    DataSet = TblTrasport
    Left = 536
    Top = 72
  end
  object TblTrasport: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    IndexFieldNames = 'num'
    MasterFields = 'num'
    MasterSource = DsrServizi
    TableName = 'trasport'
    UpdateMode = upWhereChanged
    Left = 536
    Top = 8
    object TblTrasportid: TIntegerField
      FieldName = 'id'
    end
    object TblTrasportnum: TIntegerField
      FieldName = 'num'
      Required = True
    end
    object TblTrasportnominativo: TStringField
      FieldName = 'nominativo'
      Required = True
      FixedChar = True
      Size = 40
    end
    object TblTrasportindirizzo: TStringField
      FieldName = 'indirizzo'
      Required = True
      FixedChar = True
      Size = 40
    end
    object TblTrasportcap: TIntegerField
      FieldName = 'cap'
    end
    object TblTrasportpaese: TStringField
      FieldName = 'paese'
      Required = True
      FixedChar = True
    end
    object TblTrasportdatan: TDateField
      FieldName = 'datan'
    end
    object TblTrasportsocio: TIntegerField
      FieldName = 'socio'
      Required = True
    end
  end
  object TblOrariDispo: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    IndexFieldNames = 'id'
    TableName = 'oraridispo'
    UpdateMode = upWhereChanged
    Left = 704
    Top = 296
    object TblOrariDispogiorno: TDateField
      FieldName = 'giorno'
      EditMask = '!99/99/00;1;_'
    end
    object TblOrariDispomezzo: TStringField
      FieldName = 'mezzo'
      FixedChar = True
      Size = 5
    end
    object TblOrariDispoconvenzione: TStringField
      FieldName = 'convenzione'
      FixedChar = True
      Size = 5
    end
    object TblOrariDispooperativa: TIntegerField
      FieldName = 'operativa'
      Required = True
    end
    object TblOrariDispoposizione: TStringField
      FieldName = 'posizione'
      Size = 30
    end
    object TblOrariDispoora_inizio: TStringField
      FieldName = 'ora_inizio'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblOrariDispoora_fine: TStringField
      FieldName = 'ora_fine'
      EditMask = '!90:00;1;_'
      Size = 8
    end
  end
  object DsrOrariDispo: TDataSource
    DataSet = qryOrariDispo
    Left = 704
    Top = 448
  end
  object TblPark: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    IndexFieldNames = 'id'
    TableName = 'park'
    UpdateMode = upWhereKeyOnly
    Left = 664
    Top = 8
    object TblParkid: TIntegerField
      FieldName = 'id'
    end
    object TblParkcod_auto: TStringField
      FieldName = 'cod_auto'
      Required = True
      FixedChar = True
      Size = 5
    end
    object TblParktipo: TStringField
      FieldName = 'tipo'
      Required = True
      FixedChar = True
    end
    object TblParkmodello: TStringField
      FieldName = 'modello'
      Required = True
      FixedChar = True
    end
    object TblParktarga: TStringField
      FieldName = 'targa'
      FixedChar = True
      Size = 10
    end
    object TblParkimmatric: TDateField
      FieldName = 'immatric'
      EditMask = '!99/99/0000;1;_'
    end
  end
  object DsrPark: TDataSource
    DataSet = TblPark
    Left = 664
    Top = 72
  end
  object qryMezziActive: TQuery
    CachedUpdates = True
    DatabaseName = 'SERV'
    SQL.Strings = (
      
        'select giorno,mezzo,ora_inizio,ora_fine,operativa,convenzione,ta' +
        'rga,posizione from park join oraridispo on oraridispo.mezzo = pa' +
        'rk.cod_auto where operativa=1 order by giorno')
    Left = 520
    Top = 392
  end
  object dsrMezziActive: TDataSource
    DataSet = qryMezziActive
    Left = 520
    Top = 448
  end
  object TblColonnine: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    TableName = 'colonnine'
    Left = 728
    Top = 8
    object TblColonninecolonnina: TStringField
      FieldName = 'colonnina'
      Required = True
      Size = 35
    end
    object TblColonninecomune: TStringField
      FieldName = 'comune'
      Required = True
      Size = 35
    end
    object TblColonnineid: TIntegerField
      FieldName = 'id'
    end
    object TblColonninelatitudine: TStringField
      FieldName = 'latitudine'
      Size = 10
    end
    object TblColonninelongitudine: TStringField
      FieldName = 'longitudine'
      Size = 10
    end
  end
  object DsrColonnine: TDataSource
    DataSet = TblColonnine
    Left = 728
    Top = 72
  end
  object qryLast10Service: TQuery
    DatabaseName = 'SERV'
    SQL.Strings = (
      
        'SELECT servizi.num,servizi.data_serv,servizi.ora_serv, servizi.t' +
        'ipo, '
      'servizi.cliente, servizi.num118, servizi.motivo,servizi.trasp_a,'
      'servizi.stato,servizi.trasp_r ,servizi.deleted'
      'FROM servizi '
      'order by servizi.num desc limit 0,15')
    Left = 616
    Top = 392
  end
  object dsrLast10Service: TDataSource
    DataSet = qryLast10Service
    Left = 616
    Top = 448
  end
  object qryUpdateMezziActive: TUpdateSQL
    ModifySQL.Strings = (
      'update oraridispo'
      'set'
      '  ora_fine = :ora_fine,'
      '  operativa = :operativa,'
      '  posizione = :posizione'
      'where'
      '  mezzo = :OLD_mezzo and'
      '  operativa = :OLD_operativa')
    InsertSQL.Strings = (
      'insert into oraridispo'
      '  (ora_fine, operativa, posizione)'
      'values'
      '  (:ora_fine, :operativa, :posizione)')
    DeleteSQL.Strings = (
      'delete from oraridispo'
      'where'
      '  mezzo = :OLD_mezzo and'
      '  operativa = :OLD_operativa')
    Left = 520
    Top = 344
  end
  object qryOrariDispo: TQuery
    CachedUpdates = True
    DatabaseName = 'SERV'
    ParamCheck = False
    SQL.Strings = (
      'select * from oraridispo;')
    UpdateObject = qryUpdateOrariDispo
    Left = 704
    Top = 392
    object qryOrariDispoid: TIntegerField
      FieldName = 'id'
      Origin = 'SERV.oraridispo.id'
    end
    object qryOrariDispomezzo: TStringField
      FieldName = 'mezzo'
      Origin = 'SERV.oraridispo.mezzo'
      FixedChar = True
      Size = 5
    end
    object qryOrariDispoora_inizio: TStringField
      FieldName = 'ora_inizio'
      Origin = 'SERV.oraridispo.ora_inizio'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object qryOrariDispoconvenzione: TStringField
      FieldName = 'convenzione'
      Origin = 'SERV.oraridispo.convenzione'
      FixedChar = True
      Size = 5
    end
    object qryOrariDispoora_fine: TStringField
      FieldName = 'ora_fine'
      Origin = 'SERV.oraridispo.ora_fine'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object qryOrariDispooperativa: TIntegerField
      FieldName = 'operativa'
      Origin = 'SERV.oraridispo.operativa'
    end
    object qryOrariDispoposizione: TStringField
      FieldName = 'posizione'
      Origin = 'SERV.oraridispo.posizione'
      Size = 30
    end
    object qryOrariDispogiorno: TDateField
      FieldName = 'giorno'
      Origin = 'SERV.oraridispo.giorno'
      EditMask = '!99/99/00;1;_'
    end
  end
  object qryUpdateOrariDispo: TUpdateSQL
    ModifySQL.Strings = (
      'update oraridispo'
      'set'
      '  mezzo = :mezzo,'
      '  ora_inizio = :ora_inizio,'
      '  ora_fine = :ora_fine,'
      '  convenzione = :convenzione,'
      '  operativa = :operativa,'
      '  posizione = :posizione'
      'where'
      '  id = :OLD_id ')
    InsertSQL.Strings = (
      'insert into oraridispo'
      
        '  (giorno, mezzo, ora_inizio, ora_fine, convenzione, operativa, ' +
        'posizione)'
      'values'
      
        '  (:giorno, :mezzo, :ora_inizio, :ora_fine, :convenzione, :opera' +
        'tiva, :posizione)')
    DeleteSQL.Strings = (
      'delete from oraridispo'
      'where'
      '  id = :OLD_id '
      '')
    Left = 704
    Top = 344
  end
  object DsrModelli: TDataSource
    DataSet = TblModelli
    Left = 16
    Top = 200
  end
  object TblModelli: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    IndexFieldNames = 'id'
    TableName = 'modelli'
    UpdateMode = upWhereChanged
    Left = 16
    Top = 136
    object TblModelliid: TIntegerField
      FieldName = 'id'
    end
    object TblModelliidentificativo: TStringField
      FieldName = 'identificativo'
      Size = 40
    end
    object TblModellinominativo: TStringField
      FieldName = 'nominativo'
      Size = 40
    end
    object b: TStringField
      FieldName = 'indirizzo'
      Size = 40
    end
    object TblModellicap: TIntegerField
      FieldName = 'cap'
    end
    object TblModellipaese: TStringField
      FieldName = 'paese'
      FixedChar = True
    end
    object TblModellimotivo: TStringField
      FieldName = 'motivo'
      Size = 30
    end
    object TblModelliluogo: TStringField
      FieldName = 'luogo'
      Size = 40
    end
    object TblModelliluogo_citta: TStringField
      FieldName = 'luogo_citta'
    end
    object TblModellidestinaz: TStringField
      FieldName = 'destinaz'
      Size = 40
    end
    object TblModellidestinaz_citta: TStringField
      FieldName = 'destinaz_citta'
    end
    object TblModellikm: TIntegerField
      FieldName = 'km'
    end
    object TblModellicosto: TFloatField
      FieldName = 'costo'
    end
    object TblModelliviaggio: TStringField
      FieldName = 'viaggio'
      FixedChar = True
      Size = 10
    end
    object TblModellirichiedente: TStringField
      FieldName = 'richiedente'
      FixedChar = True
      Size = 30
    end
    object TblModelliora_serv: TStringField
      FieldName = 'ora_serv'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblModelliora_fine: TStringField
      FieldName = 'ora_fine'
      EditMask = '!90:00;1;_'
      Size = 8
    end
    object TblModellibolla: TStringField
      FieldName = 'bolla'
      FixedChar = True
      Size = 5
    end
  end
  object DsrCliente: TDataSource
    DataSet = tblCliente
    Left = 80
    Top = 200
  end
  object tblCliente: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    TableName = 'cliente'
    Left = 80
    Top = 136
    object tblClientecod: TIntegerField
      DisplayLabel = 'Cod'
      FieldName = 'cod'
    end
    object tblClienteragsoc: TStringField
      DisplayLabel = 'Ragione sociale'
      FieldName = 'ragsoc'
      Required = True
      FixedChar = True
      Size = 30
    end
    object tblClienteindirizzo: TStringField
      DisplayLabel = 'Indirizzo'
      FieldName = 'indirizzo'
      Required = True
      FixedChar = True
      Size = 30
    end
    object tblClientetelefono: TStringField
      DisplayLabel = 'Telefono'
      FieldName = 'telefono'
      Required = True
      FixedChar = True
      Size = 15
    end
    object tblClientepart_iva: TStringField
      DisplayLabel = 'Partita IVA'
      FieldName = 'part_iva'
      Required = True
      FixedChar = True
    end
    object tblClientefax: TStringField
      DisplayLabel = 'Fac'
      FieldName = 'fax'
      FixedChar = True
      Size = 15
    end
  end
  object DsrOspedali: TDataSource
    DataSet = TblOspedali
    Left = 148
    Top = 200
  end
  object TblOspedali: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    IndexFieldNames = 'id'
    TableName = 'ospedali'
    UpdateMode = upWhereChanged
    Left = 148
    Top = 136
    object TblOspedaliid: TIntegerField
      FieldName = 'id'
    end
    object TblOspedaliospedale: TStringField
      FieldName = 'ospedale'
      Size = 30
    end
    object TblOspedalipaese: TStringField
      FieldName = 'paese'
      Size = 30
    end
    object TblOspedalilatitudine: TStringField
      FieldName = 'latitudine'
      Size = 10
    end
    object TblOspedalilongitudine: TStringField
      FieldName = 'longitudine'
      Size = 10
    end
  end
  object TblCosto: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    IndexFieldNames = 'id'
    StoreDefs = True
    TableName = 'costo'
    UpdateMode = upWhereKeyOnly
    Left = 208
    Top = 136
    object TblCostoid: TIntegerField
      FieldName = 'id'
      ProviderFlags = [pfInUpdate, pfInWhere, pfInKey]
    end
    object TblCostocod: TIntegerField
      FieldName = 'cod'
      ProviderFlags = [pfInUpdate, pfInWhere, pfInKey]
      Required = True
    end
    object TblCostocosto_fisso: TFloatField
      FieldName = 'costo_fisso'
      KeyFields = 'id'
      ProviderFlags = []
      Required = True
      DisplayFormat = #8364' ##,##00.00'
      EditFormat = '00.00'
      Precision = 2
    end
    object TblCostocosto_km: TFloatField
      FieldName = 'costo_km'
      KeyFields = 'id'
      ProviderFlags = []
      DisplayFormat = #8364' ##,##00.00'
      EditFormat = '00.00'
      Precision = 2
    end
    object TblCostosecondo_trasportato: TFloatField
      FieldName = 'secondo_trasportato'
      KeyFields = 'id'
      ProviderFlags = []
      Required = True
      DisplayFormat = #8364' ##,##00.00'
      EditFormat = '00.00'
    end
    object TblCostofermo_macchina: TFloatField
      FieldName = 'fermo_macchina'
      KeyFields = 'id'
      ProviderFlags = []
      Required = True
      DisplayFormat = #8364' ##,##00.00'
      EditFormat = '00.00'
      Precision = 2
    end
    object TblCostoaccompagnatore: TFloatField
      FieldName = 'accompagnatore'
      KeyFields = 'id'
      ProviderFlags = []
      DisplayFormat = #8364' ##,##00.00'
      EditFormat = '00.00'
      Precision = 2
    end
    object TblCostosconto_soci: TIntegerField
      FieldName = 'sconto_soci'
      KeyFields = 'id'
      ProviderFlags = []
      DisplayFormat = '#0 %'
    end
  end
  object DsrCosto: TDataSource
    DataSet = TblCosto
    Left = 208
    Top = 200
  end
  object TblSoci: TTable
    CachedUpdates = True
    DatabaseName = 'SERV'
    IndexFieldNames = 'ID_SOCIO'
    TableName = 'soci'
    Left = 272
    Top = 136
    object TblSociID_SOCIO: TIntegerField
      FieldName = 'ID_SOCIO'
    end
    object TblSociTESSERA: TIntegerField
      FieldName = 'TESSERA'
      Required = True
    end
    object TblSociNOMINATIVO: TStringField
      FieldName = 'NOMINATIVO'
      Required = True
      Size = 40
    end
    object TblSociINDIRIZZO: TStringField
      FieldName = 'INDIRIZZO'
      Required = True
      Size = 50
    end
    object TblSociCAP: TIntegerField
      FieldName = 'CAP'
    end
    object TblSociCITTA: TStringField
      FieldName = 'CITTA'
      Required = True
      Size = 40
    end
    object TblSociPROV: TStringField
      FieldName = 'PROV'
      Required = True
      Size = 2
    end
    object TblSociLUOGO_DI_NASCITA: TStringField
      FieldName = 'LUOGO_DI_NASCITA'
      Required = True
      Size = 40
    end
    object TblSociDATA_DI_NASCITA: TDateField
      FieldName = 'DATA_DI_NASCITA'
      Required = True
    end
    object TblSociCF: TStringField
      FieldName = 'CF'
    end
    object TblSociDATA_TESSERAMENTO: TDateField
      FieldName = 'DATA_TESSERAMENTO'
    end
    object TblSociTRATTAMENTO_DATI: TSmallintField
      FieldName = 'TRATTAMENTO_DATI'
    end
    object TblSociTELEFONO: TStringField
      FieldName = 'TELEFONO'
      Required = True
      Size = 40
    end
    object TblSociPROFESSIONE: TStringField
      FieldName = 'PROFESSIONE'
    end
    object TblSociZONA: TIntegerField
      FieldName = 'ZONA'
    end
  end
  object DsrSoci: TDataSource
    DataSet = TblSoci
    Left = 272
    Top = 200
  end
  object TblGrado: TTable
    DatabaseName = 'SERV'
    IndexFieldNames = 'ID_GRADO'
    TableName = 'grado'
    Left = 408
    Top = 8
    object TblGradoID_GRADO: TIntegerField
      FieldName = 'ID_GRADO'
      Required = True
    end
    object TblGradoCOD: TStringField
      FieldName = 'COD'
      Required = True
      FixedChar = True
      Size = 2
    end
    object TblGradoGRADO: TStringField
      FieldName = 'GRADO'
    end
  end
  object DsrGrado: TDataSource
    DataSet = TblGrado
    Left = 408
    Top = 72
  end
end
