unit dmServizi;

interface

uses
  SysUtils, Classes, DBTables, DB, dmMod;
type
  TdmdServizi = class(TDataModule)
    DsrServizi: TDataSource;
    TblServizi: TTable;
    r: TIntegerField;
    cccc: TIntegerField;
    TblServizitipo: TStringField;
    TblServizicliente: TStringField;
    TblServizinum118: TStringField;
    TblServizistato: TStringField;
    TblServiziluogo: TStringField;
    TblServiziluogo_citta: TStringField;
    TblServizimotivo: TStringField;
    TblServizidestinaz: TStringField;
    TblServizidestinaz_citta: TStringField;
    TblServizics: TStringField;
    TblServiziautista: TStringField;
    TblServizimilite: TStringField;
    TblServizimilite2: TStringField;
    TblServizicentralino: TStringField;
    TblServiziora_posto: TStringField;
    TblServiziora_caric: TStringField;
    TblServiziora_dest: TStringField;
    TblServiziora_lib: TStringField;
    TblServizikm: TIntegerField;
    TblServizimezzo: TStringField;
    TblServizibolla: TStringField;
    TblServizitrasp_a: TStringField;
    TblServizitrasp_r: TStringField;
    TblServizidata_serv: TDateField;
    TblServiziora_serv: TStringField;
    TblServiziora_part: TStringField;
    TblServizicod_stato: TIntegerField;
    c: TIntegerField;
    TblServiziora_fine: TStringField;
    TblServizideleted: TIntegerField;
    TblServizipagato: TIntegerField;
    TblServizinum_fatt: TStringField;
    TblServizifatturato: TIntegerField;
    DsrTipo_serv: TDataSource;
    TblTipo_serv: TTable;
    TblTipo_servtiposerv: TStringField;
    TblTipo_servcod: TIntegerField;
    dsrStato: TDataSource;
    TblStato: TTable;
    TblStatocod: TStringField;
    TblStatostatobolla: TStringField;
    DsrTrasport: TDataSource;
    TblTrasport: TTable;
    TblTrasportid: TIntegerField;
    TblTrasportnum: TIntegerField;
    TblTrasportnominativo: TStringField;
    TblTrasportindirizzo: TStringField;
    TblTrasportcap: TIntegerField;
    TblTrasportpaese: TStringField;
    TblTrasportdatan: TDateField;
    TblTrasportsocio: TIntegerField;
    TblPark: TTable;
    TblParkid: TIntegerField;
    TblParkcod_auto: TStringField;
    TblParktipo: TStringField;
    TblParkmodello: TStringField;
    TblParktarga: TStringField;
    TblParkimmatric: TDateField;
    DsrPark: TDataSource;
    TblModoPart: TTable;
    TblModoPartmodo: TStringField;
    DsrModoPart: TDataSource;
    qryVolActive: TQuery;
    IntegerField1: TIntegerField;
    StringField1: TStringField;
    DsrVolActive: TDataSource;
    TblMod_error: TTable;
    DsrMod_error: TDataSource;
    qrySequence: TQuery;
    DsrSequence: TDataSource;
    QryFind: TQuery;
    DsrQryFind: TDataSource;
    DsrCliente: TDataSource;
    tblCliente: TTable;
    tblClientecod: TIntegerField;
    tblClienteragsoc: TStringField;
    tblClienteindirizzo: TStringField;
    tblClientetelefono: TStringField;
    tblClientepart_iva: TStringField;
    tblClientefax: TStringField;
    TblServiziriferimenti: TStringField;
    qryMezziActive: TQuery;
    qryUpdateMezzi: TUpdateSQL;
    dsrMezziActive: TDataSource;
    TblServiziDAE: TStringField;
    TblServiziMSA: TStringField;
    TblServiziMSAonB: TStringField;
    TblServiziELI: TStringField;
    TblServiziVVF: TStringField;
    TblServiziPOLIZ: TStringField;
    TblServiziVNOTE: TStringField;
    TblServiziMSB: TStringField;
    qryCosto: TQuery;
    dsrCosto: TDataSource;
    TblServizicosto: TFloatField;
    DsrModelli: TDataSource;
    TblModelli: TTable;
    TblModelliid: TIntegerField;
    TblModelliidentificativo: TStringField;
    TblModellinominativo: TStringField;
    TblModelliindirizzo: TStringField;
    TblModellicap: TIntegerField;
    TblModellipaese: TStringField;
    TblModellimotivo: TStringField;
    TblModelliluogo: TStringField;
    TblModelliluogo_citta: TStringField;
    TblModellidestinaz: TStringField;
    TblModellidestinaz_citta: TStringField;
    TblModellikm: TIntegerField;
    TblModellicosto: TFloatField;
    TblModelliviaggio: TStringField;
    TblModellirichiedente: TStringField;
    TblServizibolla2: TStringField;
    TblServizinote: TBlobField;
    TblModelliora_serv: TStringField;
    TblModelliora_fine: TStringField;
    TblModellibolla: TStringField;
    DsrOspedali: TDataSource;
    TblOspedali: TTable;
    TblOspedaliid: TIntegerField;
    TblOspedaliospedale: TStringField;
    TblOspedalipaese: TStringField;
    TblOspedalilatitudine: TStringField;
    TblOspedalilongitudine: TStringField;
    DsrConvenzioni: TDataSource;
    QrySelectConv: TQuery;
    procedure DataModuleCreate(Sender: TObject);

  private
    { Private declarations }
  public
    procedure OpenDatasets;
    procedure CloseDatasets;
  end;

var
  dmdServizi: TdmdServizi;

implementation

{$R *.dfm}

{ TdmdServizi }

 {
TODO  -oMemini -cRefactoring:
Spostare in dmMod in modo da risparmiare memoria ogni volta che apro una scheda
(release 4.5) 

ModPart
Stato
Park
Modelli
Ospedali

Ovviamente poi bisogna correggere tutti linking al datamodule..
}

procedure TdmdServizi.DataModuleCreate(Sender: TObject);
begin
  Name := 'dm_' + Owner.Name;
end;

procedure TdmdServizi.OpenDatasets;
begin
   // Apertura DataSet e Query
   qryVolActive.Open;
   qryMezziActive.Open;
   TblServizi.Active := True;
   TblTipo_serv.Active := True;
   tblCliente.Active := True;
   TblTrasport.Active := True;
   QrySelectConv.Open;

   { Da eliminare e linkare le form a quelli su dmMod
   }
   TblStato.Active := True;
   TblPark.Active := True;
   TblOspedali.Active := True;
   TblMod_error.Active := True;
   TblModoPart.Active := True;

   // Se si sposta questo bisogna cambiare tutte le procedure CopyFromModel()
   TblModelli.Active := True;

end;


procedure TdmdServizi.CloseDatasets;
begin
  // Chiusura DataSet e Query
  qryVolActive.Close;
  qryMezziActive.Close;
  TblServizi.Active := False;
  TblTipo_serv.Active := False;
  TblTrasport.Active := False;
  TblCliente.Active := False;
  TblModelli.Active := False;
  QrySelectConv.Close;

  { Da eliminare e linkare le forma a quelli su dmMod
  }
  TblStato.Active := False;
  TblPark.Active := False;
  TblOspedali.Active := False;
  TblMod_error.Active := False;
  TblModoPart.Active := False;
  // Se si sposta questo bisogna cambiare tutte le procedure CopyFromModel()
  TblModelli.Active := False;

end;


end.
