unit svrFrameGuardiaMed;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, ComCtrls, DBCtrls, Mask, Buttons, dmServizi, untcommon;

type
  TFrameGuardiaMedica = class(TFrame)
    grpEquipaggio: TGroupBox;
    Label21: TLabel;
    Label23: TLabel;
    Label35: TLabel;
    Label39: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label9: TLabel;
    AUTISTA: TDBLookupComboBox;
    MILITE2: TDBLookupComboBox;
    CENTRALINO: TDBLookupComboBox;
    MEZZO: TDBLookupComboBox;
    grpScheda118: TGroupBox;
    Label41: TLabel;
    Label94: TLabel;
    Label3: TLabel;
    Label30: TLabel;
    sbpartenza: TSpeedButton;
    lF5: TLabel;
    Label32: TLabel;
    Label34: TLabel;
    CLIENTE: TDBLookupComboBox;
    ORA_SERV: TDBEdit;
    ORA_PART: TDBEdit;
    grpStatoMezzo: TGroupBox;
    Label8: TLabel;
    lF10: TLabel;
    sblibero: TSpeedButton;
    Label17: TLabel;
    Label31: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    ORA_FINE: TDBEdit;
    POSIZIONE: TComboBox;
    COLONNINA: TDBLookupComboBox;
    grpCosto: TGroupBox;
    COSTO: TDBEdit;
    PAGATO: TDBCheckBox;
    grpNote: TGroupBox;
    Note: TDBRichEdit;
    grpDati: TGroupBox;
    Label13: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    labelCivico: TLabel;
    Label14: TLabel;
    Label19: TLabel;
    sbposto: TSpeedButton;
    lf6: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label40: TLabel;
    luogo_citta: TDBEdit;
    MOTIVO: TDBEdit;
    CIVICO: TEdit;
    RIFERIMENTI: TDBEdit;
    ORA_POSTO: TDBEdit;
    INDIRIZZO: TEdit;
    LUOGO: TDBEdit;
    grpLibero: TGroupBox;
    LabelLibero: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    sbfine: TSpeedButton;
    lf9: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label52: TLabel;
    ORA_LIB: TDBEdit;
    KM: TDBEdit;
    BOLLA: TDBEdit;
    Label18: TLabel;
    STATO: TDBLookupComboBox;
    Label44: TLabel;
    GetMap: TSpeedButton;
    GroupBox1: TGroupBox;
    lblScheda: TLabel;
    constructor CreateWithDM(AOwner: TComponent; d: TdmdServizi);
    procedure sbpartenzaClick(Sender: TObject);
    procedure sbpostoClick(Sender: TObject);
    procedure sbfineClick(Sender: TObject);
    procedure sbliberoClick(Sender: TObject);
    procedure genLuogo(Sender: TObject);
    procedure CleanComboBox(Sender: TObject; var Key: Char);
    procedure GetMapClick(Sender: TObject);
    procedure MEZZOClick(Sender: TObject);
  private
     FdmServizi: TdmdServizi;
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

uses untstrade;

procedure TFrameGuardiaMedica.CleanComboBox(Sender: TObject; var Key: Char);
begin
  if (Key = Chr(vk_Back)) then
     FdmServizi.TblServizi[(Sender as TDBLookupComboBox).DataField] := NULL;
end;

constructor TFrameGuardiaMedica.CreateWithDM(AOwner: TComponent; d: TdmdServizi);
begin
  inherited Create(AOwner);
  FdmServizi := d;
  RedirectFixupReferences(Self, 'dmdServizi', FdmServizi.Name);

    lblScheda.Caption := FdmServizi.TblServizi.FieldByName('NUM').AsString;

end;

procedure TFrameGuardiaMedica.genLuogo(Sender: TObject);
begin
    if (civico.Text <> '') then
    begin
      FdmServizi.TblServizi['Luogo'] := null;
      FdmServizi.TblServizi['Luogo'] := indirizzo.Text + ' N. ' + civico.Text;
    end;
end;

procedure TFrameGuardiaMedica.GetMapClick(Sender: TObject);
begin
      if (luogo_citta.Text = '') or (INDIRIZZO.text = '') then
        begin
          MessageDlg('Inserire un''indirizzo valido.', mtWarning,
          [mbOk], 0);
          Abort;
      end;

     if not Assigned(frmStrade) then
        FrmStrade := Tfrmstrade.create(nil);

     FrmStrade.IndividuaSuMappa(luogo_citta.Text,INDIRIZZO.Text + ' ' + CIVICO.text);
     FrmStrade.Show;
end;

procedure TFrameGuardiaMedica.MEZZOClick(Sender: TObject);
begin
  CambiaTabName((sender as TDBLookupComboBox).Text,
    FdmServizi.tblServizi.FieldByName('NUM').AsString);
end;

procedure TFrameGuardiaMedica.sbfineClick(Sender: TObject);
var   formattedDateTime : string;
begin
  DateTimeToString(formattedDateTime, 't', Time);
  FdmServizi.TblServizi['ORA_LIB'] := formattedDateTime;
  //FdmServizi.TblServizi['ORA_LIB'] := TimeToStr(Time);
end;

procedure TFrameGuardiaMedica.sbliberoClick(Sender: TObject);
var   formattedDateTime : string;
begin
  DateTimeToString(formattedDateTime, 't', Time);
  FdmServizi.TblServizi['ORA_FINE'] := formattedDateTime;
  // FdmServizi.TblServizi['ORA_FINE'] := TimeToStr(Time);
end;

procedure TFrameGuardiaMedica.sbpartenzaClick(Sender: TObject);
var   formattedDateTime : string;
begin
  DateTimeToString(formattedDateTime, 't', Time);
  FdmServizi.TblServizi['ORA_PART'] := formattedDateTime;
  //FdmServizi.TblServizi['ORA_PART'] := TimeToStr(Time);
end;

procedure TFrameGuardiaMedica.sbpostoClick(Sender: TObject);
var   formattedDateTime : string;
begin
  DateTimeToString(formattedDateTime, 't', Time);
  FdmServizi.TblServizi['ORA_POSTO'] := formattedDateTime;
  //FdmServizi.TblServizi['ORA_POSTO'] := TimeToStr(Time);
end;

end.
