unit svrFrameStaziona;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, DBCtrls, ComCtrls, Mask, Buttons, dmServizi, ShlIntf,
  StrTools, ComObj, dmMod, untcommon;

type
  TFrameStaziona = class(TFrame)
    grpEquipaggio: TGroupBox;
    Label35: TLabel;
    Label39: TLabel;
    Label20: TLabel;
    Label22: TLabel;
    Label21: TLabel;
    Label23: TLabel;
    CENTRALINO: TDBLookupComboBox;
    MEZZO: TDBLookupComboBox;
    MILITE: TDBLookupComboBox;
    CS: TDBLookupComboBox;
    MILITE2: TDBLookupComboBox;
    AUTISTA: TDBLookupComboBox;
    grpServizio: TGroupBox;
    Label41: TLabel;
    Label94: TLabel;
    Label3: TLabel;
    Label12: TLabel;
    CLIENTE: TDBLookupComboBox;
    ORA_SERV: TDBEdit;
    MOTIVO: TDBEdit;
    grpFROM: TGroupBox;
    Label13: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    luogo_indirizzo: TDBEdit;
    luogo_citta_indirizzo: TDBEdit;
    luogo_civico_indirizzo: TEdit;
    grpTO: TGroupBox;
    grpFine: TGroupBox;
    Label28: TLabel;
    Label29: TLabel;
    Label18: TLabel;
    Btntrasp: TSpeedButton;
    Label8: TLabel;
    KM: TDBEdit;
    BOLLA: TDBEdit;
    STATO: TDBLookupComboBox;
    ORA_FINE: TDBEdit;
    grpNote: TGroupBox;
    Note: TDBRichEdit;
    grpCosto: TGroupBox;
    COSTO: TDBEdit;
    PAGATO: TDBCheckBox;
    chkTrasportato: TCheckBox;
    RIFERIMENTI: TDBEdit;
    Label14: TLabel;
    destinaz_ospedale_label: TLabel;
    destinaz_ospedale: TDBEdit;
    destinaz_ospedale_comune_label: TLabel;
    destinaz_citta_ospedale: TDBEdit;
    INDIRIZZO: TEdit;
    btnOspedaliTo: TSpeedButton;
    GroupBox1: TGroupBox;
    lblScheda: TLabel;
    SpeedButton15: TSpeedButton;
    constructor CreateWithDM(AOwner: TComponent; d: TdmdServizi);
    procedure chkTrasportatoClick(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure BtntraspClick(Sender: TObject);
    procedure genLuogo(Sender: TObject);
    procedure btnOspedaliToClick(Sender: TObject);
    procedure CleanComboBox(Sender: TObject; var Key: Char);
    procedure MEZZOClick(Sender: TObject);
  private
    FdmServizi: TdmdServizi;
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

uses untCliente, UntTrasportato, untOspedale;

procedure TFrameStaziona.CleanComboBox(Sender: TObject; var Key: Char);
begin
  if (Key = Chr(vk_Back)) then
     FdmServizi.TblServizi[(Sender as TDBLookupComboBox).DataField] := NULL;
end;

procedure TFrameStaziona.chkTrasportatoClick(Sender: TObject);
begin
    if chkTrasportato.Checked <> True then
    begin
      destinaz_ospedale_label.Visible := False;
      destinaz_ospedale.Visible := False;
      destinaz_ospedale_comune_label.Visible := False;
      destinaz_citta_ospedale.Visible := False;
      btnTrasp.Enabled := False;
      btnOspedaliTo.Visible := False;
    end
    else
    begin
      destinaz_ospedale_label.Visible := True;
      destinaz_ospedale.Visible := True;
      destinaz_ospedale_comune_label.Visible := True;
      destinaz_citta_ospedale.Visible := True;
      btnTrasp.Enabled := True;
      btnOspedaliTo.Visible := True;
    end;


end;

constructor TFrameStaziona.CreateWithDM(AOwner: TComponent; d: TdmdServizi);
begin
  inherited Create(AOwner);
  FdmServizi := d;
  RedirectFixupReferences(Self, 'dmdServizi', FdmServizi.Name);

      destinaz_ospedale_label.Visible := False;
      destinaz_ospedale.Visible := False;
      destinaz_ospedale_comune_label.Visible := False;
      destinaz_citta_ospedale.Visible := False;
      btnTrasp.Enabled := False;
      
  lblScheda.Caption := FdmServizi.TblServizi.FieldByName('NUM').AsString;
end;

procedure TFrameStaziona.SpeedButton15Click(Sender: TObject);
begin
  frmCliente := TFrmCliente.createWithDM(self, FdmServizi);
  FdmServizi.tblCliente.Append;
  frmCliente.ShowModal;
  frmCliente.free;
end;

procedure TFrameStaziona.btnOspedaliToClick(Sender: TObject);
begin
  FrmOspedali := TFrmOspedali.createWithDM(self, FdmServizi);
    if (FrmOspedali.ShowModal = mrYes) then
    begin
      FdmServizi.TblServizi['destinaz'] := FdmServizi.TblOSpedali['ospedale'];
      FdmServizi.TblServizi['destinaz_citta'] := FdmServizi.TblOSpedali['paese'];
      bolla.SetFocus;
    end;
  FrmOspedali.free;
end;

procedure TFrameStaziona.BtntraspClick(Sender: TObject);
begin

  Frmcaricato := TFrmCaricato.createWithDM(self, FdmServizi);

  Frmcaricato.showmodal;
  if (FdmServizi.tblTrasport.RecordCount = 1) then
  begin
    btntrasp.Caption := inttostr(FdmServizi.tblTrasport.RecordCount) + ' &Trasportato';
  end
  else
  begin
     btntrasp.Caption := inttostr(FdmServizi.tblTrasport.RecordCount) + ' &Trasportati';
     // CalcolaCosto(self);
  end;
  Frmcaricato.Free;
end;

procedure TFrameStaziona.genLuogo(Sender: TObject);
begin
begin
    if (luogo_civico_indirizzo.Text <> '') then
    begin
      FdmServizi.TblServizi['Luogo'] := null;
      FdmServizi.TblServizi['Luogo'] := indirizzo.Text + ' N. ' + luogo_civico_indirizzo.Text;
    end;
end;
end;


procedure TFrameStaziona.MEZZOClick(Sender: TObject);
begin
  CambiaTabName((sender as TDBLookupComboBox).Text,
    FdmServizi.tblServizi.FieldByName('NUM').AsString);
end;

end.
