unit svrFrameTrasportoAmbu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, DBCtrls, ComCtrls, Mask, Buttons, dmServizi, ShlIntf,
  StrTools, ComObj, dmMod, DB, untcommon;

type
  TFrameTrasportoAmbu = class(TFrame)
    grpEquipaggio: TGroupBox;
    Label35: TLabel;
    Label39: TLabel;
    CENTRALINO: TDBLookupComboBox;
    MEZZO: TDBLookupComboBox;
    grpServizio: TGroupBox;
    Label41: TLabel;
    Label94: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    Label12: TLabel;
    CLIENTE: TDBLookupComboBox;
    ORA_SERV: TDBEdit;
    MOTIVO: TDBEdit;
    grpFine: TGroupBox;
    Label28: TLabel;
    Label29: TLabel;
    labelBolla2pz: TLabel;
    Label18: TLabel;
    Label8: TLabel;
    KM: TDBEdit;
    BOLLA: TDBEdit;
    bolla2pz: TDBEdit;
    STATO: TDBLookupComboBox;
    ORA_FINE: TDBEdit;
    grpNote: TGroupBox;
    Note: TDBRichEdit;
    grpCosto: TGroupBox;
    COSTO: TDBEdit;
    PAGATO: TDBCheckBox;
    Label20: TLabel;
    Label22: TLabel;
    MILITE: TDBLookupComboBox;
    CS: TDBLookupComboBox;
    Label21: TLabel;
    Label23: TLabel;
    MILITE2: TDBLookupComboBox;
    AUTISTA: TDBLookupComboBox;
    grpTO: TGroupBox;
    destinaz_ospedale_label: TLabel;
    destinaz_ospedale_comune_label: TLabel;
    destinaz_indirizzo_label: TLabel;
    destinaz_indirizzo_civico_label: TLabel;
    destinaz_indirizzo_comune_label: TLabel;
    destinaz_citta_ospedale: TDBEdit;
    destinaz_ospedale: TDBEdit;
    rdiToIndirizzo: TRadioButton;
    rdiToOspedale: TRadioButton;
    debug_destinaz: TDBEdit;
    destinaz_indrizzo_civico: TEdit;
    destinaz_indirizzo_comune: TDBEdit;
    destinaz_indirizzo: TEdit;
    grpFROM: TGroupBox;
    luogo_indirizzo_label: TLabel;
    luogo_indirizzo_comune_label: TLabel;
    luogo_indirizzo_civico_label: TLabel;
    luogo_ospedale_label: TLabel;
    luogo_ospedale_comune_label: TLabel;
    luogo_debug: TDBEdit;
    luogo_citta_indirizzo: TDBEdit;
    luogo_indirizzo_civico: TEdit;
    rdiFromIndirizzo: TRadioButton;
    rdiFromOspedale: TRadioButton;
    luogo_ospedale: TDBEdit;
    luogo_citta_ospedale: TDBEdit;
    luogo_indirizzo: TEdit;
    OreFermo: TEdit;
    LabelFermo: TLabel;
    MODELLO: TDBLookupComboBox;
    btnOspedaliFrom: TSpeedButton;
    btnOspedaliTo: TSpeedButton;
    SpeedButton15: TSpeedButton;
    GroupBox1: TGroupBox;
    lblScheda: TLabel;
    nPz1: TRadioButton;
    nPz2: TRadioButton;
    Btntrasp: TSpeedButton;
    constructor CreateWithDM(AOwner: TComponent; d: TdmdServizi);
    procedure rdiFromIndirizzoClick(Sender: TObject);
    procedure rdiFromOspedaleClick(Sender: TObject);
    procedure rdiToIndirizzoClick(Sender: TObject);
    procedure rdiToOspedaleClick(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure BtntraspClick(Sender: TObject);
    procedure genLuogo(Sender: TObject);
    procedure genDestinaz(Sender: TObject);
    procedure CalcolaCosto(Sender: TObject);
    procedure nPz1Click(Sender: TObject);
    procedure nPz2Click(Sender: TObject);
    procedure CopyFromModel(Sender: TObject);
    procedure btnOspedaliFromClick(Sender: TObject);
    procedure btnOspedaliToClick(Sender: TObject);
    procedure CleanComboBox(Sender: TObject; var Key: Char);
    procedure MEZZOClick(Sender: TObject);
  private
    FdmServizi: TdmdServizi;
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

uses untCliente, UntTrasportato, untOspedale;

procedure TFrameTrasportoAmbu.CleanComboBox(Sender: TObject; var Key: Char);
begin
  if (Key = Chr(vk_Back)) then
     FdmServizi.TblServizi[(Sender as TDBLookupComboBox).DataField] := NULL;
end;


constructor TFrameTrasportoAmbu.CreateWithDM(AOwner: TComponent; d: TdmdServizi);
begin
  inherited Create(AOwner);
  FdmServizi := d;
  RedirectFixupReferences(Self, 'dmdServizi', FdmServizi.Name);

  // nascondiamo un p di roBBa ;)
    luogo_ospedale.Visible := False;
    luogo_ospedale_label.Visible := False;
    luogo_citta_ospedale.Visible := False;
    luogo_ospedale_comune_label.Visible := False;

    destinaz_indirizzo_label.Visible := False;
    destinaz_indirizzo.Visible := False;
    destinaz_indirizzo_civico_label.Visible := False;
    destinaz_indrizzo_civico.Visible := False;
    destinaz_indirizzo_comune_label.Visible := False;
    destinaz_indirizzo_comune.Visible := False;

    // se si tratta di CMR
    if (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 7) then
    begin
      nPz1.Visible := false;
      npz2.Visible := false;
      //milite.Enabled := false;
      //milite2.Enabled := false;
    end;

      bolla2pz.Visible := false;
      labelBolla2pz.Visible := false;

    CalcolaCosto(self);

    lblScheda.Caption := FdmServizi.TblServizi.FieldByName('NUM').AsString;

end;


procedure TFrameTrasportoAmbu.CopyFromModel(Sender: TObject);
begin
    if FdmServizi.TblModelli.FieldByName('VIAGGIO').AsString = 'ANDATA' then
    begin
      rdiFromIndirizzoClick(self);
      rdiToOspedaleClick(self);
      rdiFromIndirizzo.Checked := True;
      rdiToOspedale.Checked := True;
      rdiFromOspedale.Checked := False;
      rdiToIndirizzo.Checked := False;
    end
    else
    begin
      rdiFromOspedaleClick(self);
      rdiToIndirizzoClick(self);
      rdiFromIndirizzo.Checked := False;
      rdiToOspedale.Checked := False;
      rdiFromOspedale.Checked := True;
      rdiToIndirizzo.Checked := True;
    end;

    FdmServizi.TblServizi['Cliente'] := FdmServizi.TblModelli['Richiedente'];
    FdmServizi.TblServizi['Luogo'] := FdmServizi.TblModelli['Luogo'];
    if FdmServizi.TblModelli['Luogo'] <> NULL then
      luogo_indirizzo.text := FdmServizi.TblModelli['Luogo'];
    FdmServizi.TblServizi['Luogo_citta'] := FdmServizi.TblModelli['Luogo_citta'];
    FdmServizi.TblServizi['motivo'] := FdmServizi.TblModelli['motivo'];
    FdmServizi.TblServizi['destinaz'] := FdmServizi.TblModelli['destinaz'];
    if FdmServizi.TblModelli['destinaz'] <> NULL then
      destinaz_indirizzo.text := FdmServizi.TblModelli['destinaz'];
    FdmServizi.TblServizi['destinaz_citta'] := FdmServizi.TblModelli['destinaz_citta'];
    FdmServizi.TblServizi['km'] := FdmServizi.TblModelli['km'];
    FdmServizi.TblServizi['ora_fine'] := FdmServizi.TblModelli['ora_fine'];
    FdmServizi.TblServizi['ora_serv'] := FdmServizi.TblModelli['ora_serv'];

    if FdmServizi.TblModelli['bolla'] <> FALSE then
        FdmServizi.TblServizi['bolla'] := '0000'
    else
        FdmServizi.TblServizi['bolla'] := NULL;

    if FdmServizi.TblModelli['indirizzo'] <> NULL then
    begin
      // Faccio pulizia
      FDmServizi.TblTrasport.CancelUpdates;

      FDmServizi.TblTrasport.Insert;

      //abilitazione socio
      FDmServizi.TblTrasport.FieldByName('SOCIO').AsInteger := 0;
      
      if FdmServizi.TblModelli['nominativo'] <> NULL then
        FDmServizi.TblTrasport['nominativo'] := FdmServizi.TblModelli['nominativo']
      else
        FDmServizi.TblTrasport['nominativo'] := 'da inserire';
        
      FDmServizi.TblTrasport['indirizzo'] := FdmServizi.TblModelli['indirizzo'];
      FDmServizi.TblTrasport['cap'] := FdmServizi.TblModelli['cap'];
      FDmServizi.TblTrasport['paese'] := FdmServizi.TblModelli['paese'];

      // Un bel post!
      FDmServizi.TblTrasport.Post;

      if (FdmServizi.tblTrasport.RecordCount = 1) then
        btntrasp.Caption := inttostr(FdmServizi.tblTrasport.RecordCount) + ' &Trasportato'
      else
        btntrasp.Caption := inttostr(FdmServizi.tblTrasport.RecordCount) + ' &Trasportati';
    end;
    
    if FdmServizi.TblModelli['costo'] = 0 then
      calcolacosto(self)
    else
      FdmServizi.TblServizi['costo'] := FdmServizi.TblModelli['costo'];

end;

procedure TFrameTrasportoAmbu.rdiFromIndirizzoClick(Sender: TObject);
begin
    // Paziente caricato a domicilio (indirizzo)
    luogo_indirizzo_civico.Visible := True;
    luogo_indirizzo_civico_label.Visible := True;
    luogo_indirizzo.Visible := True;
    luogo_indirizzo_label.Visible := True;

    luogo_citta_indirizzo.Visible := True;
    luogo_citta_indirizzo.Visible := True;
    luogo_ospedale.Visible := False;
    luogo_ospedale_label.Visible := False;
    luogo_citta_ospedale.Visible := False;
    luogo_ospedale_comune_label.Visible := False;
    btnOspedaliFrom.Visible := False;
    
    stato.Enabled := False;
end;

procedure TFrameTrasportoAmbu.rdiFromOspedaleClick(Sender: TObject);
begin
    // Paziente carico in ospedale

    luogo_indirizzo_civico.Visible := False;
    luogo_indirizzo_civico_label.Visible := False;
    luogo_indirizzo.Visible := False;
    luogo_indirizzo_label.Visible := False;
    luogo_citta_indirizzo.Visible := False;
    luogo_indirizzo_comune_label.Visible := False;

    luogo_ospedale.Visible := True;
    luogo_ospedale_label.Visible := True;
    luogo_citta_ospedale.Visible := True;
    luogo_ospedale_comune_label.Visible := True;
    btnOspedaliFrom.Visible := True;
    
end;

procedure TFrameTrasportoAmbu.rdiToIndirizzoClick(Sender: TObject);
begin
    // Destinazione paziente domicilio (indirizzo)
    destinaz_ospedale_label.Visible := False;
    destinaz_ospedale.Visible := False;
    destinaz_ospedale_comune_label.Visible := False;
    destinaz_citta_ospedale.Visible := False;
    btnOspedaliTo.Visible := False;

    destinaz_indirizzo_label.Visible := True;
    destinaz_indirizzo.Visible := True;
    destinaz_indirizzo_civico_label.Visible := True;
    destinaz_indrizzo_civico.Visible := True;
    destinaz_indirizzo_comune_label.Visible := True;
    destinaz_indirizzo_comune.Visible := True;
end;

procedure TFrameTrasportoAmbu.rdiToOspedaleClick(Sender: TObject);
begin
    // Destinazione paziente ospedale
    destinaz_ospedale_label.Visible := True;
    destinaz_ospedale.Visible := True;
    destinaz_ospedale_comune_label.Visible := True;
    destinaz_citta_ospedale.Visible := True;
    btnOspedaliTo.Visible := True;

    destinaz_indirizzo_label.Visible := False;
    destinaz_indirizzo.Visible := False;
    destinaz_indirizzo_civico_label.Visible := False;
    destinaz_indrizzo_civico.Visible := False;
    destinaz_indirizzo_comune_label.Visible := False;
    destinaz_indirizzo_comune.Visible := False;
end;
procedure TFrameTrasportoAmbu.SpeedButton15Click(Sender: TObject);
begin
  frmCliente := TFrmCliente.createWithDM(self, FdmServizi);
  FdmServizi.tblCliente.Append;
  frmCliente.ShowModal;
  frmCliente.free;
end;

procedure TFrameTrasportoAmbu.btnOspedaliFromClick(Sender: TObject);
begin
  FrmOspedali := TFrmOspedali.createWithDM(self, FdmServizi);
    if (FrmOspedali.ShowModal = mrYes) then
    begin
      FdmServizi.TblServizi['luogo'] := FdmServizi.TblOSpedali['ospedale'];
      FdmServizi.TblServizi['luogo_citta'] := FdmServizi.TblOSpedali['paese'];
    end;
  FrmOspedali.free;
end;

procedure TFrameTrasportoAmbu.btnOspedaliToClick(Sender: TObject);
begin
  FrmOspedali := TFrmOspedali.createWithDM(self, FdmServizi);
    if (FrmOspedali.ShowModal = mrYes) then
    begin
      FdmServizi.TblServizi['destinaz'] := FdmServizi.TblOSpedali['ospedale'];
      FdmServizi.TblServizi['destinaz_citta'] := FdmServizi.TblOSpedali['paese'];
      bolla.SetFocus;
    end;
  FrmOspedali.free;
end;

procedure TFrameTrasportoAmbu.BtntraspClick(Sender: TObject);
begin

  Frmcaricato := TFrmCaricato.createWithDM(self, FdmServizi);

  Frmcaricato.showmodal;
  if (FdmServizi.tblTrasport.RecordCount = 1) then
  begin
    btntrasp.Caption := inttostr(FdmServizi.tblTrasport.RecordCount) + ' &Trasportato';
  end
  else
  begin
     btntrasp.Caption := inttostr(FdmServizi.tblTrasport.RecordCount) + ' &Trasportati';
     // CalcolaCosto(self);
  end;
  Frmcaricato.Free;
end;

procedure TFrameTrasportoAmbu.genLuogo(Sender: TObject);
begin
    if luogo_indirizzo_civico.text <> '' then
    begin
      FdmServizi.TblServizi['Luogo'] := null;
      FdmServizi.TblServizi['Luogo'] := luogo_indirizzo.Text + ' N. ' + luogo_indirizzo_civico.Text;
    end;
end;

procedure TFrameTrasportoAmbu.MEZZOClick(Sender: TObject);
begin
  CambiaTabName((sender as TDBLookupComboBox).Text,
    FdmServizi.tblServizi.FieldByName('NUM').AsString);
end;

procedure TFrameTrasportoAmbu.nPz1Click(Sender: TObject);
begin
    nPz2.Checked := False;
    labelBolla2pz.Visible := False;
    bolla2pz.Visible := False;
    labelBolla2pz.Enabled := False;
    bolla2pz.Enabled := False;
end;

procedure TFrameTrasportoAmbu.nPz2Click(Sender: TObject);
begin
    nPz1.Checked := False;
    labelBolla2pz.Visible := true;
    bolla2pz.Visible := true;
    labelBolla2pz.Enabled := true;
    bolla2pz.Enabled := true;
end;

procedure TFrameTrasportoAmbu.genDestinaz(Sender: TObject);
begin
    if destinaz_indrizzo_civico.text <> '' then
    begin
      FdmServizi.TblServizi['destinaz'] := null;
      FdmServizi.TblServizi['destinaz'] := destinaz_indirizzo.Text + ' N. ' + destinaz_indrizzo_civico.Text;
    end;
end;

procedure TFrameTrasportoAmbu.CalcolaCosto(Sender: TObject);
var
  costo_fisso: double;
  costo_km: double;
  totale: double;
  secondo_trasportato: double;
  accompagnatore: double;
  fermo_macchina: double;
  sconto_soci: integer;
  km: Integer;

begin

  // Workaround, a volte quando distruggo la form scatta l'evento onexit
  // che mi porta nella procedura CalcolaCosto quando il dataset  gi chiuso
  if not(FdmServizi.TblServizi.State in [dsedit, dsinsert]) then
    exit;

  Fdmservizi.qryCosto.ParamByName('codiceserv').Value :=
    FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger;

  Fdmservizi.qryCosto.Open;

  costo_fisso := Fdmservizi.qryCosto.FieldByName('costo_fisso').AsFloat;
  costo_km := Fdmservizi.qryCosto.FieldByName('costo_km').AsFloat;
  secondo_trasportato := Fdmservizi.qryCosto.FieldByName('secondo_trasportato').asFloat;
  //accompagnatore := Fdmservizi.qryCosto.FieldByName('accompagnatore').AsFloat;
  fermo_macchina := Fdmservizi.qryCosto.FieldByName('fermo_macchina').AsFloat;
  sconto_soci :=  Fdmservizi.qryCosto.FieldByName('sconto_soci').AsInteger;

  Fdmservizi.qryCosto.Close;

  totale := costo_fisso;

  if (FdmServizi.TblTipo_serv.FieldByName('Cod').AsInteger = 5) then
  begin
   if (FdmServizi.TblServizi.FieldByName('km').AsInteger > 15) then
    begin
     km := FdmServizi.TblServizi.FieldByName('km').AsInteger - 15;
     totale := totale + km * costo_km;
    end;

    if (npz2.Checked) then
    begin
      totale := totale + secondo_trasportato;
    end;

    if (StrToFloat(OreFermo.Text) <> 0) then
      totale := totale + fermo_macchina * StrToFloat(OreFermo.Text);
  end
  else
  begin
      if (StrToFloat(OreFermo.Text) <> 0) then
        totale := totale + fermo_macchina * StrToFloat(OreFermo.Text);
  end;

  if (FdmServizi.TblModelli['costo'] = 0) then
    FdmServizi.TblServizi['COSTO'] := totale;

end;


end.
