{*************************************************************************
  This file is a part of "Registro Servizi" program.
  Copyright  2005-2008 P.A. Croce Viola Cesate.  All rights reserved.

  "Registro Servizi" is distributed under a BSD-style license, for details,
  see the file LICENSE.

  Version 4.5

**************************************************************************}

{*************************************************************************
  TODO 0 -oMemini -cFeaturing : Rilascio release 4.0

  RELEASE 4.0
- (FATTO) Multiservizio
  Ovvero far aprire tutte le schede missione in una TAB;

- (FATTO) Template schede che cambia in base al servizio

- (FATTO) Preset per i trasporti

- (FATTO) Inserire la possibilt di visualizzare completamente
  le ultime 10 missioni registrate (solo visualizzazione no modifica);
  Magari l'elenco mostra soltando determinati campi, con un doppio click si apre
  una form dove ci sono i dettagli del servizio

- (FATTO) Inserire la form per gestire gli orari di disponibilit mezzo

- (FATTO) RSS
  Inserire il supporto per un rss reader.

}

{ TODO 0 -oMemini -cFeaturing : Rilascio Release 4.5

  RELEASE 4.5

  - Motore di ricerca strade (si appoggia a google maps)

  - (FATTO) Soci
    Integrare il programma gestione soci

  - (Meglio di no) Valutare se inserire una dialog di conferma quando si apre
     una nuova missione

  - Inserire una parte di amministrazione dove si pu mantenere il database
    con operazioni del tipo:
  * (FATTO) Effettuare un dump del DB in formato SQL (txt)
  * (FATTO) Reinizializzare il DB (truncate delle tabelle: servizi, trasport e sequence)
  * (FATTO) Modificare determinati parametri (costi servizi / colonnine / ospedali / etc)

  - (FATTO) Bugfixing vario

}

{ TODO 0 -oMemini -cFeaturing : Rilascio Release 5

  RELEASE 5

  - Sviluppare tutte le parti che ora referenziano NotImplemented()

  - Gestione esquipaggio in servizio con orari

  - Migliorare la sezione untoraridispo (integrare con sopra)

  - Spostare in un thread esterno il parsing degli RSS

  - Rivedere il "calcola costo" per calcolare lo sconto soci

  - Pulizia del codice;

  - Ottimizzazzione utilizzo risorse (valutare se spostare alcuni dataset su dmMod
    cosi' da utilizzarli in comune tra la verie form (per i listsource)

  - Motore di ricerca coordiante ortelio da integrare in untmappe

}

{ TODO 0 -oMemini -cFeaturing : Rilascio Release 6

  RELEASE 6

  - Sostituzione BDE con le zeoslib o altro di meglio!
  - Riattivare le transazione ? (ok anche se dopo)

**************************************************************************}
unit untAuto;

interface

uses
  Windows, Messages, sysutils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolWin, ComCtrls, Menus, Buttons, ExtCtrls, StdCtrls, DBCtrls, ImgList,
  shellapi, jpeg, XPMan, ActnList, ButtonGroup, DB, DBTables, JvComponentBase,
  JvMergeManager, JvExExtCtrls, JvExtComponent, JvClock, JvBaseDlg,
  JvJVCLAboutForm; //  FMXUtils ;

type
  TFrmAuto = class(TForm)
    mnuMain: TMainMenu;
    About1: TMenuItem;
    Uscita1: TMenuItem;
    SB: TStatusBar;
    imlMain: TImageList;
    Help1: TMenuItem;
    XPManifest: TXPManifest;
    aclMain: TActionList;
    acnNewMission: TAction;
    acnServiceList: TAction;
    acnVolunteerList: TAction;
    acnSearch: TAction;
    acnVolunteerMgmt: TAction;
    acnAssociates: TAction;
    acnCalc: TAction;
    Panel1: TPanel;
    ButtonGroup1: TButtonGroup;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Nuovamissione1: TMenuItem;
    Listavolontari1: TMenuItem;
    Elencoservizi1: TMenuItem;
    Gestionevolontari1: TMenuItem;
    Soci1: TMenuItem;
    Calcolatrice1: TMenuItem;
    N1: TMenuItem;
    JvMergeManager1: TJvMergeManager;
    TabControl1: TTabControl;
    acnDispoMezzi: TAction;
    JvClock1: TJvClock;
    acnModelli: TAction;
    GestioneModelli1: TMenuItem;
    DisponibiltMezzi1: TMenuItem;
    ools1: TMenuItem;
    Ricerche2: TMenuItem;
    oggi: TLabel;
    Impostazioni: TMenuItem;
    acnNotImplemented: TAction;
    Amministrazione1: TMenuItem;
    ReinizializzaDB: TMenuItem;
    acnNotImplemented1: TMenuItem;
    acnImpostazioni: TAction;
    RicercaStrade1: TMenuItem;
    TrovaSede: TMenuItem;
    acnMappa: TAction;
    TrovaColonnina1: TMenuItem;
    TrovaOspedale1: TMenuItem;
    ApriMappa: TMenuItem;
    AcnTrovaSede: TAction;
    AcnMangeDB: TAction;
    procedure acnCalcExecute(Sender: TObject);
    procedure acnAssociatesExecute(Sender: TObject);
    procedure acnVolunteerMgmtExecute(Sender: TObject);
    procedure acnVolunteerListExecute(Sender: TObject);
    procedure acnSearchExecute(Sender: TObject);
    procedure acnServiceListExecute(Sender: TObject);
    procedure acnNewMissionExecute(Sender: TObject);
    procedure acnDisponibMezziExecute(Sender: TObject);
    procedure BtnquitClick(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Arrange1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Uscita1Click(Sender: TObject);
    procedure BtnFindClick(Sender: TObject);
    procedure BtnVolontariClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure acnModelliExecute(Sender: TObject);
    procedure JvClock1Alarm(Sender: TObject);
    procedure acnNotImplementedExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acnImpostazioniExecute(Sender: TObject);
    procedure acnMappaExecute(Sender: TObject);
    procedure AcnTrovaSedeExecute(Sender: TObject);
    procedure AcnMangeDBExecute(Sender: TObject);
    procedure acnNotImplemented1Click(Sender: TObject);
  private
    procedure PopolateMenuMappe;
    procedure LocalizzaColonnina(Sender: TObject);
    procedure LocalizzaOspedale(Sender: TObject);
  public
    { Public declarations }
  end;

var
  FrmAuto: TFrmAuto;

implementation

uses UntServizi, dmMod, UntAbout, UntFind, untRicercaPersonale, UntDispoMezzi,
  UntElServ, UntPassword, UntGestionePersonale, UntMain, UntModelli, untimpostazioni,
  untSoci, untstrade, untcommon, untDBDump, untchangepassword;

ResourceString
  NoChiudere = 'Impossibile chiudere il programma quando ci sono delle missioni attive';
  CoordError = 'Coordinate non valide, impossibile continuare';

{$R *.DFM}

procedure TFrmAuto.BtnquitClick(Sender: TObject);
begin
  FrmAuto.Close;
end;

procedure TFrmAuto.TabControl1Change(Sender: TObject);
begin
  JvMergeManager1.GotoForm(TForm(TabControl1.Tabs.Objects[
  tabcontrol1.TabIndex]));
end;

procedure TFrmAuto.Tile1Click(Sender: TObject);
begin
  tile;
end;

procedure TFrmAuto.LocalizzaColonnina(Sender: TObject);
  var  MyCoordinate : TCoordinate;
begin

       MyCoordinate := GetCoordinate('colonnine','colonnina',
       StringReplace((sender as TMenuItem).Caption,'&','',[rfReplaceAll, rfIgnoreCase]));

       if (MyCoordinate[1] = '') or(MyCoordinate[2] = '') then
       begin
        MessageDlg(CoordError,mtWarning, [mbOk], 0);
       end
       else
       begin
        if not Assigned(frmStrade) then
          FrmStrade := Tfrmstrade.create(nil);
        FrmStrade.IndividuaCoordinate(MyCoordinate[1],MyCoordinate[2]);
        FrmStrade.Show;
       end;
end;

procedure TFrmAuto.LocalizzaOspedale(Sender: TObject);
  var  MyCoordinate : TCoordinate;
begin

       MyCoordinate := GetCoordinate('ospedali','ospedale',
       StringReplace((sender as TMenuItem).Caption,'&','',[rfReplaceAll, rfIgnoreCase]));

       if (MyCoordinate[1] = '') or(MyCoordinate[2] = '') then
       begin
        MessageDlg(CoordError,mtWarning, [mbOk], 0);
       end
       else
       begin
        if not Assigned(frmStrade) then
          FrmStrade := Tfrmstrade.create(nil);
        FrmStrade.IndividuaCoordinate(MyCoordinate[1],MyCoordinate[2]);
        FrmStrade.Show;
       end;
end;

procedure TFrmAuto.PopolateMenuMappe;
var
  mi: TMenuItem;
begin
  ModServ.QryFind.SQL.Clear;
  ModServ.QryFind.SQL.Add('select colonnina from colonnine order by colonnina');
  ModServ.QryFind.Open;
  ModServ.QryFind.First;
  while not (ModServ.QryFind.Eof) do
  begin
    mi := TMenuItem.Create(mnuMain);
    mi.Caption := CapitaliseString(ModServ.QryFind.FieldByName('colonnina').AsString, True);
    mi.OnClick := LocalizzaColonnina;
    TrovaColonnina1.Add(mi);
    ModServ.QryFind.Next;
  end;
  ModServ.QryFind.Close;
  ModServ.QryFind.SQL.Clear;
  ModServ.QryFind.SQL.Add('select ospedale from ospedali order by ospedale');
  ModServ.QryFind.Open;
  ModServ.QryFind.First;
  while not (ModServ.QryFind.Eof) do
  begin
    mi := TMenuItem.Create(mnuMain);
    mi.Caption := CapitaliseString(ModServ.QryFind.FieldByName('ospedale').AsString, True);
    mi.OnClick := LocalizzaOspedale;
    TrovaOspedale1.Add(mi);
    ModServ.QryFind.Next;
  end;
  ModServ.QryFind.Close;
  ModServ.QryFind.SQL.Clear;
end;

procedure TFrmAuto.acnNotImplemented1Click(Sender: TObject);
begin
  FrmChangePassword.ShowModal;
end;

procedure TFrmAuto.acnNotImplementedExecute(Sender: TObject);
begin
  NotImplemented
end;

procedure TFrmAuto.Arrange1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TFrmAuto.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TFrmAuto.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin

if  TabControl1.Tabs.Count > 1 then
begin
CanClose := False;
MessageDlg(NoChiudere,
   mtError, [mbCancel], 0);
end;

end;

procedure TFrmAuto.FormCreate(Sender: TObject);
begin
  ModServ.OpenDatasets;
  PopolateMenuMappe;
  
  if (GetConfString('OPTIONS','NOME ASSOCIAZIONE') <> '') then
      FrmAuto.Caption := FrmAuto.Caption + ' - ' + GetConfString('OPTIONS','NOME ASSOCIAZIONE');
      SB.Panels[0].Text := GetConfString('OPTIONS','NOME ASSOCIAZIONE');
end;

procedure TFrmAuto.FormDestroy(Sender: TObject);
 var
  LItem: TCollectionItem;
begin
  for LItem in ButtonGroup1.Items do
    TGrpButtonItem(LItem).Action := nil;

  if Assigned(frmStrade) then
    FrmStrade.Free;

  ModServ.CloseDatasets;
end;

procedure TFrmAuto.FormShow(Sender: TObject);
begin
  TabControl1.tabs.AddObject('Principale', FrmMain);
  jvmergemanager1.Merge(FrmMain, true);
  Oggi.Caption := FormatDateTime('dd/mm/yyyy', date);
end;

procedure TFrmAuto.JvClock1Alarm(Sender: TObject);
begin
    Oggi.Caption := FormatDateTime('dd/mm/yyyy', date);
end;

procedure TFrmAuto.About1Click(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TFrmAuto.Uscita1Click(Sender: TObject);
begin
  frmAuto.Close;
end;

procedure TFrmAuto.BtnFindClick(Sender: TObject);
begin
  // APERTURA FRMFIND
  ModServ.QryFind.Active := false;
  FrmFind.ShowModal;
end;

procedure TFrmAuto.BtnVolontariClick(Sender: TObject);
begin
  FrmVolontari.ShowModal;
end;

procedure TFrmAuto.acnNewMissionExecute(Sender: TObject);
begin
  FrmServizi := nil;

  try
    FrmServizi := TfrmServizi.Create(Self);

    TabControl1.tabs.AddObject('Nuova Missione (' + IntToStr(frmServizi.getNumeroScheda()) + ')', FrmServizi); 
    TabControl1.TabIndex := tabcontrol1.Tabs.Count - 1;
    //visualizzazione form dati nel tab
    jvmergemanager1.Merge(FrmServizi, true);
  Except
    Exit;
  end;
end;

procedure TFrmAuto.acnServiceListExecute(Sender: TObject);
begin
  //password
  { TODO 1 -oLDS -cRefactoring : Change this obscene way to set a flag... }
  modServ.App := 'ELSERV';
  if FrmPassword.ShowModal = mrOk then
  begin
    if modServ.Chiave then
      FrmElServ.ShowModal;
  end;
  modServ.App := '';
end;

procedure TFrmAuto.AcnTrovaSedeExecute(Sender: TObject);
begin
        if not Assigned(frmStrade) then
          FrmStrade := Tfrmstrade.create(nil);
        FrmStrade.acnTrovaSedeExecute(nil);
        FrmStrade.Show;
end;

procedure TFrmAuto.acnSearchExecute(Sender: TObject);
begin
  // APERTURA FRMFIND
  ModServ.QryFind.Active := false;
  FrmFind.ShowModal;
end;

procedure TFrmAuto.acnVolunteerListExecute(Sender: TObject);
begin
  FrmVolontari := TFrmVolontari.Create(self);
  FrmVolontari.ShowModal;
  FrmVolontari.Free;
end;

procedure TFrmAuto.acnVolunteerMgmtExecute(Sender: TObject);
begin
  { TODO 1 -oLDS -cRefactoring : Change this obscene way to set a flag... }
  modServ.App := 'GESTVOL';
  if FrmPassword.showModal = mrOk then
  begin
    if modServ.Chiave then
      FrmInsertVol.showmodal;
  end;
  modServ.App := '';
end;

procedure TFrmAuto.acnDisponibMezziExecute(Sender: TObject);
begin
  FrmDispoMezzi.ShowModal;
  FrmMain.RefreshQuery;
end;

procedure TFrmAuto.acnImpostazioniExecute(Sender: TObject);
begin
     FrmImpostazioni := TFrmImpostazioni.Create(self);
     FrmImpostazioni.Showmodal;
     FrmImpostazioni.Free;
end;

procedure TFrmAuto.AcnMangeDBExecute(Sender: TObject);
begin
  FrmDBDump := TFrmDBDump.Create(self);
  FrmDBDump.ShowModal;
  FrmDBDump.Free;
end;

procedure TFrmAuto.acnMappaExecute(Sender: TObject);
begin
  if not Assigned(frmStrade) then
    FrmStrade := Tfrmstrade.create(nil);
  FrmStrade.Show;
end;

procedure TFrmAuto.acnModelliExecute(Sender: TObject);
begin
  FrmModelli.ShowModal;
end;

procedure TFrmAuto.acnAssociatesExecute(Sender: TObject);
begin
  FrmSoci := TFrmSoci.Create(self);
  FrmSoci.ShowModal;
  FrmSoci.Free;
end;

procedure TFrmAuto.acnCalcExecute(Sender: TObject);
begin
  ShellExecute(frmAuto.Handle, 'open', 'calc.exe', nil, nil,
    SW_SHOWNORMAL);
end;

end.

