unit untDispoMezzi;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, dmMod, Grids, DBGrids, JvDBUltimGrid, JvExDBGrids,
  JvDBGrid, Mask, DBCtrls, ComCtrls, JvExComCtrls, JvDateTimePicker,
  JvDBDateTimePicker, JvExMask, JvToolEdit, JvMaskEdit, JvCheckedMaskEdit,
  JvDatePickerEdit, ExtCtrls, ActnList, db, Buttons, ImgList, DateUtils,
  JvExStdCtrls, JvHtControls, JvDBHTLabel, untcommon;

type
  TfrmDispoMezzi = class(TForm)
    aclDispo: TActionList;
    acnNew: TAction;
    acnDelete: TAction;
    acnUndo: TAction;
    acnSave: TAction;
    imlTransported: TImageList;
    btnNew: TSpeedButton;
    btnDelete: TSpeedButton;
    btnUndo: TSpeedButton;
    btnSave: TSpeedButton;
    btnModifica: TSpeedButton;
    acnModify: TAction;
    Label6: TLabel;
    Label5: TLabel;
    Panel1: TPanel;
    Settimana_da: TLabel;
    settimana_al: TLabel;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    elenco: TDBGrid;
    setday: TJvDateTimePicker;
    grpConvenzione: TDBRadioGroup;
    grpPartenza: TGroupBox;
    Label17: TLabel;
    rdiColonnina: TRadioButton;
    rdiSede: TRadioButton;
    COLONNINA: TDBLookupComboBox;
    grpOrari: TGroupBox;
    Label11: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MEZZO: TDBLookupComboBox;
    ora_inizio: TDBEdit;
    ora_fine: TDBEdit;
    Giorno: TJvDBDateTimePicker;
    sbExit: TSpeedButton;
    acnClose: TAction;
    rdiFine: TDBCheckBox;
    procedure btnChiudiClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure rdiColonninaClick(Sender: TObject);
    procedure rdiSedeClick(Sender: TObject);
    procedure acnBackExecute(Sender: TObject);
    procedure acnDeleteUpdate(Sender: TObject);
    procedure acnNewUpdate(Sender: TObject);
    procedure acnSaveUpdate(Sender: TObject);
    procedure acnSaveExecute(Sender: TObject);
    procedure acnUndoExecute(Sender: TObject);
    procedure acnDeleteExecute(Sender: TObject);
    procedure acnNewExecute(Sender: TObject);
    //procedure rdiInizioClick(Sender: TObject);
    procedure rdiFineClick(Sender: TObject);
    procedure acnModifyExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure elencoDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SetWeek(Sender: Tobject);
    procedure acnCloseExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDispoMezzi: TfrmDispoMezzi;

implementation

{$R *.dfm}


procedure TfrmDispoMezzi.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // bho
end;


procedure TfrmDispoMezzi.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    if ModServ.qryOrariDispo.State in [dsInsert,dsEdit] then
      btnChiudiClick(self);
    close;
end;

procedure TfrmDispoMezzi.FormShow(Sender: TObject);
  var
  today, inizio_sett : TDateTime;
  TodayOfWeek : TdateTime;
  queryday, query: string;
  begin
    setday.date := date;
    Giorno.date := date;
    
    ModServ.qryOrariDispo.SQL.Clear;
    query := 'SELECT * FROM oraridispo WHERE GIORNO between ("';
    grpOrari.Enabled := False;
    grpPartenza.Enabled := False;
    grpConvenzione.Enabled := False;

    btnDelete.Enabled := True;
    btnModifica.Enabled := True;
    btnNew.Enabled := True;
    btnUndo.Enabled := False;
    btnSave.Enabled := False;


    //ora_inizio.Enabled := False;
    ora_fine.Enabled := False;

    //rdiInizio.Checked := False;
    rdiFine.Checked := False;

    today := date;
    TodayOfWeek := DayOfTheWeek(today);
    inizio_sett := (today - TodayOfWeek) + 1;
    queryday := FormatDateTime('dd/mm/yyyy', inizio_sett);
    query := query + FormatDateTime('yyyy-mm-dd', inizio_sett) + '") and ("';
    settimana_da.caption := 'Settimana dal ' + queryday;

    queryday :=FormatDateTime('dd/mm/yyyy', inizio_sett + 6);
    query := query + FormatDateTime('yyyy-mm-dd', inizio_sett + 6)+ '")';
    settimana_al.caption := 'al ' + queryday;

    // Per Mysql FormatDateTime('yyyy-mm-dd', inizio_sett);
    ModServ.qryOrariDispo.SQL.Add(query);
    ModServ.qryOrariDispo.Active := False;
    ModServ.qryOrariDispo.ExecSQL;
    ModServ.qryOrariDispo.Active := True;

end;

procedure TfrmDispoMezzi.rdiColonninaClick(Sender: TObject);
begin
    colonnina.Enabled := True;
    ModServ.qryOrariDispo['posizione'] := NULL;
end;

procedure TfrmDispoMezzi.rdiFineClick(Sender: TObject);
begin
    if ModServ.qryOrariDispo.State in [dsEdit, dsInsert] then
    begin

    if rdiFine.State = cbChecked then
    begin

      ora_fine.Enabled := true;

      ModServ.qryOrariDispo.FieldByName('operativa').Value := 0;
      ModServ.qryOrariDispo['posizione'] := NULL;

      //if ModServ.qryOrariDispo['ORA_FINE'] = NULL then
      // Questo l'ho dovuto commentare a causa del bug delle odbc, quado faccio
      // faccio la insert a mano non riesco a settare il campo a NULL
      ModServ.qryOrariDispo.FieldByName('ORA_FINE').Value := TimeToStr(Time);
    end
    else
    begin
      rdiFine.State := cbUnchecked;
      ora_fine.Enabled := False;
      ModServ.qryOrariDispo.FieldByName('ORA_FINE').Value := NULL;
      ModServ.qryOrariDispo.FieldByName('posizione').Value := 'SEDE';
    end;

    end;
end;


//procedure TfrmDispoMezzi.rdiInizioClick(Sender: TObject);
//begin
//    if ModServ.qryOrariDispo.State in [dsEdit, dsInsert] then
//    begin
//    ora_inizio.Enabled := True;
//    ModServ.qryOrariDispo.FieldByName('operativa').Value := 1;
//
//    if ModServ.qryOrariDispo['ORA_INIZIO'] = NULL then
//      ModServ.qryOrariDispo.FieldByName('ORA_INIZIO').Value := TimeToStr(Time);
//    end;
//end;

procedure TfrmDispoMezzi.rdiSedeClick(Sender: TObject);
begin
    colonnina.Enabled := False;
    ModServ.qryOrariDispo.FieldByName('posizione').Value := 'SEDE';
end;

procedure TfrmDispoMezzi.acnNewExecute(Sender: TObject);
begin
  ModServ.qryOrariDispo.Append;
  Giorno.Date := date;

  ModServ.qryOrariDispo.FieldByName('convenzione').Value := 'EST';
  ModServ.qryOrariDispo.FieldByName('posizione').Value := 'SEDE';
  if ModServ.qryOrariDispo['ORA_INIZIO'] = NULL then
      ModServ.qryOrariDispo.FieldByName('ORA_INIZIO').Value := TimeToStr(Time);
      
  grpOrari.Enabled := True;
  grpPartenza.Enabled := True;
  grpConvenzione.Enabled := True;

  btnDelete.Enabled := False;
  btnModifica.Enabled := False;
  sbExit.Enabled := False;
  btnNew.Enabled := False;
  btnUndo.Enabled := True;
  btnSave.Enabled := True;
  mezzo.SetFocus;
end;

procedure TfrmDispoMezzi.acnNewUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := not (ModServ.qryOrariDispo.State in
    [dsEdit, dsInsert]);
end;

procedure TfrmDispoMezzi.acnCloseExecute(Sender: TObject);
begin
  close
end;

procedure TfrmDispoMezzi.acnDeleteExecute(Sender: TObject);
begin
    if confirm('Eliminare la riga selezionata?') then
    begin
      ModServ.qryOrariDispo.Delete;
      grpOrari.Enabled := False;
      grpPartenza.Enabled := False;
      grpConvenzione.Enabled := False;
      //rdiInizio.Checked := False;
      rdiFine.Checked := False;

      ModServ.qryOrariDispo.ApplyUpdates;
      ModServ.qryOrariDispo.CommitUpdates;
    end;
end;

procedure TfrmDispoMezzi.acnUndoExecute(Sender: TObject);
begin
  //annullamento dell'inserimento
  ModServ.qryOrariDispo.Cancel;
    grpOrari.Enabled := False;
    grpPartenza.Enabled := False;
    grpConvenzione.Enabled := False;
    //rdiInizio.Checked := False;
    rdiFine.Checked := False;

    btnDelete.Enabled := True;
    btnModifica.Enabled := True;
    btnNew.Enabled := True;
    sbexit.Enabled := True;

    btnUndo.Enabled := False;
    btnSave.Enabled := False;
end;

procedure TfrmDispoMezzi.acnSaveExecute(Sender: TObject);
begin
  ModServ.qryOrariDispo.Post;
end;

procedure TfrmDispoMezzi.acnSaveUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ModServ.qryOrariDispo.State in
    [dsEdit, dsInsert];
end;

procedure TfrmDispoMezzi.acnDeleteUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := not ModServ.qryOrariDispo.IsEmpty;
end;

procedure TfrmDispoMezzi.acnModifyExecute(Sender: TObject);
begin
  ModServ.qryOrariDispo.Edit;

  grpOrari.Enabled := True;
  grpPartenza.Enabled := True;
  grpConvenzione.Enabled := True;
  //rdiInizio.Checked := False;
  if ModServ.qryOrariDispo['operativa'] = 1 then
    rdiFine.Checked := False
  else
  begin
    rdiFine.Checked := True;
    ora_fine.Enabled := True;
  end;

  sbExit.Enabled := False;
  btnDelete.Enabled := False;
  btnNew.Enabled := False;
  btnModifica.Enabled := False;
    btnUndo.Enabled := True;
    btnSave.Enabled := True;
end;

procedure TfrmDispoMezzi.acnBackExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmDispoMezzi.elencoDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
    if ModServ.qryOrariDispo.FieldByName('operativa').AsInteger = 1 then
      begin
        elenco.Canvas.Brush.Color := clSkyBlue;
        //elenco.Canvas.Font.Color := ClRed;
        elenco.Canvas.Font.Style := [fsBold];
      end;
      elenco.DefaultDrawColumnCell(Rect, DataCol, Column, State);
end;


procedure TfrmDispoMezzi.btnChiudiClick(Sender: TObject);
begin

    if ModServ.qryOrariDispo.State in [dsInsert] then
    begin
    // TODO 1 -oMemini -cFixup bug http://bugs.mysql.com/bug.php?id=18084
    // Ho dovuto crearemi la query a mano, appena si risolve sto problema
    //  meglio cambiare sta porcheria
{
insert into oraridispo
  (giorno, mezzo, ora_inizio, ora_fine, convenzione, operativa, posizione)
values
  (:giorno, :mezzo, :ora_inizio, :ora_fine, :convenzione, :operativa, :posizione)
}  
        ModServ.QryFind.Close;
        ModServ.QryFind.SQL.Clear;
        ModServ.QryFind.SQL.Text := 'insert into oraridispo ' +
        '(giorno, mezzo, ora_inizio, ora_fine, convenzione, operativa, posizione)' +
        ' values' +
        '(:giorno, :mezzo, :ora_inizio, :ora_fine, :convenzione, :operativa, :posizione)';


        ModServ.QryFind.ParamByName('giorno').AsString :=
          FormatDateTime('yyyy-mm-dd', Giorno.Date);
        ModServ.QryFind.ParamByName('mezzo').AsString := mezzo.Text;
        ModServ.QryFind.ParamByName('ora_inizio').AsString := ora_inizio.text;
        if rdiFine.Checked then
        begin
          ModServ.QryFind.ParamByName('operativa').AsString := '0';
          ModServ.QryFind.ParamByName('ora_fine').AsString := ora_fine.text;
        end
        else
        begin
          ModServ.QryFind.ParamByName('operativa').AsString := '1';
          ModServ.QryFind.ParamByName('ora_fine').AsString := '';

        //Not Work because field is unknown type (isen't casted)
        //ModServ.QryFind.ParamByName('ora_fine').Clear;
        end;
        ModServ.QryFind.ParamByName('convenzione').AsString := grpConvenzione.Value;

        if not(rdiFine.Checked) then
        begin
          if rdiColonnina.Checked then
          begin
            ModServ.QryFind.ParamByName('posizione').AsString := Colonnina.Text;
          end
          else
          begin
            ModServ.QryFind.ParamByName('posizione').AsString := 'SEDE'
          end;
        end
        else
          ModServ.QryFind.ParamByName('posizione').AsString := '';

        ModServ.QryFind.ExecSQL;

        //ModServ.qryOrariDispo.Post;
        //ModServ.qryOrariDispo.ApplyUpdates;
        //ModServ.qryOrariDispo.CommitUpdates;
        ModServ.qryOrariDispo.Cancel;
        ModServ.QryFind.SQL.Clear;
    end;

    if ModServ.qryOrariDispo.State in [dsEdit] then
    begin
{
update oraridispo
set
  giorno = :giorno,
  mezzo = :mezzo,
  ora_inizio = :ora_inizio,
  ora_fine = :ora_fine,
  convenzione = :convenzione,
  operativa = :operativa,
  posizione = :posizione
where
  id = :OLD_id
}
      ModServ.qryOrariDispo.Post;
      ModServ.qryOrariDispo.ApplyUpdates;
      ModServ.qryOrariDispo.CommitUpdates;
    end;

      ModServ.qryOrariDispo.Active := False;
      ModServ.qryOrariDispo.ExecSQL;
      ModServ.qryOrariDispo.Active := True;
      
      grpOrari.Enabled := False;
      grpPartenza.Enabled := False;
      grpConvenzione.Enabled := False;

      sbExit.Enabled := True;
      btnDelete.Enabled := True;
      btnNew.Enabled := True;
      btnModifica.Enabled := True;


      btnUndo.Enabled := False;
      btnSave.Enabled := False;
end;


procedure TfrmDispoMezzi.SetWeek(Sender: Tobject);
  var
  select_date,select_dateOfWeek :  TDateTime;
  inizio_sett : TDateTime;
  queryday,query : string;
begin
    select_date := SetDay.Date;
    select_dateOfWeek := DayOfTheWeek(select_date);
    inizio_sett := (select_date - select_dateOfWeek) + 1;
    queryday :=FormatDateTime('dd/mm/yyyy', inizio_sett);

    settimana_da.caption := 'Settimana dal ' + queryday;
    queryday :=FormatDateTime('dd/mm/yyyy', inizio_sett + 6);
    settimana_al.caption := 'al ' + queryday;

    ModServ.qryOrariDispo.SQL.Clear;
    query := 'SELECT * FROM oraridispo WHERE GIORNO between ("';
    query := query + FormatDateTime('yyyy-mm-dd', inizio_sett) + '") and ("';
    query := query + FormatDateTime('yyyy-mm-dd', inizio_sett + 6)+ '")';

    // Per Mysql FormatDateTime('yyyy-mm-dd', inizio_sett);
    ModServ.qryOrariDispo.SQL.Add(query);
    ModServ.qryOrariDispo.Active := False;
    ModServ.qryOrariDispo.ExecSQL;
    ModServ.qryOrariDispo.Active := True;
end;

end.

// update oradisp,park set oradisp.ora_fine=now(), park.disponibile=0, park.posizione=""
// where oradisp.mezzo=park.mezzo
