unit untRicercaPersonale;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  dmMod, StdCtrls, ExtCtrls, ToolWin, ComCtrls, Grids, DBGrids, Buttons, DBCtrls;

type
  TFrmVolontari = class(TForm)
    estratti: TLabel;
    btnExit: TSpeedButton;
    btnExecute: TSpeedButton;
    Panel1: TPanel;
    grdResult: TDBGrid;
    Label6: TLabel;
    Label1: TLabel;
    Label19: TLabel;
    GroupBox1: TGroupBox;
    nominativo: TEdit;
    Label2: TLabel;
    chkNominativo: TCheckBox;
    GroupBox2: TGroupBox;
    disp_attuale: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    chkdae: TCheckBox;
    Label8: TLabel;
    Label9: TLabel;
    chkturnocompleto: TCheckBox;
    T_feriale: TDBLookupComboBox;
    T_Festivo: TDBLookupComboBox;
    qualifica: TDBLookupComboBox;
    Label3: TLabel;
    chkinserv: TCheckBox;
    chkaspett: TCheckBox;
    chkdimiss: TCheckBox;
    Label10: TLabel;
    Pulisci: TSpeedButton;
    rapporto: TDBLookupComboBox;
    procedure btnExecuteClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure chkNominativoClick(Sender: TObject);
    procedure CleanComboBox(Sender: TObject; var Key: Char);
    procedure nominativoKeyPress(Sender: TObject; var Key: Char);
    procedure PulisciClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVolontari: TFrmVolontari;

implementation

{$R *.DFM}

procedure TFrmVolontari.btnExecuteClick(Sender: TObject);
begin

  if nominativo.text = '' then
    chkNominativo.Checked := True;

  //creazione della queri di ricerca
  ModServ.QryAvailable.Close;
  ModServ.QryAvailable.SQL.Clear;
  ModServ.QryAvailable.Sql.Add('SELECT TESSERA as MATRICOLA, COGNOME as NOMINATIVO, GRADO,DATA_ACC as ACCETTAZIONE, DAE as DAE, SQ_FER as FERIALE, SQ_FES as FESTIVO');
  ModServ.QryAvailable.Sql.Add('FROM gestvol');
  ModServ.QryAvailable.Sql.Add('WHERE');

  if not chkNominativo.Checked  then
    ModServ.QryAvailable.Sql.Add('COGNOME LIKE ''%' + nominativo.text + '%'' AND ');

  if qualifica.Text <> '' then
    ModServ.QryAvailable.Sql.Add('GRADO = '''+ qualifica.KeyValue +''' AND ');

  if T_feriale.text <> '' then
    ModServ.QryAvailable.Sql.Add('SQ_FER = '''+ t_feriale.KeyValue +''' AND ');

  if T_Festivo.text <> '' then
    ModServ.QryAvailable.Sql.Add('SQ_FES = '''+ t_festivo.KeyValue +''' AND ');

  if rapporto.Text <> '' then
    ModServ.QryAvailable.SQL.add('id_posizione = ''' + IntToStr(rapporto.keyvalue) +''' AND '); 

  if disp_attuale.Text = 'DISPONIBILE' then
    ModServ.QryAvailable.Sql.Add('INDISPOSTO = 0 ')
  else
    ModServ.QryAvailable.Sql.Add('INDISPOSTO = 1 ');

  if chkdae.Checked then
    ModServ.QryAvailable.Sql.Add('AND NOT DAE = 0 ');

  if chkinserv.Checked then
    ModServ.QryAvailable.Sql.Add('AND (SERVIZIO = 0 ')
  else
   ModServ.QryAvailable.Sql.Add('AND (SERVIZIO = 1 ');

  if chkdimiss.Checked then
    ModServ.QryAvailable.Sql.Add('AND DIMISS = 0 ')
  else
   ModServ.QryAvailable.Sql.Add('OR DIMISS = 1 ');

  if chkaspett.Checked then
    ModServ.QryAvailable.Sql.Add('AND ASPETT = 0 )')
  else
   ModServ.QryAvailable.Sql.Add('OR ASPETT = 1 )');

  // Ordina la query in modo sensato...
  ModServ.QryAvailable.Sql.Add('ORDER BY COGNOME');

  ModServ.QryAvailable.Open;

  //cancello l'ultima riga della query (Non ricordo perch l'avevo fatto)
  //ModServ.QryAvailable.Sql.Delete(ModServ.QryAvailable.Sql.count - 1);
  
  //numero estratti [LDS: pu non avere senso con i database Sql C/S...]
  Estratti.Caption := IntToStr(ModServ.QryAvailable.RecordCount);
end;

procedure TFrmVolontari.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmVolontari.chkNominativoClick(Sender: TObject);
begin

  if (sender as TCheckBox).Checked then
  begin
    nominativo.Color := clRed;
    nominativo.Text := '';
    nominativo.Enabled := False;
  end
  else
    nominativo.Enabled := True;
    nominativo.color := clWindow;

end;

procedure TFrmVolontari.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then close;
end;

procedure TFrmVolontari.nominativoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    btnExecuteClick(nil);
    Key := #0;
  end;
end;

procedure TFrmVolontari.PulisciClick(Sender: TObject);
begin
  ModServ.QryAvailable.Close;

  Nominativo.text := '';
  qualifica.KeyValue := '';
  T_feriale.KeyValue := '';
  T_Festivo.KeyValue := '';

  chkNominativo.Checked := False;
  chkdae.Checked := False;
  chkturnocompleto.Checked := True;
  chkdimiss.Checked := True;
  chkaspett.Checked := True;
  chkinserv.Checked := False;

  disp_attuale.Text := 'DISPONIBILE';
  Rapporto.KeyValue := 0;
  
end;

procedure TFrmVolontari.CleanComboBox(Sender: TObject; var Key: Char);
begin
  if (Key = Chr(vk_Back)) then
     (Sender as TDBLookupComboBox).KeyValue := '';
end;

end.
