unit UntMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Grids, DBGrids, JvComponentBase,
  JvUrlListGrabber, JvUrlGrabbers, JvExStdCtrls, JvHtControls, xmldom, XMLIntf,
  msxmldom, XMLDoc, JvExComCtrls, JvComCtrls, ExtCtrls, JvHint, JvExControls,
  JvEditorCommon, JvEditor, JvMemo, JvCalendar, JvExDBGrids, JvDBGrid,
  JvMonthCalendar, ImgList, untStrade, Menus, JvMenus, untRSS, untcommon;

type
  TFrmMain = class(TForm)
    Label5: TLabel;
    XMLDocument1: TXMLDocument;
    Timer1: TTimer;
    JvUrlListGrabber1: TJvUrlListGrabber;
    grpStradario: TGroupBox;
    SegnReale: TGroupBox;
    TreeSegnalazioni: TJvTreeView;
    lblDescription: TJvMemo;
    lblTitle: TLabel;
    last10serv: TJvDBGrid;
    da_via: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label3: TLabel;
    da_comune: TEdit;
    Label7: TLabel;
    Label_dest: TLabel;
    Button2: TButton;
    rdiPunto: TRadioButton;
    rdiPercorso: TRadioButton;
    Label_tovia: TLabel;
    to_via: TEdit;
    label_tocomune: TLabel;
    to_comune: TEdit;
    Label9: TLabel;
    chksede: TCheckBox;
    Label4: TLabel;
    imsRss: TImageList;
    grpMezzi: TGroupBox;
    gridMezziAttivi: TDBGrid;
    PopupRSS: TJvPopupMenu;
    Visualizzaingriglia1: TMenuItem;
    Stampa1: TMenuItem;
    PopupMezzi: TJvPopupMenu;
    ModificaEquipaggio1: TMenuItem;
    StaccoMacchina1: TMenuItem;
    Cambia1: TMenuItem;
    NuovaMissione1181: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    DisponibiltMezzi1: TMenuItem;
    FineDisponibilitMezzo1: TMenuItem;
    lblLink: TJvHTLabel;
    procedure FormShow(Sender: TObject);
    procedure RefreshQuery;
    procedure RefreshRss;
    procedure GetFile;
    procedure TreeSegnalazioniChange(Sender: TObject; Node: TTreeNode);
    procedure JvUrlListGrabber1DoneFile(Sender: TJvUrlListGrabber;
      Grabber: TJvCustomUrlGrabber; FileName: string; FileSize: Integer;
      Url: string);
    procedure JvUrlListGrabber1Error(Sender: TJvUrlListGrabber;
      Grabber: TJvCustomUrlGrabber; ErrorMsg: string);
    procedure Timer1Timer(Sender: TObject);
    procedure last10servDblClick(Sender: TObject);
    procedure last10servDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure rdiPercorsoClick(Sender: TObject);
    procedure rdiPuntoClick(Sender: TObject);
    procedure chksedeClick(Sender: TObject);
    procedure to_comuneKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure FineDisponibilitMezzo1Click(Sender: TObject);
    procedure NuovaMissione1181Click(Sender: TObject);
    procedure ModificaEquipaggio1Click(Sender: TObject);
    procedure Cambia1Click(Sender: TObject);
    procedure StaccoMacchina1Click(Sender: TObject);
    procedure Visualizzaingriglia1Click(Sender: TObject);
    procedure Stampa1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation


uses dmMod, untAuto, untReport, UntException;

{$R *.dfm}

resourcestring
  headlineupdate = 'Ultimo aggiornamento  ';
  headlineerror = 'Errore durante l''aggiornamento delle segnalazioni';
  headlinedeactivated = 'Segnalazioni in tempo reale disattivate';
  headlineupdating = 'Aggiornamento segnalazioni in corso';

procedure TFrmMain.Button1Click(Sender: TObject);
begin

     if not Assigned(frmStrade) then
        FrmStrade := Tfrmstrade.create(nil);

      if rdiPercorso.Checked = true then
      begin
        if (da_comune.Text = '') or (da_via.text = '') then
        begin
          MessageDlg('Inserire un luogo di partenza valido.', mtWarning,
          [mbOk], 0);
          Abort;
        end
        else
         FrmStrade.CalcolaPercorso(da_comune.text,da_via.Text,
         to_comune.text,to_via.Text);
      end
      else
      begin
      if (to_comune.Text = '') or (to_via.text = '') then
        begin
          MessageDlg('Inserire una destinazione valida.', mtWarning,
          [mbOk], 0);
          Abort;
        end
        else
        FrmStrade.IndividuaSuMappa(to_comune.Text,to_via.Text);
      end;

      FrmStrade.Show;

end;

procedure TFrmMain.Button2Click(Sender: TObject);
begin
  da_via.Text := '';
  da_comune.text := '';
  to_via.Text := '';
  to_comune.text := '';
  rdiPunto.Checked := True;
  rdiPercorso.Checked := False;
  chksede.Checked := False;

    da_via.Visible := False;
    da_comune.Visible := False;
    label_tocomune.Visible := False;
    label_tovia.Visible := False;
    Label_dest.Visible := False;
    chksede.Visible := False;

end;

procedure TFrmMain.Cambia1Click(Sender: TObject);
begin
  NotImplemented
end;

procedure TFrmMain.chksedeClick(Sender: TObject);
begin
    if chksede.Checked = True then
      begin
        da_via.Text := ModServ.BASEINDIRIZZO;
        da_comune.Text := ModServ.BASECOMUNE;
        da_via.Enabled := False;
        da_comune.Enabled := False;
      end
      else
      begin
        da_via.Enabled := True;
        da_comune.Enabled := True;
        da_via.Text := '';
        da_comune.text := '';
      end;
end;

procedure TFrmMain.rdiPercorsoClick(Sender: TObject);
begin
    da_via.Visible := True;
    da_comune.Visible := True;
    label_tocomune.Visible := True;
    label_tovia.Visible := True;
    Label_dest.Visible := True;
    chksede.Visible := True;
end;

procedure TFrmMain.rdiPuntoClick(Sender: TObject);
begin
    da_via.Visible := False;
    da_comune.Visible := False;
    label_tocomune.Visible := False;
    label_tovia.Visible := False;
    Label_dest.Visible := False;
    chksede.Visible := False;
end;

procedure TFrmMain.Timer1Timer(Sender: TObject);
begin
  RefreshRSS;
  RefreshQuery;
end;

procedure TFrmMain.to_comuneKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    Button1Click(self);
end;

procedure TFrmMain.TreeSegnalazioniChange(Sender: TObject; Node: TTreeNode);
var
  rssFeedData : PRSSFeedData;
begin

  TreeSegnalazioni.Items[TreeSegnalazioni.ItemIndex].SelectedIndex :=
     TreeSegnalazioni.Items[TreeSegnalazioni.ItemIndex].ImageIndex;
     
  if TreeSegnalazioni.Selected = nil then Exit;

  // if TreeSegnalazioni.Selected = TreeSegnalazioni.Items.GetFirstNode then Exit;
  //all other tree items except the "first" one hold rss data ...

  rssFeedData := PRSSFeedData(TreeSegnalazioni.Selected.Data);

  lblTitle.Caption := TreeSegnalazioni.Selected.Text;

  if Assigned(rssFeedData) then
  begin
    lblLink.Caption := Format('<a href="%s">Visualizza dal sito</a>',[rssFeedData.URL]);
    lblDescription.Text := rssFeedData.Description;//Format('%s',[rssFeedData.Description]);
    //lblDate.Caption := Format('Date: %s',[rssFeedData.Date]);
  end
  else
    exit
end;

procedure TFrmMain.Visualizzaingriglia1Click(Sender: TObject);
begin
  NotImplemented
end;

procedure TFrmMain.FineDisponibilitMezzo1Click(Sender: TObject);
begin
  NotImplemented
end;

procedure TFrmMain.FormDestroy(Sender: TObject);
begin
    ClearTree(TreeSegnalazioni);
end;

procedure TFrmMain.FormResize(Sender: TObject);
  var X : integer;
begin

  X := (SegnReale.Width div 2);

  TreeSegnalazioni.Width := X-3;
  lblDescription.Width := X-3;
  lblDescription.Left := X+3;
  lblTitle.left := lblDescription.Left+3;
  lblLink.Left := lblDescription.Left+3;

  //
  grpStradario.Width := X-6;
  grpMezzi.Left := X+3;
  grpMezzi.Width := X-3;

end;

procedure TFrmMain.FormShow(Sender: TObject);
begin
  lblTitle.Caption := 'n/a';
  lblDescription.Text := 'n/a';
  TreeSegnalazioni.Items.AddChild(nil,headlineupdating);

  ShowScrollBar(gridMezziAttivi.handle,SB_HORZ, false);
  RefreshRSS;
  RefreshQuery;
end;


procedure TFrmMain.JvUrlListGrabber1DoneFile(Sender: TJvUrlListGrabber;
  Grabber: TJvCustomUrlGrabber; FileName: string; FileSize: Integer;
  Url: string);
  var indeximmagine : integer;
      risultato: string;
begin
  if FileSize > 0 then
  begin
      Indeximmagine := 0;

      if Url = ModServ.URLOspedali then
        indeximmagine := 1;
      if URl = ModServ.URLTraffico then
        Indeximmagine := 2;
      if Url = MoDserv.URLNews then
        Indeximmagine := 3;


      risultato := PopulateTree(FileName, FileSize, Url, indeximmagine,TreeSegnalazioni,XMLDocument1);

      if StrToBool(risultato) then
      begin
        UpdateStatusPanel(FrmAuto.SB.Panels[1], headlineupdate + DateTimeToStr(now));

      end
      else
        JvUrlListGrabber1Error(nil, nil, risultato);

  end
  else
  begin
     JvUrlListGrabber1Error(nil, nil,'FileSize is zero');
  end;
end;

procedure TFrmMain.JvUrlListGrabber1Error(Sender: TJvUrlListGrabber;
  Grabber: TJvCustomUrlGrabber; ErrorMsg: string);
begin
    ClearTree(TreeSegnalazioni);
    FrmAuto.SB.Panels[1].Text := headlineerror;
    lblTitle.Caption := 'Error';
    lblDescription.Text := ErrorMsg;
    TreeSegnalazioni.Items.AddChild(nil,headlineerror);
    lblLink.Visible := False;
end;

procedure TFrmMain.last10servDblClick(Sender: TObject);
begin
    FrmReport.ShowModal;
end;

procedure TFrmMain.last10servDrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
    if ModServ.qryLast10Service.FieldByName('deleted').AsInteger = 1 then
      begin
        last10serv.Canvas.Font.Style := [fsItalic];
        last10serv.Canvas.Font.Color := clGray;
      end;
      last10serv.DefaultDrawColumnCell(Rect, DataCol, Column, State);
end;

procedure TFrmMain.ModificaEquipaggio1Click(Sender: TObject);
begin
  NotImplemented
end;

procedure TFrmMain.NuovaMissione1181Click(Sender: TObject);
begin
  NotImplemented
end;

procedure TFrmMain.RefreshQuery;
begin
      ModServ.qryMezziActive.Active := False;
      ModServ.qryMezziActive.ExecSQL;
      ModServ.qryMezziActive.Active := True;

      ModServ.qryLast10Service.Active := False;
      ModServ.qryLast10Service.ExecSQL;
      ModServ.qryLast10Service.Active := True;
end;

procedure TFrmMain.GetFile;
begin
  // Pulisco la lista (non si sa mai)
  JvUrlListGrabber1.URLs.Clear;

  JvUrlListGrabber1.DefaultGrabbersProperties.ItemsNamed['HTTP'].FileName :=
   GetEnvironmentVariable('TEMP') + '\output.xml';

  // Ricreo la lista
  JvUrlListGrabber1.URLs.Add(ModServ.URLOspedali);
  JvUrlListGrabber1.URLs.Add(ModServ.URLTraffico);
  JvUrlListGrabber1.URLs.Add(ModServ.URLNews);

  // start grab!
  jvUrlListGrabber1.StartAll;

  FrmAuto.SB.Panels[1].Text := headlineupdating;

end;

procedure TFrmMain.RefreshRSS;
begin
      if ModServ.FEEDRSS then
      begin
        if not(lblLink.Visible) then
          lblLink.Visible := True;
          
        ClearTree(TreeSegnalazioni);
        GetFile;
      end
      else
      begin
        JvUrlListGrabber1Error(nil, nil,headlinedeactivated);
        if lblLink.Visible then
         lblLink.Visible := False;
      end;
end;

procedure TFrmMain.StaccoMacchina1Click(Sender: TObject);
begin
  NotImplemented
end;

procedure TFrmMain.Stampa1Click(Sender: TObject);
begin
  NotImplemented
end;

end.
