

{*************************************************************************
  TODO -oMemini -cFixup: Verificare che i campi presentati sia corretti
  **************************************************************************}
unit svrFrameAutoMed;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, ComCtrls, DBCtrls, Mask, ExtCtrls, Buttons, dmServizi,
  ShlIntf, StrTools, ComObj, dmMod, untcommon;

type
  TFrameAutoMed = class(TFrame)
    grpEquipaggio: TGroupBox;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label35: TLabel;
    Label39: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label9: TLabel;
    Label15: TLabel;
    Label25: TLabel;
    CS: TDBLookupComboBox;
    AUTISTA: TDBLookupComboBox;
    MILITE: TDBLookupComboBox;
    MILITE2: TDBLookupComboBox;
    CENTRALINO: TDBLookupComboBox;
    MEZZO: TDBLookupComboBox;
    grpScheda118: TGroupBox;
    Label16: TLabel;
    Label41: TLabel;
    Label94: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label30: TLabel;
    sbpartenza: TSpeedButton;
    lF5: TLabel;
    Label27: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    NUM118: TDBEdit;
    CLIENTE: TDBLookupComboBox;
    ORA_SERV: TDBEdit;
    TRASP_A: TDBLookupComboBox;
    ORA_PART: TDBEdit;
    grpAltrimezzi: TGroupBox;
    chkMSA: TDBCheckBox;
    chkEli: TDBCheckBox;
    chkVVF: TDBCheckBox;
    chkForzordine: TDBCheckBox;
    chkMSB: TDBCheckBox;
    chkAltro: TDBCheckBox;
    grpEsito: TGroupBox;
    Label18: TLabel;
    Label6: TLabel;
    sbcaricato: TSpeedButton;
    lf7: TLabel;
    Label42: TLabel;
    Label44: TLabel;
    STATO: TDBLookupComboBox;
    ORA_CARIC: TDBEdit;
    grpDestinazione: TGroupBox;
    Label7: TLabel;
    Label24: TLabel;
    sbdestinazione: TSpeedButton;
    lf8: TLabel;
    Label26: TLabel;
    Label43: TLabel;
    lbDest: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    ORA_DEST: TDBEdit;
    TRASP_R: TDBLookupComboBox;
    destinaz_citta: TDBEdit;
    DESTINAZ: TDBEdit;
    grpLibero: TGroupBox;
    LabelInterrotta: TLabel;
    LabelLibero: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    sbfine: TSpeedButton;
    lf9: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label52: TLabel;
    ORA_LIB: TDBEdit;
    KM: TDBEdit;
    BOLLA: TDBEdit;
    grpStatoMezzo: TGroupBox;
    Label8: TLabel;
    lF10: TLabel;
    sblibero: TSpeedButton;
    Label17: TLabel;
    Label31: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    ORA_FINE: TDBEdit;
    POSIZIONE: TComboBox;
    COLONNINA: TDBLookupComboBox;
    grpCosto: TGroupBox;
    COSTO: TDBEdit;
    PAGATO: TDBCheckBox;
    grpNote: TGroupBox;
    Note: TDBRichEdit;
    grpDati: TGroupBox;
    Label13: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Label19: TLabel;
    sbposto: TSpeedButton;
    lf6: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label40: TLabel;
    luogo_citta: TDBEdit;
    MOTIVO: TDBEdit;
    INCROCIO: TEdit;
    chkIncrocio: TCheckBox;
    RIFERIMENTI: TDBEdit;
    ORA_POSTO: TDBEdit;
    LUOGO: TDBEdit;
    btnOspedaliTo: TSpeedButton;
    SpeedButton1: TSpeedButton;
    INDIRIZZO: TEdit;
    labelCivico: TLabel;
    CIVICO: TEdit;
    GetMap: TSpeedButton;
    GroupBox1: TGroupBox;
    lblScheda: TLabel;
    constructor CreateWithDM(AOwner: TComponent; d: TdmdServizi);
    procedure Btn118Click(Sender: TObject);
    procedure genLuogo(Sender: TObject);
    procedure chkIncrocioClick(Sender: TObject);
    procedure TRASP_COLOR(Sender: TObject);
    procedure btnOspedaliToClick(Sender: TObject);
    procedure CleanComboBox(Sender: TObject; var Key: Char);
    procedure STATOClick(Sender: TObject);
    procedure GetMapClick(Sender: TObject);
    procedure MEZZOClick(Sender: TObject);
  private
    FDmServizi: TdmdServizi;
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

uses untServizi, untChiusura118, untOspedale, untstrade;

resourcestring
  CodColInvalid = 'Il codice di invio specificato non  valido';

procedure TFrameAutoMed.CleanComboBox(Sender: TObject; var Key: Char);
begin
  if (Key = Chr(vk_Back)) then
     FdmServizi.TblServizi[(Sender as TDBLookupComboBox).DataField] := NULL;
end;

procedure TFrameAutoMed.Btn118Click(Sender: TObject);
begin
  frm118 := TFrm118.Create(self);

  frm118.label10.Caption := '';
  frm118.label11.Caption := '';
  frm118.label12.Caption := '';
  frm118.label13.Caption := '';
  frm118.label14.Caption := '';
  frm118.label15.Caption := '';
  frm118.codcol.Caption := '';
  frm118.label20.Caption := '';
  frm118.label22.Caption := '';
  frm118.Label9.Caption := '';

  if FdmServizi.TblServizi['NUM118'] <> Null then
    frm118.label12.Caption := FdmServizi.TblServizi['NUM118'];
  if FdmServizi.TblServizi['mezzo'] <> Null then
    frm118.Label9.Caption := FdmServizi.TblServizi['mezzo'];
  if FdmServizi.TblServizi['ORA_POSTO'] <> Null then
    frm118.label10.Caption := FdmServizi.TblServizi['ORA_POSTO'];
  if FdmServizi.TblServizi['ORA_CARIC'] <> Null then
    frm118.label11.Caption := FdmServizi.TblServizi['ORA_CARIC'];
  if FdmServizi.TblServizi['ORA_DEST'] <> Null then
    frm118.label13.Caption := FdmServizi.TblServizi['ORA_DEST'];
  if FdmServizi.TblServizi['ORA_LIB'] <> Null then
    frm118.label14.Caption := FdmServizi.TblServizi['ORA_LIB'];
  if FdmServizi.TblServizi['DESTINAZ'] <> Null then
    frm118.label15.Caption := FdmServizi.TblServizi['DESTINAZ'] +
    ' ('+FdmServizi.TblServizi['DESTINAZ_CITTA']+')';
  if FdmServizi.TblServizi['TRASP_R'] <> Null then
  begin
    frm118.codcol.Caption := FdmServizi.TblServizi['TRASP_R'];
    frm118.codcol.Color := trasp_r.Color
  end
  else
    frm118.codcol.Transparent := True;
  if FdmServizi.TblServizi['ORA_PART'] <> Null then
    frm118.label20.Caption := FdmServizi.TblServizi['ORA_PART'];
  if FdmServizi.TblServizi['STATO'] <> Null then
    frm118.label22.Caption := FdmServizi.TblServizi['STATO'];
  frm118.showmodal;

  frm118.free;
end;

procedure TFrameAutoMed.btnOspedaliToClick(Sender: TObject);
begin
  FrmOspedali := TFrmOspedali.createWithDM(self, FdmServizi);
    if (FrmOspedali.ShowModal = mrYes) then
    begin
      FdmServizi.TblServizi['destinaz'] := FdmServizi.TblOSpedali['ospedale'];
      FdmServizi.TblServizi['destinaz_citta'] := FdmServizi.TblOSpedali['paese'];
      trasp_r.SetFocus;
    end;
  FrmOspedali.free;
end;

procedure TFrameAutoMed.chkIncrocioClick(Sender: TObject);
begin
  if chkIncrocio.Checked <> false then
  begin
    CIVICO.Enabled := False;
    CIVICO.Visible := False;
    labelCivico.Visible := False;
    INCROCIO.Enabled := True;
    INCROCIO.Visible := True;
  end
  else
  begin
    CIVICO.Enabled := True;
    CIVICO.Visible := True;
    labelCivico.Visible := True;
    INCROCIO.Enabled := False;
    INCROCIO.Visible := False;
  end;

  genLuogo(self);

end;

constructor TFrameAutoMed.CreateWithDM(AOwner: TComponent; d: TdmdServizi);
begin
  inherited Create(AOwner);
  FdmServizi := d;
  RedirectFixupReferences(Self, 'dmdServizi', FdmServizi.Name);

    //  Disabilito un p di pannelli
    ora_caric.Visible := False;
    destinaz.Visible := False;
    destinaz_citta.Visible := False;
    trasp_r.Visible := False;
    ora_dest.Visible := False;

    sbcaricato.visible := False;
    lf7.Visible := False;

    sbdestinazione.visible := False;
    lf8.visible := False;

    lblScheda.Caption := FdmServizi.TblServizi.FieldByName('NUM').AsString;

end;

procedure TFrameAutoMed.genLuogo(Sender: TObject);
begin

  if (civico.Text <> '') or (incrocio.Text <> '') then
  begin
    FdmServizi.TblServizi['Luogo'] := null;

    if self.chkIncrocio.Checked <> False then
    begin
      FdmServizi.TblServizi['Luogo'] := INDIRIZZO.Text + ' INCROCIO CON ' + INCROCIO.Text;
    end
    else
    begin
      FdmServizi.TblServizi['Luogo'] := INDIRIZZO.Text + ' N. ' + CIVICO.Text;
    end;
  end;
end;

procedure TFrameAutoMed.GetMapClick(Sender: TObject);
begin
      if (luogo_citta.Text = '') or (INDIRIZZO.text = '') then
        begin
          MessageDlg('Inserire un''indirizzo valido.', mtWarning,
          [mbOk], 0);
          Abort;
      end;

     if not Assigned(frmStrade) then
        FrmStrade := Tfrmstrade.create(nil);

     FrmStrade.IndividuaSuMappa(luogo_citta.Text,INDIRIZZO.Text + ' ' + CIVICO.text);
     FrmStrade.Show;
end;

procedure TFrameAutoMed.MEZZOClick(Sender: TObject);
begin
  CambiaTabName((sender as TDBLookupComboBox).Text,
    FdmServizi.tblServizi.FieldByName('NUM').AsString);
end;

procedure TFrameAutoMed.STATOClick(Sender: TObject);
var
  cod_stato: integer;
begin
  cod_stato := FdmServizi.Tblstato.FieldByName('COD').AsInteger;
  Trasp_r.Color := clWindow;

    //  Disabilito un p di pannelli

    ora_caric.Visible := False;
    destinaz.Visible := False;
    destinaz_citta.Visible := False;
    trasp_r.Visible := False;
    ora_dest.Visible := False;

    sbcaricato.visible := False;
    lf7.Visible := False;

    sbdestinazione.visible := False;
    lf8.visible := False;

    trasp_r.Enabled := True;

    LabelLibero.Visible := True;
    LabelInterrotta.Visible := False;

    ora_posto.Visible := True;
    sbposto.Visible := True;
    lf6.Visible := True;
    btnOspedaliTo.Visible := False;

  case cod_stato of
    0:
    // Rifiuto / Vuoto / etc
    begin
      FdmServizi.TblServizi['trasp_r'] := 'BIANCO';
      FdmServizi.TblServizi['destinaz'] := NULL;
      FdmServizi.TblServizi['destinaz_citta'] := NULL;
      FdmServizi.TblServizi['ora_dest'] := NULL;
      trasp_r.Enabled := False;
      trasp_r.Visible := True;
    end;
    1, 2, 3:
    // Regolare
    begin
      // Abilito i controlli
      destinaz.Visible := True;
      destinaz_citta.Visible := True;

      ora_caric.Visible := True;  //abilita ora caricato
      FdmServizi.TblServizi['trasp_r'] := NULL;
      trasp_r.Visible := True;    //ablt codice trasporto
      ora_dest.Visible := True;   //ablt ora dest

      sbcaricato.visible := True;
      lf7.Visible := True;

      sbdestinazione.visible := True;
      lf8.visible := True;
      btnOspedaliTo.Visible := True;

      Costo.Visible := True; //ablt costo
    end;
    4:
    // DECEDUTO
    begin
        FdmServizi.TblServizi['trasp_r'] := 'NERO';
        FdmServizi.TblServizi['destinaz'] := NULL;
        FdmServizi.TblServizi['destinaz_citta'] := NULL;
        FdmServizi.TblServizi['ora_dest'] := NULL;
        trasp_r.Enabled := False;
        trasp_r.Visible := True;
    end;
    5:
    // INTERROTTA
    begin
        LabelLibero.Visible := False;
        LabelInterrotta.Visible := True;

        ora_posto.Visible := False;
        sbposto.Visible := False;
        lf6.Visible := False;

        // svuoto i campi del db
        FdmServizi.TblServizi['trasp_r'] := NULL;
        FdmServizi.TblServizi['destinaz'] := NULL;
        FdmServizi.TblServizi['destinaz_citta'] := NULL;
        FdmServizi.TblServizi['ora_dest'] := NULL;
    end;
    6:
    // EVAQUATO CON ALTRI MEZZI
    begin
        // per future espansioni per evaquato con altri mezzi
        FdmServizi.TblServizi['trasp_r'] := NULL;
        FdmServizi.TblServizi['destinaz'] := NULL;
        FdmServizi.TblServizi['destinaz_citta'] := NULL;
        FdmServizi.TblServizi['ora_dest'] := NULL;
    end;
    else
    begin

    end;
  end;
end;

procedure TFrameAutoMed.TRASP_COLOR(Sender: TObject);
begin
    {
    if trasp_a.Text = 'BIANCO' then
      trasp_a.color := clWhite;

    if trasp_a.Text = 'NERO' then
      trasp_a.color := clWhite;
    }

    begin
     if ((sender as TDBLookupComboBox).Text = 'BIANCO') or ((sender as TDBLookupComboBox).Text = 'NERO') then
     begin
       // Il condice bianco e nero non  ammesso nell'andata.
       if ((sender as TDBLookupComboBox).Name = 'TRASP_A') then
       begin
        FdmServizi.TblServizi['trasp_a'] := NULL;
        (sender as TDBLookupComboBox).color := clWhite;
       end
       else
       begin
        if (sender as TDBLookupComboBox).Text = 'BIANCO' then (sender as TDBLookupComboBox).color := clWhite;
        if (sender as TDBLookupComboBox).Text = 'NERO' then (sender as TDBLookupComboBox).color := clWhite;
       end;
       //MessageDlg(CodColInvalid,mtWarning,[mbOk],0);
       //(sender as TDBLookupComboBox).SetFocus;
     end;
    end;
    
    if (sender as TDBLookupComboBox).Text = 'VERDE' then
      (sender as TDBLookupComboBox).color := clLime;

    if (sender as TDBLookupComboBox).Text = 'GIALLO' then
      (sender as TDBLookupComboBox).color := clYellow;

    if (sender as TDBLookupComboBox).Text = 'ROSSO' then
      (sender as TDBLookupComboBox).color := clRed;
end;

end.
