unit untChangePassword;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, JvExStdCtrls, JvEdit;

type
  TFrmChangePassword = class(TForm)
    Panel1: TPanel;
    OKBtn: TButton;
    Bevel1: TBevel;
    Label3: TLabel;
    Sezione: TComboBox;
    password_orig: TJvEdit;
    Label2: TLabel;
    Label1: TLabel;
    password_new: TJvEdit;
    password_check: TJvEdit;
    Label14: TLabel;
    btnCambia: TButton;
    Image1: TImage;
    Label4: TLabel;
    Label5: TLabel;
    lblError: TLabel;
    btnPulisci: TButton;
    procedure password_origKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure password_checkKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OKBtnClick(Sender: TObject);
    procedure btnCambiaClick(Sender: TObject);
    procedure SezioneClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnPulisciClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmChangePassword: TFrmChangePassword;



implementation

{$R *.dfm}

uses untcommon;

resourcestring
  passwordnomatch = 'ATTENZIONE: Le password devono essere uguali';
  passworderror =   'ATTENZIONE: La password inserita non  valida';
  passwordchanged = 'Password cambiata';
  passwordnotchagne = 'Errore durante il cambio della password';

procedure TFrmChangePassword.btnCambiaClick(Sender: TObject);
begin
  if ChangePassword(password_new.Text,GetSection(Sezione.Text)) then
  begin
    ShowMessage(passwordchanged);
    password_orig.text := '';
    password_new.Text := '';
    password_check.text := '';
    sezione.Text := '';
  end
  else
    ShowMessage(passwordnotchagne);
end;

procedure TFrmChangePassword.btnPulisciClick(Sender: TObject);
begin
  FormShow(nil);
end;

procedure TFrmChangePassword.FormShow(Sender: TObject);
begin
    password_orig.text := '';
    password_new.Text := '';
    password_check.text := '';
    sezione.Text := '';
    lblError.Caption := '';
end;

procedure TFrmChangePassword.OKBtnClick(Sender: TObject);
begin
  close;
end;

procedure TFrmChangePassword.password_checkKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (password_new.Text = password_check.text) and (password_new.text <> '') then
    begin
      btnCambia.Enabled := True;
      lblerror.Caption := '';
    end
    else
    begin
      btnCambia.Enabled := False;
      lblError.Caption := passwordnomatch;
    end;
end;

procedure TFrmChangePassword.password_origKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if password_orig.Text = '' then
    exit;

   if CheckPassword(password_orig.Text,GetSection(Sezione.Text)) then
   begin
     password_new.Enabled := True;
     password_check.Enabled := True;
     lblError.Caption := '';
   end
   else
   begin
     password_new.Enabled := False;
     password_check.Enabled := False;
     lblError.Caption := passworderror;
   end;
end;

procedure TFrmChangePassword.SezioneClick(Sender: TObject);
begin
    password_orig.text := '';
    password_new.Text := '';
    password_check.text := '';
    lblError.Caption := '';
end;

end.
